OpenMPT - Full Version History
------------------------------

- [New]    : new feature
- [Imp]    : improvement
- [Mod]    : change
- [Var]    : other
- [Fix]    : bug fix
- [Reg]    : known issue / regression / feature removal
- (tx XYZ) : thanks to XYZ for telling us about the bug / requesting the feature


Developers:
<initials> nick name  / real name        [email @openmpt.org]
   <al>    Relabs     / Ahti Leppänen    [relabs]
   <ec>    Ericus     / Eric Chavanon    [ericus]
   <jh>    manx       / Jörn Heusipp     [manx]
   <js>    Saga Musix / Johannes Schultz [sagamusix]
   <rf>    rewbs      / Robin Fernandes  [rewbs]
   <sp>    pelya      / Sergiy Pylypenko [pelya]
   <tn>    plastik_s  / Trevor Nunes     [plastik_s]
Patch submitters:
   <cs>    kode54     / Christopher Snowhill
   <da>    Revenant   / Devin Acker
   <ih>    xaimus     / Imran Hameed
   <jb>    JoaoBaptMG / João Baptista de Paula e Silva
   <kk>    SYRiNX     / Keith F. Kelly
   <ks>    coda       / Ken Snyder


Got questions, comments or bug reports? Visit https://openmpt.org/ where you can
find our issue tracker and forums.


v1.30.12.00 (15 April 2023, revision 19028)
-------------------------------------------
Sample tab
- [Fix] <js> Stopping a sample preview could stop unrelated plugin notes.

Instrument tab
- [Fix] <js> Saving ITI files with embedded samples created broken ITI files if the source samples were marked as external (http://forum.openmpt.org/index.php?topic=6957.0).

MOD
- [Imp] <js> VBlank heuristics are now applied to MOD files with M!K! signature. Fixes mod.siedler ii (tx AliceLR).
- [Mod] <js> NoiseTracker MODs are now always played with VBlank timing (tx AliceLR).

Other formats
- [Imp] MED: Add support for default instrument pitch.
- [Mod] 669: Reject files with lots of control characters in song message.
- [Fix] MED: Global play transpose value was not considered for MMD0 files.

Misc
- [Imp] <js> Allow arrow up / down keys and scroll wheel to modify various edit fields in Stream Export and settings dialogs.
- [Imp] <js> Tab order in Plugin Manager was changed to make the plugin list reachable more easily (http://bugs.openmpt.org/view.php?id=1680).
- [Fix] <js> In OpenMPT 1.30.11.00, browsing for all module types showed all 3-letter file extensions in addition to modules (http://bugs.openmpt.org/view.php?id=1678).
- [Fix] <js> Song length detection stopped at first encountered F00 command in XM files instead of looking for further subsongs.

Third-Party Libraries
- [Imp] Update mpg123 (v1.31.3)


v1.30.11.00 (5 March 2023, revision 18811)
------------------------------------------
Tree view
- [Fix] <js> When previewing soundfont or MIDI library items, a click was heard on note-off (http://bugs.openmpt.org/view.php?id=1659).

Pattern tab
- [Imp] <js> Quick Paste only sets the module as modified if the pattern contents were changed.
- [Fix] <js> Don't allow notes or effects not supported by the current module type to be pasted through Quick Cursor Paste.
- [Fix] <js> After seeking with sample sync, the filter settings of playing notes were not updated since OpenMPT 1.30.09.00.
- [Fix] <js> Effect info: XM commands E10 / E20 / EA0 / EB0 now correctly show "continue" for parameter info.

Sample tab
- [Imp] <js> The correct endianness of 16SV IFF sample data is now determined heuristically, to support both IFF files created by some (broken) PC software and files using the correct endianness.
- [Imp] <js> Fix single-cycle loops in some IFF samples.

Instrument tab
- [Fix] <js> If the first notes assigned to a sample in a key map required no transposition but the transposition changed for higher notes, the "Transpose Samples / Reset Map" feature was still available, even though it shouldn't be.
- [Fix] <js> Possible crash when hovering the envelope area of malformed instruments with a set release node but no envelope points (http://bugs.openmpt.org/view.php?id=1672).

Mod Conversion
- [Fix] <js> MOD commands E10 / E20 / EA0 / EB0 are no longer preserved when converting to other formats, as the MOD format applies no effect memory for them.

Playback
- [Fix] <js> The fix for the OPL cutoff bug introduced in OpenMPT 1.30.09.00 was incomplete (http://bugs.openmpt.org/view.php?id=1671).
- [Fix] <js> Avoid potential deadlock when a VST plugin is auto-bypassed due to an exception.
- [Fix] <js> Possible crash when playing instruments with a set release node but no envelope points (http://bugs.openmpt.org/view.php?id=1672).

Other formats
- [Fix] <js> ULT: Offset commands exceeding 65535 samples were sometimes not imported correctly even if there was room for them.

Misc
- [Fix] <js> When saving modules extracted from ZIP files and other archive types, there was no prompt for a new filename, instead overwriting the original archive file.
- [Fix] <js> Song length calculation and seeking in (malformed) modules with thousands of short sub-songs has been sped up.

Third-Party Libraries
- [Imp] Update UnRAR (v6.2.6)


v1.30.10.00 (29 January 2023, revision 18674)
---------------------------------------------
Pattern tab
- [Fix] <js> When jumping around in the module, the tempo was sometimes incorrectly limited to 255 BPM.

Sample tab
- [Fix] <js> Normalizing all samples or removing DC offset from all samples didn't mark external samples as modified (except for the currently selected one).

Instrument tab
- [Fix] <js> Previewing filtered instruments produced a repetitive click sound in OpenMPT 1.30.09.00 (http://bugs.openmpt.org/view.php?id=1655).

Comments tab
- [Fix] <js> The displayed middle-C frequency was slightly off for MOD files.

Mod Conversion
- [Fix] <js> Translation between MOD / XM E5x and MPTM / IT / S3M S2x Set Finetune commands did not take the different scales of the commands into account.
- [Fix] <js> Wrong PAL middle-C frequency was used when converting from MOD to MPTM / IT / S3M.

Playback
- [Fix] <js> Initial instrument cutoff was broken for OPL instruments in OpenMPT 1.30.09.00 (http://bugs.openmpt.org/view.php?id=1657).

Other formats
- [Fix] <js> Loading DSym files was completely broken in OpenMPT 1.30.09.00.

Misc
- [Fix] <jh> After auto-updating from a previous version with no modules open, an empty module was created.

Third-Party Libraries
- [Imp] Update mpg123 (v1.31.2)


v1.30.09.00 (8 January 2023, revision 18451)
--------------------------------------------
Tree view
- [Fix] <js> Instead of playing silence, preview for missing MIDI library soundfont items was falling back to the first instrument in the soundfont.
- [Mod] <js> ZIP files are no longer tried to be resolved as links in the file browser. This may slightly speed up populating the file browser, and should fix a potential crash reported by a user (http://bugs.openmpt.org/view.php?id=1645).

Pattern tab
- [Imp] <js> When recording MIDI pitch bend events, changes are now applied live (http://bugs.openmpt.org/view.php?id=1640).
- [Imp] <js> VU meters now scale better with larger pattern fonts and high-DPI displays.
- [Fix] <js> After removing channels, the pattern cursor sometimes became invisible if the channel it was previously located in no longer existed.

Sample tab
- [Fix] <js> Vertical lines sometimes showed up in zoomed-in waveforms. 
- [Fix] <js> The dragging improvements from OpenMPT 1.30.04.00 are no longer applied to cue points and loop points, as the old behaviour is arguably better-suited there.
- [Fix] <js> Avoid overwriting sample slot when loading an OPL instrument from an S3I file but current format doesn't support OPL.
- [Fix] <js> The forward / backward mouse buttons to navigate to the next / previous sample slot now also work when clicking into the OPL editor.

Instrument tab
- [Fix] <js> Live update of filter settings only worked for running notes if the filter envelope was active.

IT
- [Fix] <js> In sample mode, portamento to a different sample turns off the filter if cutoff / resonance was previously 127 / 0.

S3M
- [Imp] <js> Detect files saved with Graoumf Tracker instead of claiming they were made with OpenMPT 4.47.
- [Fix] <js> Pattern loop state was not propagated anymore since OpenMPT 1.30, leading to wrong song length calculation and SB0 + SBx being located on different channels not working properly anymore (http://bugs.openmpt.org/view.php?id=1641).

Bundled plugins
- [Imp] <js> MIDI I/O Plugin: MIDI Start message is no longer sent when previewing notes in pattern / sample / instrument editors or when pattern stepping is enabled (http://forum.openmpt.org/index.php?topic=6880.0).

Misc
- [Fix] <jh> Update Check: On modern portable amd64 installations, updates for the legacy version were downloaded instead (http://bugs.openmpt.org/view.php?id=1642).

Third-Party Libraries
- [Imp] Update UnRAR (v6.2.3)


v1.30.08.00 (13 November 2022, revision 18159)
----------------------------------------------
Pattern tab
- [Imp] <js> More accurate effect description when combining volume column cue points with regular offset.

Sample tab
- [Fix] <js> Avoid drawing sample waveform from uninitialized memory under some very specific circumstances.

Other formats
- [Fix] <js> MO3: Sample filenames were not imported correctly.

Module cleanup
- [Fix] <js> Automatic Sample Trimmer: Avoid over-trimming samples that are used for MOD-style sample swapping - it is important that the whole sample is preserved in this case even if it is playing completely silently, as the timing of sample swap depends on reaching that sample's end or loop end.

Stream Export
- [Fix] <jh> Little-endian RAW export was broken since OpenMPT 1.30.01.00, exporting big-endian samples instead.

Misc
- [New] <js> Added Play / Stop shortcut (http://bugs.openmpt.org/view.php?id=1619).
- [Imp] <js> Keyboard configuration: If no choices are set, the Restore button now restores all default choices for the given shortcut (http://bugs.openmpt.org/view.php?id=1630).
- [Fix] <js> OPL Export: Pressing the Cancel button didn't abort the conversion process.
- [Fix] <kk & js> Most keyboard shortcuts were not accessible with Microsoft's RDP client for iOS and potentially other virtual keyboards (http://bugs.openmpt.org/view.php?id=1634).

Third-Party Libraries
- [Imp] Update flac (v1.4.2), mpg123 (v1.31.1) and UnRAR (v6.2.2)


v1.30.07.00 (25 September 2022, revision 17944)
-----------------------------------------------
Tree view
- [Imp] <js> Allow ESC to cancel label editing.

Pattern tab
- [Mod] <js> Clarify that a 0 digit means using the previous value in the effect info of vibrato / tremolo / panbrello pattern commands.

Sample tab
- [Imp] <jh> 32-bit FLAC files can now be read.
- [Fix] <js> Inserting or deleting cue points no longer marks external samples as modified.

Instrument tab
- [Fix] <js> SFZ: Don't import one-shot loop type as an actual loop. The only difference to the no_loop type is the note-off behaviour.

VST / DMO Plugins
- [Fix] <js> Previous notes were not stopped properly when a new note was struck and all mix channels were occupied.

Playback
- [Fix] <js> Possible crash when playing manipulated IT / MPTM files with a T00 command.

Other formats
- [Imp] <js> MID: Fall back to just finding suitable soundfont instrument by MSB bank if MSB + LSB search was not successful. This is particularly relevant for SF2 soundfonts as they only support the bank MSB (http://bugs.openmpt.org/view.php?id=1628).
- [Fix] <js> MTM: In MultiTracker, setting speed and tempo are mutually exclusive commands. Still, some MultiTracker modules were made to be played with external players such as DMP, so they actually rely on "standard" speed / tempo behaviour. Decide which behaviour to use by checking of speed and tempo commands are found on the same row (tx AliceLR).
- [Fix] <js> MTM: Ignore sample loops if the loop end is <= 2.

Bundled plugins
- [Fix] <js> Echo DMO: Migrate left and right delay values in modules made with OpenMPT versions between 1.27.01.00 and 1.30.05.00 to the correct interpretation (https://bugs.openmpt.org/view.php?id=1631).

Misc
- [Fix] <js> MIDI Export: Fixed some issues with stuck notes and inconsistent state updates between channels.

Third-Party Libraries
- [Imp] Update flac (v1.4.1)


v1.30.06.00 (21 August 2022, revision 17755)
--------------------------------------------
Tree view
- [Fix] <js> Under some circumstances (e.g. after removing all unused patterns in Song Cleanup and then removing all patterns in a second Song Cleanup), the complete upper tree view could be emptied, eventually leading to a crash (tx eightbitbubsy).
- [Fix] <js> Show BRR files in sample browser (http://bugs.openmpt.org/view.php?id=1617).

Pattern tab
- [Imp] <js> In multi-channel record mode, PC events (both when recorded from plugin or via MIDI mapping) are now distributed to all channels of the current record group (http://bugs.openmpt.org/view.php?id=1622).

Sample tab
- [Fix] <js> Calculate correct selection point after scrolling with an 1:x zoom factor (http://bugs.openmpt.org/view.php?id=1611).
- [Fix] <js> When the crossfade dialog was allowed to be opened because normal loop points were set despite the loop itself not being enabled, it still tried to use the sustain loop points instead, even if they resulted in an empty loop.

VST / DMO Plugins
- [Fix] <js> Don't send All Controllers Off to T-Force Trance Gate 2 plugin, as it also resets some user-configured parameters such as resonance (http://bugs.openmpt.org/view.php?id=1610).

Other formats
- [Fix] <js> DBM: Sample middle-C frequencies were slightly off. laffik_-_marynarze.dbm sounds much more bearable now.
- [Fix] <js> DBM: Fixed pattern break parameter interpretation.

Bundled plugins
- [Fix] <js> Echo DMO: Setting the delay parameter to 0 yielded a 2-second echo delay instead of 1ms.
- [Fix] <js> Digi Booster Echo: Setting the delay parameter to 0 yielded a 510ms echo delay instead of approximately 334ms.

Third-Party Libraries
- [Imp] Update mpg123 (v1.30.2), nlohmann json (v3.11.2) and UnRAR (v6.1.7)


v1.30.05.00 (12 June 2022, revision 17503)
------------------------------------------
Tree view
- [New] <js> Can now (un-)bypass all plugins at once through the tree view, or alternatively just all effect plugins (http://bugs.openmpt.org/view.php?id=1410).

Pattern tab
- [Imp] <js> Allow "Jump to previous / next entry in column" shortcuts to be used together with the selection key. Search is only performed in the current pattern in this case (http://bugs.openmpt.org/view.php?id=1598).
- [Mod] <js> There are now default key bindings for "Jump to previous / next entry in column" (Ctrl + Alt + Up / Down).
- [Fix] <js> When stalling the pattern auto-follow (e.g. while drawing a selection) and transitioning to the next order containing the same pattern again, the order list and pattern editor weren't updated to reflect the new order position (tx NoobTracker).
- [Fix] <js> When the currently selected order item contained the same pattern as the first order item, restarting song playback gave the visual impression that the previously selected order item was still being played instead of the first order item.

Sample tab
- [Fix] <js> Consecutive transposition especially with middle-C frequencies below 8363 Hz could cause a wrong sample rate to be calculated in IT / MPTM.
- [Fix] <js> Displaying extremely long samples with a very low sample rate could cause OpenMPT to hang.

Instrument tab
- [New] <js> Added a new option to the sample map context menu, "Transpose Samples / Reset Map", which - if at all possible - resets the instrument's note mapping to the default and compensates for that by transposing samples instead (http://bugs.openmpt.org/view.php?id=1596).

Mod Conversion
- [Fix] <js> Remove portamento up / down and volume slide commands with parameter 00 when converting from MOD.

Playback
- [Fix] <js> Bidi-looped samples sometimes stopped playing at the end of the loop (http://bugs.openmpt.org/view.php?id=1597).

Installer/release package
- [Mod] <js> Re-mapped some assignments in DE_jojo.mkb to match newly added default shortcuts.


v1.30.04.00 (24 April 2022, revision 17270)
-------------------------------------------
Tree view
- [Imp] <js> Allow plugin instances to be removed through the context menu or pressing the Delete key (http://bugs.openmpt.org/view.php?id=1583).

General tab
- [Imp] <js> Allow plugin instances to be removed with a dedicated button (http://bugs.openmpt.org/view.php?id=1583).

Pattern tab
- [Imp] <js> Parameter Editor: Remember last window position in addition to size (http://bugs.openmpt.org/view.php?id=1579).
- [Fix] <js> Pitch / Pan Separation and Random Variation instrument properties were not resetting properly when seeking, potentially causing instruments to be played e.g. at a vastly different pan position compared to playing the module continuously.

Sample tab
- [Imp] <js> When in instrument mode, slicing at cue points now assigns the sample name to newly added instruments.
- [Mod] <js> Allow broken SBI files created with JuceOPLVSTi to be loaded.
- [Mod] <js> The sample grid is no longer applied to sample drawing.
- [Fix] <js> Drawing sample data with Shift pressed could cause a crash in OpenMPT 1.30.03.00 (http://bugs.openmpt.org/view.php?id=1592).
- [Fix] <js> Dragging improvements from OpenMPT 1.30.03.00 actually made things worse when zooming into a sample (http://bugs.openmpt.org/view.php?id=1581).

Other formats
- [Fix] <js> MED: Stereo samples were not imported correctly.

Misc
- [Fix] <js> Fixed a crash when trying to play song from current pattern if the pattern is not part of the current order list.

Third-Party Libraries
- [Imp] Update zlib (v1.2.12)


v1.30.03.00 (13 March 2022, revision 17105)
-------------------------------------------
Tree view
- [Fix] <js> Avoid playing a sound when double-clicking the folder of a soundfont drum instrument (http://bugs.openmpt.org/view.php?id=1516).

General tab
- [Imp] <js> Plugin dry / wet ratio display is now updated immediately when modified through macros or plugin volume handling (http://bugs.openmpt.org/view.php?id=1463).
- [Fix] <js> The tempo slider position was not set correctly in the MPTM format (tx coda).

Pattern tab
- [Imp] <js> The base octave setting now respects the current instrument's group size where possible (http://bugs.openmpt.org/view.php?id=1568).
- [Imp] <js> Goto Dialog: Limit channel and row spinners to current pattern and module limits (http://bugs.openmpt.org/view.php?id=1575).
- [Mod] <js> Data Entry shortcuts and Ctrl + Scroll Wheel now only affect "special" notes if no regular notes are selected (http://bugs.openmpt.org/view.php?id=1573).
- [Fix] <js> Go To Dialog: Fixed rare crash when module is playing while the jump is being applied (http://bugs.openmpt.org/view.php?id=1578).
- [Fix] <js> Correctly apply shared effect memory when seeking in S3M files.
- [Fix] <js> Apply Command S (S3M / IT / MPTM) effect memory when seeking.

Sample tab
- [Imp] <js> Improve behaviour when dragging a timeline item in the sample editor and the initial grab point wasn't exactly the horizontal position of the item.

Mod Conversion
- [Fix] <js> MOD / XM command EBF conversion was broken in OpenMPT 1.30.02.00.

VST / DMO Plugins
- [Mod] <js> Apply (hidden) auto-suspend setting when new adding plugins to a module, not when creating a plugin instance (which also happens when loading an existing module).
- [Fix] <js> With malformed modules, the LFO plugin could output invalid parameter changes to other plugins, causing a crash depending on how the target plugin handles such invalid parameters.

Playback
- [Fix] <js> Fixed potential crash when using the Amiga BLEP resampler and playing extremely high notes.

Other formats
- [Fix] <js> MO3: Pattern indices 254 / 255 are no longer treated as +++ / --- when the original file was a MOD / XM.

Misc
- [Imp] <js> Apply default channel colors when changing the number of channels via Song Properties.
- [Mod] <js> The active instrument is now remembered more consistently when switching between tabs. This allows to e.g. change to a specific instrument in the pattern editor, then go to the instrument editor and see the same instrument there (as before) and finally go to the sample editor and also see the correct sample there.
- [Mod] <js> MIDI Export: Default to mapped drum export.

Third-Party Libraries
- [Imp] Update flac (v1.3.4), r8brain (v5.6) and UnRAR (v6.1.6)


v1.30.02.00 (30 January 2022, revision 16761)
---------------------------------------------
Tree view
- [Fix] <js> Display of large directories could be rather slow due to trying to resolve links for pretty much any file.
- [Fix] <js> When browsing the contents of a module, the "back" mouse button now behaves the same as the backspace key (it goes back to the directory containing the module).

General tab
- [Imp] <js> Added tooltips to disabled controls explaining why they are disabled.

Pattern tab
- [New] <js> New option "Play whole row when navigating" can be found in the general settings to play the current row when navigating vertically.
- [New] <js> New keyboard shortcut "Toggle row playback when navigating" to toggle aforementioned option without having to visit general settings.
- [Imp] <js> Seeking in the module now updates filter state, plugin dry / wet ratio and plugin parameter changes from MIDI macros (http://bugs.openmpt.org/view.php?id=1497).
- [Imp] <js> Better display of finetune command semantics when there's an instrument number next to the command (http://bugs.openmpt.org/view.php?id=1536).
- [Fix] <js> Note Properties: Switching to / from an extended command broke effect parameter display (http://bugs.openmpt.org/view.php?id=1535).

Sample tab
- [Imp] <js> Added timeline context menu entry to quickly add a cue point if there are any unused cue points (http://forum.openmpt.org/index.php?topic=6767.0).
- [Imp] <js> Added .sam to recognized raw sample extensions (http://bugs.openmpt.org/view.php?id=1546).
- [Imp] <js> When an exising sample already uses the .s3i extension, offer it as the default format to save the sample (http://bugs.openmpt.org/view.php?id=1546).
- [Mod] <js> Allow sustain loops to be edited even if the current format doesn't support them, in case they were imported from another format (http://bugs.openmpt.org/view.php?id=1544).
- [Mod] <js> Newly created samples no longer set the default cue points to multiples of 2048 samples (http://bugs.openmpt.org/view.php?id=1540).
- [Fix] <js> Fixed a crash when hovering sample display of a sample slot that failed to load an external sample.
- [Fix] <js> The sample value shown as percentage in the status bar was displayed as a value between 0 and 1 instead of 0 and 100 as intended.

Mod Conversion
- [Fix] <js> MOD / XM command EBF is now converted to MPTM / IT / S3M command DFE instead of DFF, as the latter slides up, not down.

Playback
- [Mod] <js> The letter "z" is now evaluated in fixed MIDI macros (Z80...ZFF) the same way as in Impulse Tracker.

MPTM
- [Fix] <js> Avoid using NaN or infinite values for tuning when reading corrupted custom tunings.

S3M
- [Fix] <js> Introducing the "Send OPL key-off when triggering notes" compatibility setting broke retrigger for OPL notes again (they retriggered rather than not retriggering).
- [Fix] <js> Retriggering a note no longer resets its pitch after a portamento, just like in IT.
- [Fix] <js> Partially implement retrigger behaviour for stopped notes in SoundBlaster mode: Like in IT, it is not possible to retrigger a sample that has already stopped playing.

MOD
- [Imp] <js> Validate the contents of "hidden" patterns beyond the end of the order list when the file size matches the expected size when only taken "official" patterns into account. This fixes Shofixti Ditty.mod from Star Control 2 while keeping other (partly broken) modules working.
- [Fix] <js> Loosened VBlank timing heuristics so that "frame of mind" by Dascon plays correctly.

Other formats
- [Fix] <js> DIGI: Improve compatibility with E3x reverse sample command.
- [Fix] <js> DSym: Tempos < 32 were treated as tempo slides (http://bugs.openmpt.org/view.php?id=1545).
- [Fix] <js> MED: Command 20 (reverse sample) should only be applied when it's next to a note.
- [Fix] <js> SymMOD: Key-off command was not implemented properly.
- [Fix] <js> Fixed a possible hang when closing a module containing 65536 or more patterns.

Module cleanup
- [Fix] <js> The automatic sample trimmer sometimes calculated incorrect sizes for samples played in reverse and bidi-looped samples (http://bugs.openmpt.org/view.php?id=1547).

Misc
- [Imp] <js> Improved startup time for OpenMPT configurations with many / large soundfonts. 
- [Imp] <js> SF2: Support tuning on the preset level.
- [Imp] <js> Added S3I to default format choice in sample editor settings.
- [Imp] <js> The default artist name can now be set in the Welcome dialog.
- [Mod] <js> When opening files, they are now first tried to be loaded files as modules, and only when that fails they are tried again as an archive. This fixes loading songs using plugins that store their plugin data chunk as a ZIP file (e.g. RetroPlug, http://bugs.openmpt.org/view.php?id=1548).
- [Mod] <js> The VSTNeverUnloadAnyPlugin hidden setting introduced in OpenMPT 1.30.01.00 was moved from the INI category "BrokenPluginWorkarounds" to category "Broken Plugin Workarounds" (same as VSTMaskAllCrashes setting).
- [Fix] <js> When trying to open a malformed file in a new OpenMPT instance and sending this file to an already running OpenMPT instance, the newly launched instance tried to open the file a second time after the other instance gave up, so two error messages were shown.
- [Fix] <js> When passing files to an already running OpenMPT instance, this instance is now moved to the foreground before sending files over, not after. This makes it possible to instantly see error messages in that other instance before it has given control back to the newly launched instance.
- [Fix] <js> The search filter in the compatibility settings dialog was case sensitive.
- [Fix] <js> Fixed a crash when there's an invalid character in a MIDI macro string that wasn't entered by the user in the MIDI macro dialog but was already present in the file.

Bundled plugins
- [Fix] <js> I3DL2Reverb: Fix possible output of NaN values with some extremely impractical set of reverb parameters.

Third-Party Libraries
- [Imp] Update ancient (v2.0.0), nlohmann json (v3.10.5) and UnRAR (v6.1.4)


v1.30.01.00 (23 December 2021, revision 16290)
----------------------------------------------
Tree view
- [Imp] <js> It is now possible to also load instruments from the MIDI library or soundfonts into the sample / instrument tab using Ctrl + (Shift +) Enter (http://bugs.openmpt.org/view.php?id=1491).
- [Imp] <js> It is now possible to extract a complete soundfont drum kit into a single instrument slot by dragging its folder rather than an individual note (tx Keffie).

General tab
- [Imp] <js> Changes to channel properties can now be undone and redone.
- [Imp] <js> Tooltips are shown for channel volume and panning sliders as well as plugin gain.
- [Imp] <js> User-chosen plugin names are now shown in addition to library names in plugin dropdown list.

Pattern tab
- [New] <js> Channels can now be color-coded. In addition to the pattern editor, channel color is also shown and editable in the General Tab, Quick Channel Settings and Channel Manager. Default colors can be changed in Display settings (http://bugs.openmpt.org/view.php?id=1316).
- [New] <js> Pattern Goto Dialog: Can now directly jump to a timestamp.
- [Imp] <js> Quick Channel Settings: Tooltips are shown for volume and panning sliders.
- [Mod] <js> Selecting a non-existing pattern in the order list now no longer keeps displaying the previously edited pattern, to avoid giving the impression that the recently-selected pattern is actually being edited.
- [Mod] <js> Typing in a pattern number into the order list now instantly updates the displayed pattern.
- [Mod] <js> "Dummy" commands are now shown as semi-transparent text.
- [Fix] <js> Fix issues with Data Entry shortcuts on commands that take two nibble parameters (e.g. volume slides).

Sample tab
- [New] <js> Added a timeline which shows sample positions in seconds or samples, and visualizes loop points and cue points, allowing them to be dragged around with the mouse. Press Shift while dragging for finetuning (http://bugs.openmpt.org/view.php?id=659).
- [New] <js> Added option to convert ping-pong loops to unidirectional loops (http://bugs.openmpt.org/view.php?id=1376).
- [New] <js> Resampling can now optionally adjust offset commands in patterns. This does not work properly with offsets affected by the SAx "high offset" command currently.
- [New] <js> Raw sample import can now try to automatically determine the correct raw format. More raw format options are now available, too.
- [New] <js> IFF MAUD samples can now be imported.
- [New] <js> The sample value under mouse cursor is now shown in the status bar.
- [Imp] <js> Cue points can now be deleted by right-clicking their marker in the timeline.
- [Imp] <js> Speed up redrawing of sample waveform when modifying the sample selection or loop points.
- [Imp] <js> Loading or renaming a sample now automatically updates the associated instrument's name too if the instrument previously had the same name as the sample or no name, and if no other samples are assigned to it (http://bugs.openmpt.org/view.php?id=1445).
- [Imp] <js> Time stretch parameter setup is now more usable.
- [Imp] <js> Dropping an item from the tree view with Shift pressed now drops it into a new sample slot.
- [Imp] <js> Added a shortcut for raw sample import.
- [Mod] <js> Opus / Vorbis: Instead of rejecting large samples, they are now trimmed to the maximum supported length and a warning is shown.

Instrument tab
- [Imp] <js> Dropping an item from the tree view with Shift pressed now drops it into a new instrument slot.
- [Imp] <js> Zoom level is now remembered when switching between tabs (http://bugs.openmpt.org/view.php?id=1506).

Mod Conversion
- [Imp] <js> Ping-pong loops are now automatically converted to unidirectional loops when converting to MOD / S3M.
- [Mod] <js> Converting to MPTM no longer asks if the order list should be split into multiple sequences if it contains separator items. This action can still be carried out manually from the order list context menu instead.

VST / DMO Plugins
- [New] <jh> OpenMPT and the default plugin bridge now use Data Execution Prevention by default. For older plugins that are not compatible with DEP, high-entropy ASLR or Large Address Awareness, a legacy plugin bridge is provided, which will be used for all plugins previously added to OpenMPT. Newly added plugins will not use the legacy bridge, unless they are detected to require it or if the user chooses so (http://bugs.openmpt.org/view.php?id=1291, http://bugs.openmpt.org/view.php?id=1402).
- [Imp] <js> Plugin Editor: Added a menu item to rename the plugin instance.
- [Imp] <js> Plugin Editor: Bypass status is now shown in title bar.
- [Mod] <jh> Do not silently ignore crashes in VST plugins any more. A new hidden settings "Broken Plugins Workarounds.VSTMaskAllCrashes" can restore previous behaviour (http://bugs.openmpt.org/view.php?id=1401).
- [Fix] <js> When implementing the Flanger DMO effect, some details in the original effect were overlooked. For modules made with OpenMPT 1.27 - 1.29, a legacy plugin using the old implementation (close to the Chorus DMO) is provided (this does not show up in the Plugin Manager) and used automatically in those modules (http://bugs.openmpt.org/view.php?id=1474).
- [Fix] <js> If an instrument's MIDI program or bank was set to 1, it wasn't transmitted together with the first note playing on that channel, only when a different program or bank was previously chosen on that channel.

Playback
- [Imp] <js> Improved precision of ping-pong loop length particularly for very small samples.
- [Fix] <js> By default, an OPL note-off message is now sent on every note change. Most of the time, there is no audible difference, but this fixes missing notes in ADLIBSP.S3M. The old behaviour is retained through a compatibility flag (http://bugs.openmpt.org/view.php?id=1446).
- [Fix] <js> Samples played at the wrong volume when rendering or playing modules in mono (http://forum.openmpt.org/index.php?topic=6711.0).
- [Fix] <js> Even after OpenMPT 1.29.15.00 the filter reset logic was still not 100% identical to Impulse Tracker: A note triggered on tick 0 of a row with a Pattern Delay effect still caused the filter to be reset on repetitions of that row even though the note wasn't retriggered.

MPTM
- [New] <js> Volume column o00 + effect column Oxx now work together as percentage offset. If parameter extension #xx is used, it increases the granularity of the percentage. SAx does not affect this command combination.
- [New] <js> Volume column oyy + effect column Oxx (yy > 0) now work together as well: The effect column offset is added to the sample cue.
- [New] <js> Two new commands, Finetune (+) and Finetune (Smooth) (*), which double as micro-tuning commands and absolute pitch wheel messages for plugins. They are centered around value 80h, and fractional precision can be extended using an additional # command on the next row. The micro-tuning depth corresponds to the pitch wheel depth of the instrument; 1 semitone is used in sample mode (https://forum.openmpt.org/index.php?topic=6379.0).

MPTM::Custom Tuning
- [New] <js> Added character '*' to drawable letters for built-in fonts.
- [Imp] <js> S2x (Set Finetune) now adjusts the finetune of the note by -8...+7 tuning steps.

IT
- [Imp] <js> Added read-only support for BeRoTracker commands 1 and 2 (equivalent to XM commands K and L, http://bugs.openmpt.org/view.php?id=1528).
- [Fix] <js> Internally, Impulse Tracker always calculates sample playback speed in Hertz instead of periods, even with Linear Slides disabled. Using periods instead can cause small yet audible discrepancies. OpenMPT now also supports frequency instead of periods for Amiga Slides. Fixes "Watching Her Smile" (http://bugs.openmpt.org/view.php?id=1344).
- [Fix] <js> Pitch/Pan Separation was affected by note-off commands, and wasn't reset by panning commands like in Impulse Tracker.

XM
- [Imp] <js> BeRoTracker saves smooth MIDI macros in a different way from OpenMPT. This command is now imported correctly (http://bugs.openmpt.org/view.php?id=1531).
- [Fix] <js> Emulate FT2 Tone Portamento quirk that inverts portamento direction after the target was reached (if target note was higher than previous note).

S3M
- [Imp] <js> S3M files saved with Impulse Tracker and latest Schism Tracker now also compute sample playback speed in Hertz.
- [Imp] <js> Depending on whether an S3M file was last saved in Scream Tracker with the Sound Blaster or Gravis Ultrasound drivers loaded, different compatibility flags are now applied. For files saved with the GUS, the sample volume factor is now also ignored (fixes volume levels in S3Ms made on the GUS, in particular if they use both samples and OPL instruments).
- [Imp] <js> Enforce the lower frequency bound (http://bugs.openmpt.org/view.php?id=961).

MOD
- [New] <js> OpenMPT only supported "TDZ4" to "TDZ9" magic bytes for TakeTracker modules, which should not even exist. Added support for 1 to 3 channel TakeTracker modules used "TDZ1" to "TDZ3" magic bytes.
- [Imp] <js> Allow EFx (Invert Loop) effect to work with 16-bit and stereo samples, which would later be converted to 8-bit mono samples anyway.
- [Fix] <js> Loosened VBlank timing heuristics so that the original copy of Guitar Slinger from Dizzy Tunes II plays correctly.

Other formats
- [New] <da & js> Can now read Symphonie (SymMOD) modules (http://bugs.openmpt.org/view.php?id=672).
- [New] <js> Can now read Digital Symphony (DSym) modules.
- [New] <js> Can now read MUS modules from Psycho Pinball and Micro Machines 2.
- [New] <js> Can now read FMT modules made with Davey W Taylor's FM Tracker.
- [New] <js> Can now read STX modules, a transitional format between STM and S3M (http://bugs.openmpt.org/view.php?id=1521).
- [New] <jh> Modules packed with various legacy compression formats (in particular many more XPK variants) can now be read. All formats supported by the ancient library (https://github.com/temisu/ancient) are supported.
- [Imp] <js> DMF / IMF: Improved accuracy of finetune commands.
- [Imp] <js> MDL: Implemented finetune command.
- [Imp] <js> OKT: Various accuracy improvements such as: Sharing volume between mixed channels, volume commands on mixed channels are permanent (not reset with new notes), mixed channels do not support default sample volume, 7-bit samples are actually supposed to be played as-is (not amplified to full 8-bit range), reject speed command parameters >= 20.
- [Mod] <js> Warn during saving of an imported file when any playback compatibility settings are enabled that are not supported by the current editing format. These settings are disabled automatically.

Stream Export
- [New] <jh> Can now export AU files with µ-law and A-law encoding.
- [Mod] <jh> Default dither is now 1-bit dither with 1st order noise shaping instead of 0.5-bit dither. Although this adds a higher noise floor in the upper part of the spectrum than the old default, the harmonic distortion is reduced, and the signal-to-noise ratio in the lower part of the spectrum is improved. Especially with high samplerates (> 48kHz), this is a clear improvement over the old default, because the added noise floor will be mostly above the audible spectrum.

Audio I/O
- [Mod] <jh> Default dither is now 1-bit dither with 1st order noise shaping instead of 0.5-bit dither.
- [Reg] <jh> Support for DirectSound output was removed.

Misc
- [New] <jh & js> OpenMPT updates can now be downloaded and installed automatically. This is currently not supported on Wine (http://bugs.openmpt.org/view.php?id=1011).
- [New] <jh> OpenMPT is now also available for Windows on ARM.
- [New] <js> Can now export OPL register dump as VGZ/VGM/DRO files (http://bugs.openmpt.org/view.php?id=1488).
- [New] <js> Can now open SF2 soundfonts with compressed samples (commonly referred to as SF3, see https://github.com/FluidSynth/fluidsynth/wiki/SoundFont3Format).
- [New] <js> Added new hidden setting "Misc.UseSingleInstance" (default false) which allows to force OpenMPT to only ever open a single instance (http://bugs.openmpt.org/view.php?id=1429).
- [New] <js> Added a button to Mixer settings to easily revert ramping settings to defaults (tx eightbitbubsy).
- [New] <js> Added a new shortcut to quickly toggle between all lower and upper views (http://bugs.openmpt.org/view.php?id=1367).
- [Imp] <js> Saving samples / instruments and Stream Export now reports if there was a write failure, e.g. due to full disk (http://bugs.openmpt.org/view.php?id=1161).
- [Imp] <js> Keyboard shortcuts can now also be bound to MIDI notes in addition to MIDI CCs (http://bugs.openmpt.org/view.php?id=1396).
- [Imp] <js> Infinite pattern loops are now detected in song length calculation. This also improves seeking accuracy in modules with pattern loops (http://bugs.openmpt.org/view.php?id=1146).
- [Imp] <jh> Register OpenMPT with Restart Manager. This allows the installer to automatically close and restart OpenMPT.
- [Imp] <jh> OpenMPT now reports if loading a module fails due to being out of memory.
- [Mod] <jh> Hidden settings "VST Plugins.FullyUnloadPlugins" is now named "BrokenPluginsWorkarounds.VSTNeverUnloadAnyPlugin" and its meaning inverted. The old setting is migrated automatically.
- [Fix] <js> Fixed possible crash when playing notes via MIDI with lots of active NNA channels (http://bugs.openmpt.org/view.php?id=1514).
- [Reg] <jh> Remove hidden setting "Misc.ShowSettingsOnNewVersion".

Bundled plugins
- [Fix] <js> I3DL2Reverb: Fix possible output of NaN values with some extremely impractical sets of reverb parameters.

Third-Party Libraries
- [Imp] Update PortAudio (v19.7.0), r8brain (v5.3), SoundTouch (v2.3.1) and UnRAR (v6.1.2)

Installer/release package
- [New] <js> Added a new German keymap (Impulse Tracker / OpenMPT crossover) by melcom. Updated coda's key map.
- [New] <jh> OpenMPT is now also available for ARM and ARM64 architectures.
- [Mod] <jh> The installer packages were unified into a single installer that installs all OpenMPT executables supported by the computer's architecture (so on an x86 machine only x86 binaries are installed).  


v1.29.15.00 (5 December 2021, revision 16116)
---------------------------------------------
Tree view
- [Fix] <js> Samples extracted from MTM files through the tree view were corrupted (http://bugs.openmpt.org/view.php?id=1522).
- [Fix] <js> Clicking on folders under soundfont items caused some instrument of that soundfont to be played since OpenMPT 1.29.14.00 (http://bugs.openmpt.org/view.php?id=1516).

Pattern tab
- [Mod] <js> Effect visualizer: Enable PC event mode if the only command in the whole selection is a PC event, even if it is not on the first row (http://forum.openmpt.org/index.php?topic=6738.0).

Sample tab
- [Fix] <js> Switching to an OPL instrument after a zoomed-in sample was shown and not scrolled entirely to the left didn't display the OPL editor correctly.
- [Fix] <js> Show correct dB values for OPL instruments in Default Volume and Global Volume tooltips.

Playback
- [Fix] <js> The logic when to turn off the resonant filter was broken in some edge cases since OpenMPT 1.29.02.00 (http://bugs.openmpt.org/view.php?id=1520).
- [Imp] <js> OPL: Improved channel allocation strategy when there are lots of faded-out notes.

XM
- [Imp] <js> Disable FT2 arpeggio quirks for XMs made with Skale Tracker (fixes KAPTENFL.XM).

S3M
- [Mod] <js> Ignore O00 commands in files created with Scream Tracker 3.00 and 3.01, as this command only gained effect memory in version 3.03.

MOD
- [Fix] <js> Digital Tracker MODs have four unknown bytes right after the magic bytes which seem to be ignored even by Digital Tracker itself. Just skip over them (tx AliceLR).

Other formats
- [Imp] <js> IMF: Implemented XE1-XE3 commands, which disable individual envelopes. Command Nxy (cutoff slide + resonance) is now also partially supported (only resonance for now).
- [Fix] <js> IMF: Filter envelopes were upside down.
- [Fix] <js> MT2: External samples with relative paths pointing to the parent directory (like some MadTracker 2 example songs) didn't load correctly.
- [Fix] <js> STM: Use S3M-like sample swap behaviour.

Module cleanup
- [Fix] <js> Removing unused samples may have removed samples only played by instrument-less notes (tx melcom).

Misc
- [Fix] <js> SF2: Fix stereo samples once again.
- [Fix] <jh> Wine Integration: Some files were missing.

Installer/release package
- [New] <js> All executables and libraries are now signed with a code signing certificate.
- [Fix] <js> Remove legacy key commands from some keymaps, as they showed a warning when loading the keymap (tx melcom).


v1.29.14.00 (14 November 2021, revision 15948)
----------------------------------------------
Tree view
- [Fix] <js> Soundfonts used in the MIDI library sometimes caused unexpected instruments to be loaded due to the ordering of instruments in the soundfont file (e.g. GeneralUser GS). Now OpenMPT always loads the instrument with the lowest bank number (http://forum.openmpt.org/index.php?topic=6727.0).
- [Fix] <js> Soundfont drum instruments with more than 128 regions didn't work correctly (http://forum.openmpt.org/index.php?topic=6727.0).

Pattern tab
- [New] <js> Parameter Editor: Add a new fill option to only change parameters next to notes.
- [Mod] <js> Parameter Editor: Remember last fill action when reopening the editor.

Sample tab
- [Imp] <js> Loading drum samples from soundfonts now translates them to be usable at middle-C rather than at their original mapped key.

Playback
- [Fix] <js> MIDI Macros: When mixing internal and external MIDI messages in the same macro and using a smooth MIDI macro command, the external macros were no longer interpolated correctly.

Other formats
- [Fix] <js> IMF: Change envelope interpretation to be more like in XM instead of IT (sustain point has no precedence over normal loop, and loops are shortened by one tick).
- [Fix] <js> MED: Some samples had a ping-pong loop when there should be no loop at all.
- [Fix] <js> MT2: Ignore incorrect drums chunk size in early MT2 files (fixes e.g. "A little Rock" by Csumi).
- [Fix] <js> MT2: Work around initial master volume of 0 used in some files that apply a fade-in a the song start using track automation that would stay silent forever otherwise (track automation is currently not supported).
- [Fix] <js> Gzip archives: Correctly decode files larger than 4 GB (although it's unlikely that there's anything in there that OpenMPT could read), and reduce memory consumption during decompression.

Misc
- [Fix] SF2: Fix various issues with complex soundfonts such as GeneralUser GS, e.g. missing support for key ranges in presets.

Third-Party Libraries
- [Imp] Update mpg123 (v1.29.2)


v1.29.13.00 (3 October 2021, revision 15754)
--------------------------------------------
Tree view
- [Imp] <js> When browsing song contents, Backspace now goes back to the folder containing the song when in the lower half of the tree view. There is now also a context menu option to close the song (http://bugs.openmpt.org/view.php?id=1498).
- [Fix] <js> Module files are now also shown as directories in lower half of tree view when "Show All Files" is checked.

Pattern tab
- [Imp] <js> Grey out plugin names in channel headers if plugins are disabled on this channel.
- [Imp] <js> Pressing the Application key on the order list now opens the context menu (http://bugs.openmpt.org/view.php?id=1501).
- [Imp] <js> Added shortcuts for opening the channel context menu and channel plugin context menu (http://bugs.openmpt.org/view.php?id=1501).
- [Fix] <js> Seeking with sample sync sometimes didn't compute the correct sample position with pingpong-looped samples.
- [Fix] <js> In the instrument and effect columns, commands assigned to special keys (Num / Caps / Scroll Lock) were executed twice, so e.g. using scroll lock to toggle song follow mode didn't work in these columns.

Sample tab
- [Fix] <js> Switching between samples using keyboard shortcuts now updates the last used sample to use in the pattern and instrument editor just like when using the spin buttons or manually entering a sample number.

Instrument tab
- [Imp] <js> Pressing the Application key on the sample map now opens the context menu (http://bugs.openmpt.org/view.php?id=1501).
- [Fix] <js> Possible crash when releasing a note key that translates to a note above B-9.

Comments tab
- [Imp] <js> Added shortcut to start renaming samples / instruments (default: Ctrl+Enter).
- [Fix] <js> Since OpenMPT 1.29.01.00, it was pretty much impossible to rename instruments due to auditioning (tx Gargaj).

IT
- [Fix] <js> Tremor: Command I11 erroneously behaved like I00 (use previous parameter), unless IT Old Effects were enabled.

Other formats
- [Fix] <js> PTM: Panning was translated wrong in some edge cases.
- [Fix] <js> IMF / PTM: Note Slide commands were sometimes slightly off. 
- [Fix] <js> DBM: Echo enable effect parameter range checks were incorrect.
- [Fix] <js> Possible crash when loading malformed MDL files.

Misc
- [Imp] <js> SFZ: Added support for reading various other *_label opcodes. They are not used for import but if their value contains spaces, it should no longer confuse the parser.
- [Fix] <js> When switching between tabs using keyboard shortcuts, and when switching between samples in the sample editor using keyboard shortcuts, the currently chosen instrument / sample is now updated correctly between pattern / samples / instrument editors (http://forum.openmpt.org/index.php?topic=6675.0).
- [Fix] <js> SF2: Region panning was not calculated correctly.
- [Fix] <js> SF2: Stereo sample merging didn't work for many soundfonts because panning values were stored for each envelope (of which there was one per instrument) rather than for each region.
- [Fix] <js> DLS: The first region of every instrument was not imported in OpenMPT 1.29.12.00 (http://bugs.openmpt.org/view.php?id=1504).
- [Fix] <js> When enabling the Display.HighResUI option, some file selector dialogs could hang (presumably due to a Windows bug) when hovering the file type dropdown on a mixed-DPI monitor setup (http://bugs.openmpt.org/view.php?id=1490).
- [Fix] <js> Key Config Dialog: Avoid bogus "Invalid Slot" message box when receiving MIDI CCs while the "Find Hotkey" input field is focussed.

Third-Party Libraries
- [Imp] Update nlohmann json (v3.10.2), mpg123 (v1.29.0)


v1.29.12.00 (22 August 2021, revision 15545)
--------------------------------------------
Tree view
- [Fix] <js> Drum key names were not displayed for SF2 soundfonts.

Pattern tab
- [Fix] <js> Find & Replace: Fixed various issues with replacing extended commands Sxy / Exy (http://bugs.openmpt.org/view.php?id=1486).

Playback
- [Fix] <js> Possible crash with malformed modules containing an invalid plugin chain or instruments pointing to invalid plugins.
- [Fix] <js> Possible crash after swapping to a sample with loop points set but not loop enabled.

MPTM
- [Fix] <js> Fixed excessive memory usage with files claiming to have an extremely high rows per beat count while also using tempo swing. Maximum rows per beat are now limited to 65536.

Other formats
- [Imp] <js> MIDI Export: Write loopStart and loopEnd cue markers (http://forum.openmpt.org/index.php?topic=6660.0).
- [Imp] <js> MIDI Import: Support loopEnd marker and EMIDI loop start / end CCs. 
- [Fix] <js> STP: Avoid creating thousands of patterns when loading malformed files even though no more pattern data can be read.
- [Fix] <js> MMCMP: Fixed various possible crashes with malformed files.

Misc
- [Mod] <js> Song Properties: Reject 0 rows per beat in modern tempo mode.
- [Imp] <js> DLS / SF2: Support more than 128 regions per instrument (some complex drum programs can exceed the previous limit).
- [Fix] <js> SF2: Extracting drums from drum instruments with a global region didn't work since OpenMPT 1.29.01.00 (http://bugs.openmpt.org/view.php?id=1457).
- [Fix] <js> Avoid crash when attempting to open the Tempo Swing Settings dialog with rows per beat being set to 0.

Third-Party Libraries
- [Imp] Update mpg123 (v1.28.2), UnRAR (v6.0.7)


v1.29.11.00 (4 July 2021, revision 15407)
-----------------------------------------
General tab
- [Imp] <js> When replacing a plugin, keep the plugin chain intact by not clearing its output plugin.

Pattern tab
- [Fix] <js> In OpenMPT 1.29.10.00, it was no longer possible to resume samples on muted channels when seeking with sample sync enabled.
- [Fix] <js> Possible crash when trying to reset a playing channel.
- [Fix] <js> Resetting a channel could mark the module as modified.
- [Fix] <js> Previewing notes could cause clicks if the NNA was set to Note Cut.

Sample tab
- [Imp] <js> For OPL instruments, the actual middle-C note frequency is now shown in a tooltip when hovering the sample rate field.
- [Imp] <js> AIFF: Support reading another variant of 64-bit floating-point and 8-bit unsigned PCM compression types.
- [Mod] <js> AIFF: Ignore invalid sample offset instead of completely rejecting the file. Makes some old (technically malformed) AIFF files load that were previously rejected.
- [Fix] <js> Avoid Windows notification sounds when holding note keys when a widget is focussed in the OPL editor.

Instrument tab
- [Imp] <js> Add more mnemonic shortcuts for various widgets.
- [Fix] <js> Previewing notes could cause clicks if the NNA was set to Note Cut.

S3M
- [Imp] <js> Honor the Stereo flag not being set. This improves the sound of some tunes like Turbulence by Purple Motion.
- [Imp] <js> Detect MPT 1.0 alpha versions which didn't set the Stereo flag. In this case, the unset Stereo flag is also ignored because MPT 1.0 alpha used the default S3M channel panning anyway.
- [Fix] <js> Only for OPL instruments the high sample rate bits should be ignored; for PCM instruments they are clamped to 65535 Hz.

MOD
- [Fix] <js> Do not apply ProTracker loop length quirk to MODs that could have been made with Scream Tracker (fixes Soul-O-Matic by Purple Motion, http://bugs.openmpt.org/view.php?id=1472).

Other formats
- [Imp] <js> AMF (DSMI): Format revisions 1 and 9, as well as early (technically malformed) revision 10 files, are now supported. Surround panning commands and instrument number without note are now converted correctly.
- [Fix] <js> AMF (DSMI): Patterns and samples were not read correctly in some files (e.g. AVOID.AMF).
- [Fix] <js> GDM: Correctly import extra-fine portamentos (http://bugs.openmpt.org/view.php?id=1469).

Misc
- [Imp] <jh> Added shim to support RtAudio v5.0.0 in addition to v5.1.0. This re-adds support for current Ubuntu LTS and Debian systems with Wine Integration.
- [Fix] <js> SF2: Only merge mono layers if they have opposite panning. Previously, e.g. two left-panned layers would have also been merged.

Third-Party Libraries
- [Imp] Update mpg123 (v1.28.0), ogg (v1.3.5), r8brain (v5.2)


v1.29.10.00 (16 May 2021, revision 15016)
-----------------------------------------
General tab
- [Fix] <js> The tempo slider handle was shown in the wrong position for tempos close to 1000 BPM.

Pattern tab
- [Imp] <js> Interpolating the volume column between a cell with a Set Volume command and a cell with no volume command but a note and instrument is now possible (it uses the default volume of that sample for interpolation).
- [Fix] <js> Duplicating / adding / removing a channel, undoing and then redoing it caused the contents of the last channel to be lost (http://bugs.openmpt.org/view.php?id=1442).
- [Fix] <js> "Maintain sample sync on mute" was only enforced after manually muting a channel, and e.g. by restarting playback broke it again (http://bugs.openmpt.org/view.php?id=1125).

Sample tab
- [Imp] <js> Can now resample all samples at once by holding shift when pressing the resample button (http://bugs.openmpt.org/view.php?id=1368).

Instrument tab
- [Fix] <js> Saving an XI instrument from an IT or MPTM module could cause wrong transposition for samples with a middle-C frequency below 8363 Hz (http://bugs.openmpt.org/view.php?id=1449).
- [Fix] <js> Saving an ITI instrument from an XM module converted auto-vibrato sweep incorrectly.

Playback
- [Fix] <jh> In quad surround mode, Bass Expansion incorrectly applied DC removal to the front channels twice instead of applying it once to front and back channels.

MPTM
- [Fix] <js> The "Do not reset OPL channel status at end of envelopes" compatibility flag was effectively force-enabled for all modules made with OpenMPT 1.29, while it should have been disabled.
- [Fix] <js> Files with OPL instruments were sometimes written in a way so that older OpenMPT and libopenmpt versions without OPL support could no longer read certain song properties and warn that the file was created with a more recent version of OpenMPT.
- [Fix] <js> The old OpenMPT 1.28 retrigger behaviour for OPL instruments differed depending on the chosen output sample rate. Retrigger now always retriggers notes as expected, which was already the case when the mix rate was chosen to be 48000 Hz. The corresponding compatibility setting was removed, as it is no longer required. 

IT
- [Imp] <js> Full OpenMPT version information (e.g. 1.29.10.00 instead of 1.29) is now written to IT files also when using compatibility export.

S3M
- [Imp] <js> Emulate IT short sample retrigger quirk in S3M files saved with Impulse Tracker and Schism Tracker.
- [Imp] <js> Full OpenMPT version information (e.g. 1.29.10.00 instead of 1.29) is now written to S3M files.

MOD
- [Fix] <js> Fixed possible crash when sample-swapping to a previously-deleted sample (tx bryc).
- [Fix] <js> ProTracker 3.6 doesn't support sample swapping. It is now disabled when loading a ProTracker 3.6 IFF module.
- [Fix] <js> Some files with "hidden" garbage patterns (e.g. altoflyt.mod) were not played correctly since OpenMPT 1.29.05.00 (http://bugs.openmpt.org/view.php?id=1458).
- [Fix] <js> E9x retrigger now works the same way as in ProTracker 2.

Other formats
- [Mod] <js> 669: Reject files that contain any pattern tempo higher than 15. 
- [Fix] <js> MDL: Improve auto-vibrato accuracy.
- [Fix] <js> In OpenMPT 1.29.09.00, the "Save As" dialog now may have shown up every time after opening a file in an import-only format. Some actions like running the Automatic Sample Trimmer may have also prevented the dialog from showing up. 
- [Fix] <js> Reduce memory consumption of malformed XPK-compressed files.

Stream Export
- [Fix] <jh> Exported 8-bit FLAC output was distorted since OpenMPT 1.29.01.00.
- [Fix] <jh> Do not offer dithering for 64-bit floating-point export.

Audio I/O
- [Mod] <jh> MME / Wave Out output devices are no longer marked as deprecated for now.

Misc
- [New] <js> Added keyboard shortcuts for increasing and decreasing tempo and ticks per row of currently playing module (tx jseb).
- [Fix] <js> Launching OpenMPT could take longer than it should depending on the current working directory, e.g. when opening modules from the task bar's jump list (http://bugs.openmpt.org/view.php?id=1444).
- [Fix] <js> Opening the help didn't open the correct page if the upper half of the view was focussed.
- [Fix] <js> Stop all playing samples when toggling "Compute note frequency in Hertz" compatibility setting.

Third-Party Libraries
- [Imp] Update mpg123 (v1.27.2)


v1.29.09.00 (11 April 2021, revision 14577)
-------------------------------------------
Tree view
- [Fix] <js> Holding a key to preview a sample or instrument in module now works as expected (no more cycling through items / playing "Ding" sound).

Pattern tab
- [New] <js> Added a new keyboard shortcut "Insert Separator" (Ctrl + Insert by default) to the order list which does the same thing as the identically-named context menu entry (http://bugs.openmpt.org/view.php?id=1437).
- [Imp] <js> Support instrument control S7x command when seeking with sample sync.
- [Fix] <js> Possible crash when resuming playback with "Play song from pattern start" combined with "Maintain sample sync on seek" (tx melcom).
- [Fix] <js> Pasting into a non-existent pattern (which would create a new pattern) didn't update the list of existing patterns in the tree view.
- [Fix] <js> Plugin names in instrument list are now updated immediately when renaming a plugin.
- [Fix] <js> Some characters were surrounded by colored frames when using proportional fonts.
- [Fix] <js> Avoid status bar updates (pattern selection size) from playing song while another song is being edited.

Instrument tab
- [Imp] <js> SFZ: Support loopcrossfade as an alias for loop_crossfade.
- [Fix] <js> SFZ: label_keyN values with spaces no longer break the parsing of following opcodes on the same line.
- [Fix] <js> SFZ export: Avoid creating folder names with trailing spaces and dots, as they are difficult to delete or move on Windows.

IT
- [Fix] <js> Instrument / sample panning was reset on note-off / fade commands (http://bugs.openmpt.org/view.php?id=1432).

Other formats
- [Fix] <js> With some imported formats, the "Save As" dialog didn't show up when trying to save them, overwriting the original file instead. 
- [Fix] <js> Possible crash when loading some malformed files.
- [Fix] <js> Fix excessive memory consumption with malformed files in various formats.

Misc
- [Mod] <js> Welcome Dialog: The initial key map suggestion is now used even when not clicking the OK button.
- [Fix] <js> Modifier key state (Ctrl, Alt, Shift, Win) could sometimes get stuck when switching to another application.

Bundled plugins
- [Fix] <js> LFO Plugin: Frequency was not immediately reset when restoring parameters from saved file (http://bugs.openmpt.org/view.php?id=1440).

Third-Party Libraries
- [Imp] Update mpg123 (v1.26.5)


v1.29.08.00 (14 March 2021, revision 14303)
-------------------------------------------
General tab
- [Fix] <js> "Output To" plugin list could contain garbage when a plugin name was edited in another view of the same module.

Pattern tab
- [New] <js> Added keyboard shortcuts for adding and removing channels (http://bugs.openmpt.org/view.php?id=1427).
- [Mod] <js> If the order list is already longer than the format-supported maximum (e.g. because of import from another format), don't shrink the order list anymore when trying to duplicate a pattern.

Sample tab
- [Imp] <js> Splitting a stereo sample into two mono samples wastes less memory.
- [Fix] <js> On some systems, the OPL patch editor caused keyboard shortcuts to stop working (http://bugs.openmpt.org/view.php?id=1382).

Comments tab
- [Fix] <js> When activating the tab, the keyboard focus is set to the text editor (http://bugs.openmpt.org/view.php?id=1365).

S3M
- [Fix] <js> Some samples or OPL patches were imported with a too high sample rate if module was saved with Scream Tracker 3 (http://bugs.openmpt.org/view.php?id=1412).

Other formats
- [Imp] <js> Support loading 64-bit PCM and floating-point WAV files as a module.
- [Fix] <js> Possible crash when loading floating-point WAV file that claimed to have a bit depth of 8 bits or lower as a module.
- [Fix] <js> AMS: Avoid allocating excessive amount of memory for compressed song message in malformed files.

Misc
- [Mod] <js> Only force to rescan MIDI devices after receiving a device change notification from the system. Might fix a crash with buggy MIDI drivers.
- [Fix] <js> Properly resize text labels on main toolbar according to actual font size used (http://forum.openmpt.org/index.php?topic=6569.0).
- [Fix] <js> Some keys were missing when resetting the default keymap (tx isdera).

Third-Party Libraries
- [Imp] Update libvorbis (v1.3.7), UnRAR (v6.0.4)


v1.29.07.00 (31 January 2021, revision 14108)
---------------------------------------------
General tab
- [Imp] <js> Using the spinner, tempo is now incremented and decremented in steps of 1 BPM in all formats. The old behaviour for MPTM - using a 0.1 BPM step size - is now applied when holding Shift (similar to 0.01 BPM steps when holding Ctrl).
- [Mod] <js> "Output To" plugin list now shows user-chosen name first, then library name.
- [Mod] <js> "Output To" plugin list was not updated when a plugin was renamed.
- [Fix] <js> Renaming a plugin could become really slow the more plugins were loaded.

Pattern tab
- [Imp] <js> Update OPL channel state (in particular currently used instrument) when seeking.
- [Fix] <js> Rare crash when trying to interpolate a column without a selection (tx coda).
- [Fix] <js> Selecting a whole row by clicking on its row number didn't copy any channels left of the current scroll position.
- [Fix] <js> MIDI recording erroneously allowed writing smooth MIDI commands with formats that don't support this command.
- [Fix] <js> The Pattern Goto Dialog was not initialized correctly, not using the current pattern and order list location as intended.

Sample tab
- [Imp] <js> Pitch Shift can now also be applied to sample selections.
- [Imp] <js> Autotune no longer marks the module as modified if the frequency didn't change.
- [Imp] <da> Stereo 8SVX files are now supported.
- [Fix] <js> Converting a stereo sample to mono by only taking the right channel caused the first sample from the left channel to remain in the sample, and thus offseting the whole sample by one.
- [Fix] <js> There was a memory leak when aborting a Pitch Shift operation.

VST / DMO Plugins
- [Mod] <js> Removing a plugin from a module now removes all output routings to that plugin slot. Previously, loading a new plugin into the same slot caused other plugins to (unexpectedly) route their output to it.
- [Fix] <js> Dropping a VST plugin file on the OpenMPT window didn't apply plugin bridge default settings like when adding it through the Plugin Manager dialog.

MPTM::Custom Tuning
- [Fix] <jh> Allow editing note name also if a note outside the primary group is selected (http://forum.openmpt.org/index.php?topic=6531.0).

MOD
- [Fix] MOD: The FT2 tremolo quirk is now also applied to MOD files. FT2 just copied the quirky code from ProTracker!

Other formats
- [Imp] <js> DMF: Preserve effects better in some situations where there is more than one effect in a pattern cell.
- [Imp] <js> DMF: Improve import of finetune effect with parameters larger than +/-15.

Misc
- [Imp] <js> Always support inputting '-' as negative sign in numeric input fields, even if the system locale would use a different character.
- [Mod] <js> "Find MPT Hacks" no longer warns about artist name being set in MOD / S3M files, as it cannot be stored in those file types anyway.
- [Fix] <js> A memory leak was possible in some situations when loading a module failed due to insufficient memory being available.
- [Fix] <js> MIDI Export: Possible crash after importing an SF2 instrument (http://bugs.openmpt.org/view.php?id=1399).

Third-Party Libraries
- [Imp] Update mpg123 (v1.26.4), UnRAR (v6.0.3)


v1.29.06.00 (29 November 2020, revision 13926)
----------------------------------------------
General tab
- [Imp] <js> When entering a restart position that points to a non-playable order item, immediately show the corrected value when the input field loses focus.

Other formats
- [Imp] <js> DMF: Support early format beta versions (in particular versions 1-4).
- [Imp] <js> MED: Support MIDI program change and custom MIDI commands.
- [Fix] <js> MED: Also use octave wrapping in 8-channel mode for MMD0/MMD1 modules (http://bugs.openmpt.org/view.php?id=1386).
- [Fix] <js> MED: If 8-channel mode is activated, ignore BPM mode (http://bugs.openmpt.org/view.php?id=1384).
- [Fix] <js> MED: Emulate tempo commands F01 and F02 quirk (http://bugs.openmpt.org/view.php?id=1384).
- [Fix] <js> MED: Tempo commands below 32 BPM were interpreted as tempo slides (http://bugs.openmpt.org/view.php?id=1384).
- [Fix] <js> MED: Do not reject files with no instruments.
- [Fix] <js> MID: Relative RPN changes (in particular coarse tune) were not implemented correctly.
- [Fix] <js> IMF: Instrument sample mapping was off by one octave, notable in the guitar part of Astaris by Karsten Koch.

Misc
- [Imp] <js> When inverting icons in high contrast / dark themes, only invert their brightness but keep the hue.
- [Fix] <js> Since OpenMPT 1.29.01.00, Note Off / Cut / Fade shortcuts were missing in new installations, when resetting keys to defaults or when importing very old OpenMPT keyboard configurations (http://bugs.openmpt.org/view.php?id=1385).
- [Fix] <js> Keyboard configuration: Fixed possible crash when resetting keyboard mapping while a separator item was focussed.
- [Fix] <js> MIDI Export: In "Melodic (any)" mode, exported MIDI channels were inconsistent between notes / tracker events and Zxx macros past channel 10 (http://forum.openmpt.org/index.php?topic=6504.0).

Third-Party Libraries
- [Imp] Update UnRAR (v6.0.2)


v1.29.05.00 (25 October 2020, revision 13771)
---------------------------------------------
Pattern tab
- [New] <js> Added new shortcuts for moving channels (current selection if there is one, edit cursor otherwise, http://forum.openmpt.org/index.php?topic=6480.0).
- [Fix] <js> Disabling song looping didn't really work for anything but the first subsong in a seqeuence. Some related issues when song looping is disabled have also been fixed.
- [Fix] <js> Fixed highlighting of the currently selected pattern in the order list past the maximum supported length of the current format (e.g. when importing from some format that supports more than 128 orders into the MOD format).

Pattern tab::Find/Replace
- [Mod] <js> If a match is found in a pattern that is not part of the current sequence, the active sequence is automatically changed.

Sample tab
- [Fix] <js> More logical cue point moving when removing sample ranges.

Instrument tab
- [Imp] <js> Respect instrument NNA settings when playing notes via MIDI (http://bugs.openmpt.org/view.php?id=1371).

MOD
- [Mod] <js> Increased threshold for considering 8xx as panning commands from 820 to 830.

Other formats
- [Imp] <js> WOW: Fix loading of several files and harden WOW detection (http://bugs.openmpt.org/view.php?id=1380).
- [Fix] <js> STM: Changed tempo computation to behave like Scream Tracker 2.3 instead of Scream Tracker 2.2, as the playback frequencies we use for sample playback are closer to those of Scream Tracker 2.3.
- [Fix] <js> MED: Fix possible hang during load if a MED file claims to contain 256 songs.

Stream Export
- [Fix] <js> Avoid desynchronization between channels when doing per-channel export for S3M files (http://bugs.openmpt.org/view.php?id=1331).

Module cleanup
- [Fix] <js> Allow multiple sequences to be merged even if current song format is not MPTM.

Misc
- [Imp] <js> Improve some icons' visibility in high contrast / dark themes.


v1.29.04.00 (4 October 2020, revision 13649)
--------------------------------------------
Tree view
- [Imp] <js> Use natural sorting for filenames (http://bugs.openmpt.org/view.php?id=1359).

Pattern tab
- [Imp] <js> Added possibility to use %channel_name% in accessibility description format, which contains the channel name in addition to its index (http://forum.openmpt.org/index.php?topic=6480.0).

Sample tab
- [Imp] <js> The start and end point of an existing selection can now be modified by dragging them with the mouse.
- [Mod] <js> WAV / FLAC: When importing cue points and there are less than 9 cue points, remove the default cue points from the sample. On export, cue points past the sample end are no longer written.
- [Fix] <js> Playback position indication did not work when using a pattern-specific playback function (e.g. "play from current pattern") and the module was not playing before that.
- [Fix] <js> Ensure that adjusting sample frequency with the fine spinner always adds or subtracts at least one Hz.
- [Fix] <js> Slicing at cue points lost the first part of the sample if some cue point was 0.
- [Fix] <js> Trimming and resampling didn't adjust cue points accordingly.

Instrument tab
- [Fix] <js> Playback position indication did not work when using a pattern-specific playback function (e.g. "play from current pattern") and the module was not playing before that.

Mod Conversion
- [Fix] <js> Sample frequency to transpose + finetune conversion was wrong if the resulting transpose value was negative.

XM
- [Imp] <js> Support loading and saving (but not editing for now, apart from using the clipboard) command W, which is used e.g. by BASS for syncing purposes.

Other formats
- [Fix] <js> MO3: Avoid certain ModPlug hacks from being fixed up twice, which could lead to e.g. very narrow pan swing range for old OpenMPT IT files saved with a recent MO3 encoder version. 
- [Fix] <js> PLM: Percentage offset (Mxx) was slightly off.

Misc
- [Fix] <js> Channel Manager is no longer redrawn on almost every unrelated UI update.


v1.29.03.00 (30 August 2020, revision 13550)
--------------------------------------------
Tree view
- [Imp] <js> Show hidden files if Windows Explorer is configured to do so. System files are now shown unless they are also hidden, as this is closer to Explorer's behaviour.
- [Fix] <js> Undoing the deletion of a pattern did not update the pattern list correctly (http://bugs.openmpt.org/view.php?id=1357).

Pattern tab
- [Fix] <js> Choosing Pattern Properties from the order list context menu always showed the properties of the currently edited pattern (http://bugs.openmpt.org/view.php?id=1356).
- [Fix] <js> It was not possible to redo the deletion of a pattern (http://bugs.openmpt.org/view.php?id=1357).
- [Fix] <js> Deleting a pattern (or undoing the deletion) did not update the color of that pattern in the order list correctly (http://bugs.openmpt.org/view.php?id=1357).

Sample tab
- [New] <js> Add support for BRR (SNES Bit Rate Reduction) sample format import.

Other formats
- [Imp] <js> MID: Support files with initial negative delta time. This is not valid according to the standard, but such files exist in the wild.
- [Fix] <js> PP20: The first few bytes of some files were not decompressed properly, making some files unplayable (depending on the original format).

Misc
- [Imp] <js> In file dialogs that can open multiple files, it is now possible to open files from different locations (e.g. through search results).
- [Imp] <js> Channel Manager: Middle-clicking a channel now shows the quick channel settings rather than just a dialog to rename.
- [Imp] <js> Channel Manager: Drag & drop now behave more naturally.
- [Fix] <js> Channel Manager: If channels were rearranged but not applied yet, middle-clicking a channel might have renamed the wrong channel.
- [Fix] <js> Some soundfont instruments with many key zones and instrument layers were no longer imported correctly since OpenMPT 1.29.01.00 (http://forum.openmpt.org/index.php?topic=6462.0).

Third-Party Libraries
- [Imp] Update nlohmann json (v3.9.1)


v1.29.02.00 (26 July 2020, revision 13346)
------------------------------------------
Tree view
- [Imp] <js> Hide empty removable drives.
- [Fix] <js> Offline / slow network shares could slow down filling of the drive list, which could also dramatically affect OpenMPT startup time (tx qsrmvt).

General tab
- [Fix] <js> Tempo tap usually broke and wrapped around to 32 BPM after several taps.

Pattern tab
- [Fix] <js> Fix wrong VU meter color at end of AdLib notes.

MPTM
- [Imp] <js> Qxy now retriggers OPL notes if new compatibility flag is set.
- [Fix] <js> Bring back old OPL note end-of-envelope behaviour for files made with OpenMPT 1.28 (http://bugs.openmpt.org/view.php?id=1344).

IT
  [Fix] <js> Global volume slides with both nibbles set preferred the "slide up" nibble over the "slide down" nibble in old OpenMPT versions, unlike other slides. Such old files are now imported correctly again.

IT::Compatible Playback Mode
- [Fix] <js> Fixed an edge case where, if the filter hit full cutoff / no resonance on the first tick of a row where a new delayed note would be triggered, the filter would be disabled even though it should stay active. Fixes trace.it by maddie.

XM
- [Fix] <js> OXM: Some sample loops were not imported correctly (http://bugs.openmpt.org/view.php?id=1329).
- [Fix] <js> Out-of-range arpeggio clamping behaviour broke in OpenMPT 1.23.05.00. The arpeggios in Binary World by Dakota now play correctly again.

S3M
- [Imp] <js> Support old-style sample pre-amp value in very early S3M files.
- [Fix] <js> Only force-enable fast slides for files ST 3.00. Previously, any S3M file made with an ST3 version older than 3.20 enabled them.
- [Fix] <js> Only apply volume and middle-C speed on instrument change if the new sample slot has sample data.

MOD
- [Fix] <js> Fix an infinite loop in GamerMan by MrGamer by playing non-ProTracker MODs more like FT2 would (http://bugs.openmpt.org/view.php?id=1337).

Other formats
- [Imp] <js> M15: Improve tracker detection heuristics to never assume SoundTracker 2.0 if there is a huge number of Dxx commands, as that is a definite hint that they should be treated as volume slides. Fixes Monty On The Run by Master Blaster.
- [Imp] <js> MO3: Support OPL patches in MO3 files created from MPTM and S3M.
- [Imp] <js> DBM: If a global pattern command would be lost because both effect commands in a cell would have to go into the regular effect column (e.g. a speed and a tempo command), the lost command is now attempted to be written into a different cell on the same row. Fixes "Party-Question V" by grogon (http://bugs.openmpt.org/view.php?id=1346).
- [Imp] <js> STM: Try to import ST2 tempo more correctly.

Audio I/O
- [Fix] <jh> Work-around a Windows 10 2004 bug which causes an empty device name to be shown for the Wave Mapper device. Also provide a more useful name in other situations where the name is missing.
- [Imp] <jh> If opening the sound device failed, the name of the device is now shown.
- [Mod] <jh> On new installations, deprecated sound device types are no longer shown.

Misc
- [Imp] <js> OpenMPT now warns if saving a tuning, plugin preset or envelope failed (e.g. because of insufficient storage space, http://bugs.openmpt.org/view.php?id=1161).
- [Fix] <js> OpenMPT could crash when flushing file contents to disk failed (e.g. because disk was full).
- [Fix] <js> DLS: Tuning of drum programs was broken in OpenMPT 1.29.01.00.
- [Fix] <js> SF2: Support negative attenuation in instrument definitions. Region attenuation now adds up to instrument attenuation instead of overriding it (http://bugs.openmpt.org/view.php?id=1336).

Third-Party Libraries
- [Imp] Update nlohmann json (v3.8.0), mpg123 (v1.26.3), opusfile (v0.12) and UnRAR (v5.9.4)

Installer/release package
- [Fix] <jh> Run post-install applications as original user. Otherwise OpenMPT will create its configuration files with elevated privileges on first start.


v1.29.01.00 (24 May 2020, revision 12900)
-----------------------------------------
Tree view
- [New] <js> Can now rearrange sequences through drag & drop.
- [New] <js> Shortcut (.lnk) files to modules, samples and directories are now resolved.
- [New] <js> Allow Forward / Backward mouse buttons to be used for folder navigation in Instrument Library.
- [New] <js> Changing the instrument library directory / module can now also be achieved by editing the library header item (slow double-click).
- [Imp] <js> Can now also import samples and instrument from modules in sample browser using Ctrl + (Shift +) Enter.
- [Imp] <js> Added rename context menu entry in addition to slow double-click.
- [Imp] <js> Duplicating / inserting sequences inserts them next to the selected item. Duplicating a sequence now keeps its original name and adds "(Copy)" to it.
- [Imp] <js> Double-clicking an empty sequence now makes it the current sequence.
- [Fix] <js> Opening a module with external samples in the sample browser broke sample previewing / import for all following modules (http://bugs.openmpt.org/view.php?id=1318). 

General tab
- [Imp] <js> Improved tempo tap button accuracy by using least squares algorithm rather than a simple average. The tempo is now also rounded rather than truncated for formats that do not support fractional tempos.

Pattern tab
- [New] <jb & js> Can now merge a selection of patterns into a single pattern from the order list context menu (http://bugs.openmpt.org/view.php?id=238).
- [New] <jb & js> Can now split a pattern into two patterns from the pattern editor context menu (http://bugs.openmpt.org/view.php?id=238).
- [New] <js> Row insertion and deletion can now also be done globally, affecting all patterns up to the next stop (---) pattern (http://bugs.openmpt.org/view.php?id=639).
- [New] <js> ProTracker- / FastTracker-like shortcuts for cutting, copying and pasting entire channels and patterns to separate clipboards (http://bugs.openmpt.org/view.php?id=424).
- [New] <js> New shortcut "Lose Selection".
- [New] <js> New shortcuts to cycle between sequences.
- [New] <js> Can now split sub songs into multiple sequences from the sequence context menu.
- [New] <js> Tooltips are shown for pattern properties, channel headers and plugin names (http://bugs.openmpt.org/view.php?id=1138).
- [Imp] <js> Moving patterns in the order list now behaves more logically (moving them to the right inserts them to the right of the dragged-on item). To make this change obvious, the insertion point is now displayed with a bold line. The old behaviour can be restored by toggling the hidden setting "Pattern Editor.OrderListOldDropBehaviour" (http://bugs.openmpt.org/view.php?id=1252).
- [Imp] <js> Previous / Next Order shortcuts now ignore skip patterns (+++).
- [Imp] <js> A group of channels can now be assigned to a record group at once by drag-selecting their channel headers (http://bugs.openmpt.org/view.php?id=1314).
- [Imp] <js> Channel aftertouch is now recorded to all active note channels.
- [Imp] <js> Duplicating / inserting sequences inserts them next to the current sequence. Duplicating a sequence now keeps its original name and adds "(Copy)" to it.
- [Imp] <js> Improve live parameter recording performance from non-bridged plugins (http://bugs.openmpt.org/view.php?id=1312).
- [Imp] <js> Order list separator / line color didn't work well if the window background color was dark.
- [Imp] <js> Improved screen reader read-out of order list (http://forum.openmpt.org/index.php?topic=6297.0).
- [Imp] <js> Pattern navigation and data entry now instantly trigger screen reader updates, unless a module is currently playing (http://forum.openmpt.org/index.php?topic=6297.0).
- [Fix] <js> Seeking with sample sync did not follow instruments with custom tuning (http://bugs.openmpt.org/view.php?id=1239). 

Pattern tab::Chord Editor
- [Imp] <js> Clicking a key on the keyboard no longer automatically replaces the last note of the chord, new notes are only added to the chord if there is room for more notes. Instead, existing notes can now be dragged around. 
- [Imp] <js> Can now specify notes up to two octaves below the base note (http://bugs.openmpt.org/view.php?id=1248).
- [Imp] <js> The dialog can now be resized, and hitting the X button no longer saves the modified chords.

Sample tab
- [New] <js> Support little-endian AU / SND files.
- [Imp] <js> Time Stretch can now be applied to sample selections.
- [Imp] <js> Instantly apply result of auto-tuning to playing channels.
- [Imp] <js> Allow resampling ratios greater than 1:512 or 512:1 again with r8brain.
- [Imp] <js> Cross-fading can now also be applied if no loop has been set but a selection has been made. The selection is then automatically set to be the sample loop.
- [Imp] <js> Improve precision of displayed auto-vibrato rate in tooltip.
- [Imp] <js> Speed up initial tab rendering.
- [Fix] <js> Adlib instrument are now always forced to be saved in S3I format, even when WAV or FLAC is selected.
- [Fix] <js> Fix accuracy and consistency of sample grid selection and grid markers with very long samples.
- [Fix] <js> Increased some OPL editor label sizes so that they work better on Wine.

Instrument tab
- [Imp] <js> Added screen reader support to note map (http://forum.openmpt.org/index.php?topic=6297.0).
- [Imp] <js> Envelope navigation and modification now instantly trigger screen reader updates, unless a module is currently playing (http://forum.openmpt.org/index.php?topic=6297.0).
- [Imp] <js> SFZ: Instrument envelopes imported / exported with SFZv2 flexible EGs (http://bugs.openmpt.org/view.php?id=1295).
- [Imp] <js> SFZ: Support for #include, macro redefinition, multiline comments, filter envelope import, synthesized samples, amplitude opcode, fractional finetune values and various other small improvements in both import and export.
- [Imp] <js> SFZ: Change filename of modified samples (loop cross-fade, offset and phase inversion) so that the original files are not modified forever.
- [Fix] <js> SFZ: Exported sample loop length was off by one.
- [Fix] <js> SFZ: Possible hang when importing malformed #define statement.

Comments tab
- [New] <js> Can now audition samples and instruments using regular note entry keys.
- [New] <js> Added shortcuts to switch between sample and instrument lists (Default: Tab) and edit selected item (Enter) (http://forum.openmpt.org/index.php?topic=6274.0).
- [New] <js> Can now copy sample and instrument names (context menu).

VST / DMO Plugins
- [Imp] <js> Resize plugin window appropriately if switching between presets results in a change of the menu bar height.
- [Mod] <js> There are some hybrid VST 2 / 3 plugins using the .vst3 file extension. It is now possible to drag & drop them on OpenMPT and add them through the Plugin Manager. Folder scan does not pick them up for now, as it might result in too many annoying warnings.
- [Mod] <js> A warning is shown when the likely cause for a plugin loading failure is a shortage of Fiber Local Storage indices.
- [Fix] <js> To circumvent a bug in some plugins made with SynthEdit 1.4 versions before February 2020, there is now a hidden setting "VST Plugins.FullyUnloadPlugins" that can be toggled to avoid fully unloading plugins when closing them (http://bugs.openmpt.org/view.php?id=1266). Alternatively, the plugins can also be bridged instead to avoid the crash.

VST::Plugin Bridge
- [Imp] <js> Speed up retrieval of parameter values when saving. 
- [Fix] <js> The stability of bridged plugins has been greatly improved. Most, if not all plugins that did not work previously should run just fine now.

Playback
- [New] <js> In addition to A500 filter settings, the Amiga resampler can now also use A1200 filter settings and unfiltered output (http://bugs.openmpt.org/view.php?id=1276).
- [New] <jh> Added Bit Crush DSP to reduce the bit depth of the final output, e.g. to emulate old hardware or trackers. 
- [Imp] <js> Allow NNA / DNA note-off / note fade to affect OPL notes the same way they affect samples.
- [Mod] <js> Improved OPL channel allocation when more than 18 notes are active, so that channels that have completely faded out are prioritized over channels that have already been released but have not faded out yet.
- [Fix] <js> Previewing an OPL instrument could cause the first pattern channel to no longer be played back correctly (http://bugs.openmpt.org/view.php?id=1323).
- [Fix] <js> Fix some inaccuracies in OPL emulator (original fixes by JP Cimalando).
- [Fix] <js> OPL channels were not affected by "Reset channels on loop" setting.
- [Fix] <js> End-of-sample pop reduction of surround channels was applied to front channels instead, causing a pop on the front channels instead of removing it on the back channels.

MPTM
- [Imp] <js> Raise tempo limit from 512 to 1000 BPM.
- [Imp] <js> When closing a file, a proper dialog is shown for handling modified / missing external samples (http://bugs.openmpt.org/view.php?id=1302).
- [Mod] <js> Sequence names now start at 1 rather than 0.

MPTM::Custom Tuning
- [Imp] <js> Custom tunings can now be used with OPL instruments (http://forum.openmpt.org/index.php?topic=6254.0).
- [Imp] <jh> Custom tuning and sequence names can now contain any Unicode characters.
- [New] <js> Added character '.' to drawable letters for built-in fonts.

IT
- [Mod] <js> Disable retrigger with short notes quirk for modules saved with Chibi Tracker, as it does not implement that quirk.

IT::Compatible Playback Mode
- [Fix] <js> Instrument and sample panning no longer override channel panning for following notes (http://bugs.openmpt.org/view.php?id=1220).
- [Fix] <js> SBx is now prioritized over Bxx commands that are to the left of it. When combining SBx and EEx effects, don't skip the first row of the loop like in FastTracker 2. (http://bugs.openmpt.org/view.php?id=959).
- [Fix] <js> Duplicate Check Type "Sample" should only be applied if the instruments match, too.
- [Fix] <js> Duplicate Check Type "Note" should compare pattern notes, but it was comparing the new pattern note against the old translated note.
- [Fix] <js> Various fixes for envelope resetting.

XM
- [New] <jh> Add support for reading OggMod OXM files (XM with Vorbis-compressed samples).
- [Imp] <js> Raise tempo limit from 512 to 1000 BPM.
- [Mod] <js> If a file contains patterns longer than 1024 rows, they are now clamped to 1024 rows instead of 64 rows.

XM::Compatible Playback Mode
- [Fix] <js> Do not reset note-off status on portamento if there is no instrument number (http://bugs.openmpt.org/view.php?id=1223).

S3M
- [Mod] <js> Support importing empty pattern commands with non-empty parameters. They can still modify the parameter memory, so ignoring them can cause wrong effect parameters to be used.
- [Fix] <js> Offset beyond loop end wraps around to loop start like in Scream Tracker 3 + GUS (previously it just keep playing from the loop start, which is neither what GUS nor Sound Blaster drivers do). If there is no loop, the sample is stopped (consistent with both GUS and Sound Blaster output).
- [Fix] <js> Notes cannot be retriggered after they have been cut.
- [Fix] <js> Previous note offset is no longer used for retriggered notes if there was no instrument number next to the Qxy effect.
- [Fix] <js> Fix portamento after note cut (fixes antediluvian_song.s3m).
- [Fix] <js> Implement sample swapping (with and without portamento) like in Scream Tracker 3 with Sound Blaster driver. This compatibility behaviour is not enabled by default, as OpenMPT mostly follows GUS playback behaviour by default.
- [Fix] <js> When combining SBx and EEx effects, don't skip the first row of the loop like in FastTracker 2. (http://bugs.openmpt.org/view.php?id=959).

MOD
- [Fix] <js> Sample swapping now also works if the sample that is being swapped from does not loop. Swapping to a non-looped sample now stops playback once the swapped-from sample reaches its (loop) end (http://bugs.openmpt.org/view.php?id=1236).
- [Fix] <js> Fix early song ending due to ProTracker pattern jump quirk (EEx + Dxx on same row) if infinite looping is disabled. Fixes Haunted Tracks.mod by Triace.
- [Fix] <js> Previous note offset is no longer used for retriggered notes if there was no instrument number next to the E9x effect.
- [Fix] <js> Vibrato type "ramp down" was upside down.

Other formats
- [Imp] <js> MED: Greatly improved MED import. Synthesized instruments are still not supported but support was added for: Multisampled instruments, delta samples, more pattern commands, Hold and Decay, VSTi and MIDI output, multiple songs and many other small changes (http://bugs.openmpt.org/view.php?id=71).

Audio I/O
- [New] <jh> WASAPI: Provide a default device which automatically follows changes in the default audio device.
- [Imp] <jh> ASIO: Provide 64-bit floating point if supported by the driver.
- [Imp] <jh> ASIO: Support deferred processing. Can be turned off by setting "Sound Settings.AllowDeferredProcessing" to false if it causes trouble. 
- [Mod] <jh> Audio driver crashes are no longer silently masked as they may leave the program in an inconsistent state. The new hidden setting "Sound Settings.MaskDriverCrashes" can be toggled to revert to the old behaviour.
- [Mod] <jh> Deprecated sound devices are no longer shown by default. Use the "Show deprecated devices" checkbox to re-enable them.
- [Mod] <jh> Notify users if they use a deprecated sound device on startup.
- [Reg] <jh> Removed hidden setting "Sound Settings.PreferSameTypeIfDeviceUnavailable". This only really made sense for WASAPI, which did not provide an explicit default device until now. For low-level APIs, falling back to any other device is not really desirable because low-level APIs tend to interfer with normal system audio processing.
- [Reg] <jh> Removed hidden settingss "Sound Settings.MoreRtAudio", "Sound Settings.MorePortAudio" and "Sound Settings.ShowNotRecommendedDeviceWarning".

Misc
- [New] <js> MIDI recording now supports Hold Pedal CC messages (http://bugs.openmpt.org/view.php?id=800).
- [Imp] <js> Use new scaling mode for non-DPI-aware applications on Windows 10 1809 or newer that makes fonts look less blurry on high-DPI displays.
- [Imp] <js> When prompting to save modified samples, also check for files that no longer exist on disk.
- [Imp] <js> SF2: Support instrument-global regions, region-specific sample loops, region tuning (only with a value of 0 for drum programs) and multi-instrument presets (http://bugs.openmpt.org/view.php?id=1320).
- [Imp] <js> Loading sound fonts no longer requires to pre-cache the entire file in memory. This makes it possible to load huge sound fonts even in 32-Bit builds.
- [Imp] <js> Legacy Playback Behaviour dialog is now searchable and resizable (http://bugs.openmpt.org/view.php?id=1285).
- [Imp] <js> MIDI Export: Add option to not export program changes per instrument (http://forum.openmpt.org/index.php?topic=6351.0).
- [Imp] <js> ultrasnd.ini import: Support section-specific PatchDir. If no path is specified, fall back to paths relative to the INI filename rather than the current directory, which we have no control over.
- [Mod] <jh> A portable installation of OpenMPT is now identified by the presence of a file called "OpenMPT.portable" rather than an entry in mptrack.ini. Existing portable installations are migrated accordingly.
- [Mod] <jh & js> mptrack.exe was renamed to OpenMPT.exe. Please update any old custom shortcuts or file associations to point to the new executable. For existing installations, the installer will try to create a symbolic link to keep the old filename working.
- [Fix] <jh> Possible crashes when loading files from network drives on unstable network connections.
- [Fix] <js> Use the default theme-aware font in various parts of the UI which now also scales correctly in high-DPI mode. The new font is different from the previous default (Tahoma) on modern Windows versions so the looks of the program are slightly changed even at 100% scaling.
- [Fix] <js> Icons were broken when using custom UI scaling factors in Windows 10 that didn't result in integer icon sizes and high-DPI mode was enabled.
- [Fix] <js> MIDI Export: Fix note-on / note-off conflict when the same note is triggered on two different pattern channels (http://forum.openmpt.org/index.php?topic=6318.0).
- [Reg] <jh> Maximum polyphony setting was removed. Even the slowest supported CPUs can handle 256 channels. The setting is still available as an advanced setting "Sound Settings.MixChannels" (defaults to 256).
- [Reg] <jh> Pre-SSE2 x86 CPUs are no longer supported. This includes Intel Pentium 3 and older, AMD Athlon XP and older and various other third-party CPUs.
- [Reg] <jh> Support for Windows XP and Windows Vista has been dropped.
- [Reg] <jh> mpg123, SoundTouch and LAME are no longer optional components; without the respective DLL files in the application directory, OpenMPT will no longer start.

Bundled plugins
- [Imp] <js> MIDI I/O Plugin: Allow to enter fractional millisecond latency values.
- [Imp] <js> I3DL2Reverb: Provide plugin presets based on OpenMPT's global reverb presets.

Third-Party Libraries
- [Imp] Update nlohmann json (v3.7.3), mpg123 (v1.26rc3), PortAudio (2020-03-26), r8brain (v4.6), RtAudio (v5.1.0)


v1.28.10.00 (13 April 2020, revision 12628)
-------------------------------------------
Pattern tab
- [Fix] <js> Do not modify existing Parameter Control Events incorrectly when interpolating normal (volume) commands or notes.
- [Fix] <js> Volume column tone portamento commands did not update portamento effect memory when seeking. XM volume column portamento quirks are now handled better when seeking.

Sample tab
- [Fix] <js> When OPL instruments were set up as external samples, changing their parameters didn't mark them as modified.

IT
- [Fix] <js> Vibrato was too fast in Old Effects mode since OpenMPT 1.27 (http://bugs.openmpt.org/view.php?id=1309).

XM
- [Fix] <js> Treat 8bitbubsy's FT2 clone exactly like Fasttracker 2 with respect to compatibility and playback flags. For example, FT2 Pan Law was not applied.

Other formats
- [Fix] <js> DMF: Some files had a wrong tempo since OpenMPT 1.25.02.00 (http://bugs.openmpt.org/view.php?id=1303).

Misc
- [Imp] <js> When changing from modern tempo mode to classic or alternative tempo mode, the initial song tempo is now retained better. 
- [Fix] <js> Potential crash when trying to save a file to a drive that no longer exists.

Third-Party Libraries
- [Imp] Update UnRAR (v5.9.2)


v1.28.09.00 (22 December 2019, revision 12387)
----------------------------------------------
Pattern tab
- [Fix] <js> Chord detect interval was broken if the pattern number didn't match its location in the order list (e.g. pattern 3 at position 3) since OpenMPT 1.28.07.00.
- [Fix] <js> Potential crash when entering notes, in particular if the order list was empty (http://bugs.openmpt.org/view.php?id=1278).
- [Fix] <js> Potential crash when halving a pattern with an odd number of rows and then expanding it again (http://bugs.openmpt.org/view.php?id=1282).

MOD
- [Fix] <js> Fix initial instrument change with no note playing. Fixes first pattern of Beyond Music by Captain (http://bugs.openmpt.org/view.php?id=1275).

Misc
- [Fix] <js> Loading / creating the first OPL instrument while playback was already running didn't start the OPL emulator until the next time playback was restarted.
- [Fix] <jh> Fix compilation of Wine Integration on recent Wine versions (http://bugs.openmpt.org/view.php?id=1263).

Third-Party Libraries
- [Imp] Update UnRAR (v5.8.5)


v1.28.08.00 (27 October 2019, revision 12247)
---------------------------------------------
Playback
- [Mod] <js> Do not apply ramp from initial global volume to current global volume when jumping around in playback.
- [Fix] <js> Possible crash when trying to retrigger an OPL note with active filter.

VST::Plugin Bridge
- [Fix] <js> Bridge process kept hanging around in background if loading or closing plugin failed.

S3M
- [Imp] <js> Import edit timer from files saved with Impulse Tracker.

Other formats
- [Fix] <js> MTM: Sample loop length was off by one.
- [Fix] <js> PSM: Sample loop length was off by one in most files.
- [Fix] <js> ITP: Possible crash with malformed files.

Misc
- [Imp] <js> Small performance improvement when opening / creating new modules or starting playback.

Third-Party Libraries
- [Imp] Update mpg123 (v1.25.13), UnRAR (v5.8.3)


v1.28.07.00 (22 September 2019, revision 12079)
-----------------------------------------------
Pattern tab
- [Imp] <js> If repeating notes on key hold is enabled, the repetitions are now ignored if recording is disabled (key-jazz) or the edit step is set to 0, to avoid ugly and unnecessary repetitions (http://forum.openmpt.org/index.php?topic=6207.0).
- [Imp] <js> The "editing is disabled" prompt can no longer be dismissed by pressing the "E" key and thus re-enabling editing accidentally (http://bugs.openmpt.org/view.php?id=1250).
- [Fix] <js> Chord detect interval didn't work across pattern boundaries (http://bugs.openmpt.org/view.php?id=1246).

Sample tab
- [Imp] <js> Add shortcuts for toggling sample drawing, adding silence and configuring the sample grid.
- [Imp] <js> Add tooltips with keyboard shortcuts for buttons in waveform view (http://bugs.openmpt.org/view.php?id=980).

Instrument tab
- [Imp] <js> Add tooltips with keyboard shortcuts for buttons in envelope view (http://bugs.openmpt.org/view.php?id=980).
- [Fix] <js> Toggling some envelope features through keyboard shortcuts did not update the corresponding button status.

VST / DMO Plugins
- [Fix] <js> MIDI Mapping dialog did not appear when holding Shift key in some plugin editors (e.g. in Synth1 editor when enabling popout sliders).

VST::Plugin Bridge
- [Fix] <js> It was not possible to record parameter changes to the pattern editor (http://bugs.openmpt.org/view.php?id=991).
- [Fix] <js> Receiving MIDI messages from the bridge was broken since v1.27.08.00.
- [Fix] <js> Sending SysEx messages to a 64-bit host or bridge never worked.

Other formats
- [Fix] <js> MID: Possible crash when importing more than one sustain pedal release message following a note-off.
- [Fix] <js> MO3: MIDI program / bank was actually not imported as announced in v1.28.03.00. 

Misc
- [Imp] <js> When adding a sound font fails, an error message is shown.
- [Fix] <js> Possible crash when trying to load huge sound fonts (http://forum.openmpt.org/index.php?topic=6217.0).
- [Fix] <js> SF2: Samples stored past 2 GB into the file couldn't be extracted (http://forum.openmpt.org/index.php?topic=6217.0).

Third-Party Libraries
- [Imp] Update flac (v1.3.3), mpg123 (v1.25.12), ogg (v1.3.4), UnRAR (v5.8.1)


v1.28.06.00 (10 August 2019, revision 11908)
--------------------------------------------
Tree view
- [Imp] <js> When showing folders in the lower panel, going back to the parent folder selects the previously visited folder (http://bugs.openmpt.org/view.php?id=1225).
- [Imp] <js> Scroll to last selected item when refreshing.

Pattern tab
- [Fix] <js> When pasting from IT to MPTM or vice versa, don't convert volume column commands as if they were coming from XM.

Sample tab
- [Fix] <js> Time-stretching a samples with a sample rate higher than 192 kHz crashed OpenMPT (http://bugs.openmpt.org/view.php?id=1234).

Mod Conversion
- [Fix] <js> When converting from IT to MPTM or vice versa, don't convert volume column commands as if they were coming from XM.

IT
- [Imp] <js> Detect IT files unpacked with early UNMO3 versions (http://forum.openmpt.org/index.php?topic=6189.0).

XM
- [Fix] <js> Fix VSTi playback or MIDI export with sample slots whose transpose is not set to C-5.

MOD
- [Imp] <js> Warn when samples beyond sample slot 31 are used.

Third-Party Libraries
- [Imp] Update mpg123 (v1.25.11)


v1.28.05.00 (26 May 2019, revision 11622)
-----------------------------------------
Pattern tab
- [Fix] <js> Seeking with sample sync did not stop notes with XM Key Off (Kxx) effect (http://bugs.openmpt.org/view.php?id=1223).

Mod Conversion
- [Fix] <js> Sequence splitting when converting to MPTM was broken (http://bugs.openmpt.org/view.php?id=1218).

Playback
- [Fix] <js> Possible crash when playing some XM files (introduced in OpenMPT 1.28.01.00).
- [Fix] <js> Breaking out of a sustain loop through Note-Off sometimes didn't continue in the regular sample loop, or not at the correct position.

Misc
- [Imp] <js> Show keyboard shortcuts in various tooltips (http://bugs.openmpt.org/view.php?id=980).
- [Imp] <js> Try to figure out when a USB MIDI device is disconnected and disable the MIDI record button if this device was being used for recording.
- [Imp] <js> In addition to checking for the latest development builds, it is now also possible to receive update notifications for upcoming minor updates.
- [Fix] <js> In High-DPI mode, scale initial size of the upper panel of child windows properly.

Bundled plugins
- [Fix] <js> MIDI I/O Plugin: Do not crash when sending a MIDI message fails (e.g. with Coolsoft Virtual MIDI Synth, http://bugs.openmpt.org/view.php?id=1219).

Third-Party Libraries
- [Imp] Update opus (v1.3.1), RtMidi (4.0.0) and UnRAR (v5.7.5)


v1.28.04.00 (7 April 2019, revision 11528)
------------------------------------------
Tree view
- [Fix] <js> MIDI Library preview did not preview the correct instruments for many soundfonts including GM.DLS.

Sample tab
- [Fix] <jh> FLAC: Tags were imported with incorrect character set.

VST / DMO Plugins
- [Fix] <js> Do not send MIDI volume or set dry / wet ratio on note-off. Old behaviour (this bug has gone unnoticed for more than ten years!) is retained through a compatibility setting that is only available for legacy files (http://forum.openmpt.org/index.php?topic=6115.0).

S3M
- [Mod] <js> Do not allow OPL3 waveforms in S3M files. Existing files with OPL3 waveforms are not affected.

MOD
- [Fix] <js> Sample swapping was always enabled since it has been separated from the ProTracker 1/2 compatibility flag. Now it is always enabled for Amiga-style modules and otherwise the old heuristic is used again (http://bugs.openmpt.org/view.php?id=1199).
- [Fix] <js> Saving 16-bit stereo samples (which should be converted to 8-bit mono) was broken since OpenMPT 1.28.01.00.

Other formats
- [Imp] <js> M15: SoundTracker default tempo is no longer rounded.
- [Fix] <js> MTM: Ignore unused Exy commands on import (http://bugs.openmpt.org/view.php?id=1204).
- [Fix] <js> Startrekker: Clamp speed to 31 ticks per row (http://bugs.openmpt.org/view.php?id=1201).

Audio I/O
- [Fix] <jh> Fix building Wine wrapper when RtAudio or PortAudio is not available (http://bugs.openmpt.org/view.php?id=1210).
- [Fix] <jh> Fix RtAudio configuration for Wine wrapper (http://bugs.openmpt.org/view.php?id=1211).

Misc
- [Mod] <js> On Windows 10, OpenMPT prevented Windows from shutting down even when there were no unsaved files. On Windows Vista and newer, OpenMPT now shows the number of unsaved files when preventing a shutdown.
- [Fix] <js> MIDI Export: Synchronize pitch wheel depth between instruments.
- [Fix] <js> MIDI Export: "Don't export" didn't work as intended when the ignored instrument shared pattern channels with exported instruments.
- [Fix] <jh> Do not disable Reverb if /noAssembly command line switch is passed.

Third-Party Libraries
- [Imp] Update UnRAR (v5.7.4)


v1.28.03.00 (10 February 2019, revision 11351)
----------------------------------------------
Sample tab
- [Fix] <js> When initializing an OPL instrument, the undo state of the sample slot was not updated (http://bugs.openmpt.org/view.php?id=1194).

Instrument tab
- [Fix] <js> Properly render & character in custom note names in note map (http://bugs.openmpt.org/view.php?id=1114).

MPTM
- [Mod] <js> OPL notes can now be controlled (volume / pan / pitch) after they have been released. Note Cut (^^^) now really cuts OPL notes, use === to release them instead. For existing MPTM files, the legacy behaviour is used.
- [Fix] <js> Possible crash when doing a portamento from an OPL instrument to an empty instrument note map slot.

IT::Compatible Playback Mode
- [Fix] <js> Various fixes for note-off + instrument number in Old Effects mode.

S3M
- [Fix] <js> Allow volume of OPL notes to be controlled after note-off (fixes gotoandplay_-_losing_sanctuary.s3m).

Other formats
- [Imp] <js> MO3: Import IT row highlights as written by MO3 2.4.1.2 or newer. Properly import MIDI program and bank info.

Audio I/O
- [Mod] <jh> On Wine on Linux, prefer DirectSound over WaveOut because there are still systems with winealsa.drv where WaveOut occasionally breaks. This change only affects new installations of OpenMPT (http://bugs.openmpt.org/view.php?id=1193).

Misc
- [Fix] <jh> Builds for Windows XP / Vista no longer worked on CPUs without SSE2 support (http://forum.openmpt.org/index.php?topic=6055.0).
- [Fix] <js> MIDI Export: Pitch bend was not reset when two instruments shared a MIDI channel (http://bugs.openmpt.org/view.php?id=1195).

Third-Party Libraries
- [Imp] Update UnRAR (v5.7.1)


v1.28.02.00 (6 January 2019, revision 11185)
--------------------------------------------
Pattern tab
- [Fix] <js> Properly render & character in custom fonts (http://bugs.openmpt.org/view.php?id=1114).

Playback
- [Mod] <js> Improve OPL silent note optimization.

MPTM::Custom Tuning
- [Fix] <js> Tuning Dialog: Properly render & character in note name list (http://bugs.openmpt.org/view.php?id=1114).

Other formats
- [Imp] <js> MO3: Apply playback changes based on "ModPlug-made" header flag.

Audio I/O
- [Fix] <jh> Only clip WASAPI non-exclusive floating-point output on real Windows systems. Wine does not need it.

Misc
- [Fix] <js> Open / Save file dialogs looked strange on some Wine setups (http://bugs.openmpt.org/view.php?id=1181).

Third-Party Libraries
- [Imp] Update nlohmann json (v3.5.0)


v1.28.01.00 (23 December 2018, revision 11100)
----------------------------------------------
Pattern tab
- [Imp] <js> Effect memory is now also used for volume column input.
- [Imp] <js> New shortcut "Show Chord Editor" (http://bugs.openmpt.org/view.php?id=338).
- [Imp] <jh> When using a custom pattern font, all ASCII characters are now usable for rendering custom note names in tunings.
- [Fix] <js> Seeking with sample sync did not work properly when playback was to be resumed on a row that contained an instrument-less note.

Sample tab
- [New] <jh> Add Apple CAF and Sony Wave64 sample import. Only basic uncompressed formats are supported and no detailed instrument or sample metadata is imported for now.
- [New] <js> Can now read SBI (OPL2 instrument) files. 
- [New] <js> Can now write S3I (Scream Tracker 3 instrument) files, mainly intended for saving OPL instruments.
- [Imp] <js> Faster sample normalization.
- [Imp] <jh> Read sample title from AU files.
- [Imp] <jh> WAV files are now written with a CSET chunk to specify the metadata encoding as UTF-8.
- [Imp] <jh> Read ID3 tags in MP3 samples.
- [Imp] <js> Decreased memory consumption during saving of FLAC samples.
- [Mod] <js> Removed mnemonic for "slice sample" context menu entry (http://bugs.openmpt.org/view.php?id=1169).
- [Fix] <jh> FLAC metadata was not encoded correctly as UTF-8.

Instrument tab
- [New] <js> Can now specify the color of the release node section of envelopes.
- [New] <js> SFZ export. Note that many instrument properties do not map cleanly to SFZ features, so this export is quite lossy.
- [New] <js> In the envelope scaling dialog, it is now also possible to add an offset to the y axis.
- [Fix] <js> Importing ITI / XI instruments into IT / XM files did not remove the release node settings.
- [Fix] <js> Fixed possible rare crash that could occur when redrawing the envelope editor (http://bugs.openmpt.org/view.php?id=1175).

Tree view
- [Imp] <js> Show external samples with different icons.
- [Mod] <js> Sample / instrument play status update is now enabled by default on new installations.
- [Fix] <js> Previewing MIDI Library items associated with soundfonts now previews the correct instrument inside that soundfont.

Mod Conversion
- [Mod] <js> Remove E0x commands when converting from MOD / XM to S3M / IT / MPTM.
- [Mod] <js> Convert Note Cut (^^^) to C00 instead of EC0 when converting to MOD / XM.

VST / DMO Plugins
- [Mod] <js> "Pass keys to plugin" is no longer required to be activated when a standard input field is focussed in a plugin GUI to be able to enter texts.

Playback
- [New] <js> MIDI macros now support three new undocumented (but fully supported by Impulse Tracker) characters: h (tracker channel), o (sample offset) and m (sample loop direction).
- [New] <js> MIDI macros now support the non-standard macro character s, which automatically calculates the correct checksum for a GS SysEx message.
- [Imp] <js> MIDI messages FA, FC and FF reset the resonant filter settings for all channels, like in Impulse Tracker.
- [Mod] <js> Amiga resampler is now enabled by default for Amiga modules.
- [Fix] <js> NNA channel allocation did not handle instruments only associated to plugins correctly, causing VSTi NNA channels to be "lost" in many cases (unable to control with S7x).
- [Fix] <js> An instrument release node past the sustain loop end was not processed correctly with "IT-style envelope position advance + enable/disable behaviour" flag enabled (http://bugs.openmpt.org/view.php?id=1171).
- [Fix] <js> Release node volume scaling was not applied properly if an envelope loop started before the release node.

MPTM
- [New] <js> AdLib (OPL) instruments are now supported. Up to 18 simultaneous voices with OPL3-style panning (hard left / center right) and all OPL3 waveforms can be used. 4-operator instruments are not available for now, though.
- [Imp] <js> More logical release node behaviour. The release part is now scaled by the ratio between the value of the key-off point and the release node. The old behaviour is retained through a compatibility flag.
- [Mod] <js> When creating a new MPTM file, a few more sensible IT compatibility flags are now enabled by default to be more consistent with IT.

XM::Compatible Playback Mode
- [Fix] <js> If the sustain point of the panning envelope is reached before key-off, it is never released.
- [Fix] <js> Do not default recall volume / panning for delayed instrument-less notes.

S3M
- [New] <js> AdLib (OPL) instruments are now supported. Compared to Scream Tracker 3, this implementation supports 18 instead of 9 simultaneous OPL voices, OPL3-style panning (hard left / center / right) and the extra OPL3 waveforms are supported as well (http://bugs.openmpt.org/view.php?id=381).
- [Fix] <js> Notes without instrument number use previous note's sample offset.

MOD
- [Imp] <js> Support notes in octave 2, like in FastTracker 2 (fixes DOPE.MOD).
- [Fix] <js> Do not apply Amiga playback heuristics to files that have clearly been written with a PC tracker. Fixes LHS_MI.MOD (tx haspor).

Other formats
- [New] <js> Can now import C67 (CDFM / Composer 670) files.
- [Mod] <js> IMF: Import disabled channels as muted channels.
- [Fix] <js> MID: Running status should only be applied to channel events.
- [Fix] <js> MID: If the MIDI Library contained instruments not mapped to soundfonts, the wrong instruments could sometimes be loaded.
- [Fix] <js> SFX: Work around bad conversions of the "Operation Stealth" soundtrack by turning pattern breaks into note stops (http://bugs.openmpt.org/view.php?id=1170).

Stream Export
- [New] <jh> Add AU export. This allows to export uncompressed PCM audio larger than 2 GB (http://bugs.openmpt.org/view.php?id=766).
- [Imp] <jh> The LAME MP3 encoder is now shipped with OpenMPT (http://bugs.openmpt.org/view.php?id=1095).
- [Reg] <jh> Removed MP3 encoding support via ACM.

Module cleanup
- [New] <js> Can now optimize samples (Edit -> Sample Trimmer) by automatically playing the whole song and recording how much of each sample is played (http://bugs.openmpt.org/view.php?id=554).

Audio I/O
- [Mod] <jh> Modernize default sound device priority list for Wine on non-Linux systems.

Misc
- [New] <js> Can now pass more than one file via command line parameter to open with OpenMPT. Use the /shared parameter to send the files to an existing OpenMPT instance rather than opening a new instance.
- [New] <js> Added menu item and keyboard shortcut to save a copy of a module (http://bugs.openmpt.org/view.php?id=1166).
- [New] <js> MIDI Export: Added option to prevent instruments from overlapping on same MIDI channel for more "classical" MIDI export rather than expecting each track to be sent to its own device / plugin.
- [Imp] <js> MIDI Export: "Melodic (any)" channel mapping now uses up to 15 instead of 8 different channels (all but channel 10).
- [Imp] <js> New shortcut "Toggle Loop Song" (http://bugs.openmpt.org/view.php?id=338).
- [Imp] <js> Settings dialog: Added a possibility to set friendly names for MIDI input devices. For output devices, the settings still have to be edited directly.
- [Imp] <js> OpenMPT now warns if saving a module or MIDI export failed (e.g. because of insufficient storage space, http://bugs.openmpt.org/view.php?id=1161).
- [Imp] <js> On Windows Vista and later, the Places bar in file dialogs now contains links to OpenMPT's default directories.
- [Imp] <js> On Windows Vista and later, the new file dialog style is now also used when audio file preview is enabled.
- [Imp] <jh> Advanced Settings: Use a different background color for settings that have non-default values.
- [Mod] <js> Subsong search is now less thorough, finding less unwanted subsongs in partially played patterns.
- [Mod] <js> Allow compatibility flags to be part of MPTM templates. They are still reset for legacy module types to always enforce maximum compatibility even when opening templates saved with an older OpenMPT version.
- [Mod] <js> When showing a list of missing plugins on startup, offer the user to remove all or some of them (http://bugs.openmpt.org/view.php?id=1153).
- [Mod] <jh & js> Merge lossy and lossless stream export into a single menu entry and keyboard shortcut (http://bugs.openmpt.org/view.php?id=801).
- [Mod] <jh & js> Format various numbers with thousands separators to make them more readable.
- [Mod] <jh> Interpolation filters have been renamed: "XMMS-ModPlug" is now "Sinc", "Polyphase" is now "Sinc with Low-Pass".
- [Mod] <jh> Added possibility to check for updates at each program startup.
- [Mod] <jh> OpenMPT now flushes all file buffers when saving files to minimize data loss in case of an unexpected system crash. As this feature may slow down module saving especially with large modules and samples, it can be disabled through the hidden setting "Misc.FlushFileBuffersOnSave" (http://bugs.openmpt.org/view.php?id=1157).
- [Mod] New shiny icons, splash and about screens by Úlfur Kolka!
- [Fix] <js> When DPI-awareness is enabled, icons are now scaled correctly.
- [Fix] <js> Automatically re-establishing Set Spacing keys after removing another numeric key combination never worked as intended.
- [Fix] <js> OpenMPT no longer uses DDE by default to open files from Explorer, as it could sometimes show a bogus warning message (http://bugs.openmpt.org/view.php?id=1126).
- [Fix] <js> No error message was shown when trying to open a file from the Most Recent Files list that was located on a non-existing drive (http://bugs.openmpt.org/view.php?id=1057).
- [Fix] <js> Update Check: Ignoring a new version did not work.
- [Reg] <js> Remove bandwidth and windowing function selection from mixer configuration. These are often misunderstood by users and changing them can result in reduced resampling quality if one does not fully understand the consequences. They are now hidden settings and reverted back their setting to the default value.
- [Reg] <jh> Wine 1.6 is no longer supported. The minimum required version is Wine 1.8.

Third-Party Libraries
- [Imp] Update opus (v1.3), SoundTouch (v2.1.1) and UnRAR (v5.6.8)


v1.27.11.00 (21 October 2018, revision 10938)
---------------------------------------------
Pattern tab
- [Fix] <js> Amplification with both fade-in and fade-out enabled was broken.
- [Fix] <js> Partially selected channels were sometimes amplified when they should not have been.

Sample tab
- [Fix] <js> Trying to apply an invalid sample rate and then choosing the upsample or downsample option instead caused the wrong sample rate to be chosen for resampling.
- [Fix] <js> Reject resampling ratios greater than or equal to 512 when using r8brain for resampling as they resulted in a crash.

Mod Conversion
- [Mod] <js> When converting to MOD / XM, convert S8x to 8xx instead of E8x, as Fast Tracker does apparently not support E8x.

Playback
- [Fix] <js> Clicks when stopping channels that didn't end at zero volume in 64-bit builds.

XM
- [Fix] <js> Do not import commands N and M as channel volume commands (http://bugs.openmpt.org/view.php?id=1156).

Other formats
- [Fix] <js> MED: Possible crash with malformed files.
 
Misc
- [Imp] <js> Implement horizontal wheel scrolling for pattern / sample / instrument editors. Useful e.g. for pattern navigation with some trackpoint drivers.
- [Fix] <js> Notes triggered from any editor could be played with a panbrello effect if some other channel was previously playing with panbrello.

Third-Party Libraries
- [Imp] Update libopusenc (v0.2.1)


v1.27.10.00 (23 September 2018, revision 10852)
-----------------------------------------------
Pattern tab
- [Fix] <js> With "always center active row" disabled, cancelling a pattern selection by clicking into the pattern did not set the cursor position correctly (http://bugs.openmpt.org/view.php?id=1142).

Sample tab
- [Mod] <jh> Reject overly long MP3 / FLAC / Vorbis / Opus / Media Foundation samples.

Tree view
- [Fix] <jh> Fix crackling, initial missing frames or sometimes even completely in audible instrument preview.

Playback 
- [Fix] <js> The first few frames of previewed notes in the sample, instrument and pattern editors were sometimes cut off (http://bugs.openmpt.org/view.php?id=209).
- [Fix] <js> Jump commands on the same row as the end of a pattern loop covering the restart position of the module could cause the module to loop even when looping was disabled (tx pulsewidth).

Other formats
- [Fix] <js> ITP: Possible crash with malformed files.

Misc
- [Fix] <js> Scrolling with touch gestures (on touch screens and some touchpads) did not scroll the pattern, sample and instrument editor contents (despite changing the scrollbar position) on Windows 8 and later.
- [Fix] <js> When trying to append a module with differing global swing settings, the time signature was not overridden properly.
- [Fix] <js> Advanced Settings: Crash when pressing Enter and there is no value to edit (http://bugs.openmpt.org/view.php?id=1140).
- [Fix] <jh> Some tooltips in the MIDI Mapping Dialog showed incorrect texts.

Third-Party Libraries
- [Imp] Update libopusenc (v0.2), opusfile (v0.11) and UnRAR (v5.6.6)


v1.27.09.00 (28 July 2018, revision 10630)
------------------------------------------
Pattern tab
- [Fix] <js> Mix-pasting multiple patterns including +++ or --- patterns inserted those patterns at the beginning of the orderlist. They are now ignored completely.
- [Fix] <js> Entering a note, then pressing the chord modifier and releasing the key was interpreted as releasing a chord, which could lead to a crash when accessing bogus chord key channels.
- [Fix] <js> Picking up an instrument number higher than the number of usable instruments in the dropdown list was not possible.

Playback
- [Fix] <js> Channels whose volume envelope was playing at volume 0 while being moved to a NNA background channel were cut off completely since OpenMPT 1.27.07.00.

MPTM
- [Fix] <jh & js> Crash with some malformed tunings.

Other formats
- [Fix] <js> AMF (ASYLUM): Convert 7-bit panning to 8-bit panning for playback.

Misc
- [Mod] <jh> The crash handler no longer includes the installation GUID in crash reports as it theoretically allows de-anonymizing update statistics.

Third-Party Libraries
- [Imp] Update UnRAR (v5.6.5)


v1.27.08.00 (19 May 2018, revision 10245)
-----------------------------------------
Pattern tab
- [Imp] <js> Show instrument change shortcuts also in sub menu of context menu.

Sample tab
- [Fix] <js> Convert sample properties when importing samples via Media Foundation codecs (for MOD / XM).

Instrument tab
- [Imp] <js> New shortcuts: Switch to Volume / Panning / Pitch / Filter Envelope, Toggle Volume / Panning / Pitch / Filter Envelope, Toggle Envelope Loop, Toggle Envelope Sustain Loop, Toggle Envelope Carry.
- [Fix] <js> SFZ: Assume UTF-8 encoding for region names.

Tree view
- [Imp] <js> Select next item after deleting a file to prevent scrolling back to top on Wine.

VST::Plugin Bridge
- [Fix] <js> Sending or receiving SysEx messages resulted in a crash.
- [Fix] <js> When automating more than 64 plugin parameters at the same time (also when restoring saved parameters), parameter 0 was reset to a value of 0 (http://forum.openmpt.org/index.php?topic=5967.0).

Playback
- [Fix] <js> The resonant filter was sometimes unstable when combining low-volume samples, low cutoff and high mixing rates.
- [Fix] <js> Switching between instruments with portamento did not update the NNA settings (fixes outcast the third.it, http://bugs.openmpt.org/view.php?id=1122).

Other formats
- [Fix] <js> AMS: Possible crash during load in low memory situations.
- [Fix] <js> FAR: Properly import volume commands.
- [Fix] <js> MID: GS drum channel enable and disable messages were still broken since v1.27.06.00.
- [Fix] <js> STM: Having both Bxx and Cxx commands in a pattern imported the Bxx command incorrectly (fixes ilu.stm).
- [Fix] <js> ULT: Portamento import was sometimes broken.

Third-Party Libraries
- [Imp] Update UnRAR (v5.6.4)


v1.27.07.00 (8 April 2018, revision 10044)
------------------------------------------
Pattern tab
- [Imp] <js> Keep track of active SFx macro during seeking.

Instrument tab
- [Fix] <js> Importing soundfont instruments into IT / XM files did not remove the release node settings.

VST / DMO Plugins
- [Mod] <js> Prepend plugin name to default filename when saving a plugin preset or bank (http://bugs.openmpt.org/view.php?id=1108).

Playback
- [Fix] <js> The "note cut" duplicate note action did not volume-ramp the previously playing sample.

Other formats
- [Imp] <js> DSM: Support restart position and 16-bit samples.
- [Imp] <js> DTM: Import global volume.

Misc
- [Fix] <js> Possible crash when calculating song length in patterns with many nested pattern loops.

Third-Party Libraries
- [Imp] Update libvorbis (v1.3.6) and UnRAR (v5.6.2)


v1.27.06.00 (11 March 2018, revision 9911)
------------------------------------------
General tab
- [Fix] <js> Undoing a change in number of channels did not update the channel count in the General tab.

Sample tab
- [Fix] <js> Shortcuts with Shift key for Normalize and DC Removal no longer clash with the Shift modifier for applying those actions to all samples.
- [Fix] <js> Fix previewing of notes after replacing a sample with an active sample selection by a shorter sample (http://bugs.openmpt.org/view.php?id=1093).

Instrument tab
- [Imp] <js> DLS / SF2 / SFZ: Set release node for volume envelopes in MPTM format.
- [Fix] <js> SFZ: Do not reject files with <curve> sections and import region_label as sample name.
- [Fix] <js> Allow to the first envelope node to be set as the release node.

Tree view
- [Fix] <js> Crash after removing all patterns (http://bugs.openmpt.org/view.php?id=1091).

Playback
- [Fix] <js> Some filter changes through MIDI macros were not applied if the note volume was set to 0 on the same row. 

Other formats
- [Imp] <js> MED: Import "STP" note stop command.
- [Fix] <js> DBM: Key Off and Set Envelope Position were imported incorrectly. High sample offset (E7x) is now supported.
- [Fix] <js> MID: GS drum channel enable and disable messages unconditionally enabled drum channels.

Stream Export
- [Imp] <js> More accurate estimation of export duration for order list selections.
- [Fix] <js> Spin buttons for sequence and order selection export were not enabled correctly.
- [Fix] <js> Correctly estimate song length when the song is played more than once (http://bugs.openmpt.org/view.php?id=1088).

Misc
- [Fix] <jh> Welcome Dialog: FT2 and IT classic keymaps were mixed up.
- [Fix] <js> Bogus error messages were shown when loading the default keymap.
- [Fix] <js> Small memory leak when browsing for folders.
- [Fix] <js> Grey out "Close All" menu item when no documents are open (http://bugs.openmpt.org/view.php?id=1062).

Third-Party Libraries
- [Imp] Update libvorbis (security patches for v1.3.5) and mpg123 (v1.25.10)


v1.27.05.00 (11 February 2018, revision 9643)
---------------------------------------------
Pattern tab
- [Imp] <js> Seeking with sample sync now supports fine volume slides.
- [Mod] <js> Interpolating the note column no longer overwrites existing instrument numbers.
- [Fix] <js> Possible crash when trying to enter notes after deleting all patterns.

Pattern tab::Find/Replace
- [Imp] <js> If no pattern selection is made, pre-fill the Find fields with values from the current pattern cell if they have not been used in a previous search (http://bugs.openmpt.org/view.php?id=1082).
- [Fix] <js> After an unsuccessful search, show the correct search strings when searching for PC events.
- [Fix] <js> When repeating a search for PC events, the previous parameter value was not filled in correctly.
- [Fix] <js> Searching for specific plugin parameter values did not work correctly.
- [Fix] <js> Searching for PC events sometimes found normal events and vice versa.

Sample tab
- [Imp] <js> Add drop-down menu for saving all samples.
- [Fix] <js> Upsampling a sample selection did not scale the new selection correctly if its end exceeded the old sample length (tx Xemogasa).

Instrument tab
- [Imp] <js> Add drop-down menu for saving all instruments.

Comments tab
- [Fix] <js> Soft tabs did not have the correct size most of the time (http://bugs.openmpt.org/view.php?id=1083). 

Tree view
- [Mod] <js> Do not enforce dragged-over items to be completely visible when using drag and drop (tx sincx).
- [Fix] <js> Duplicating or inserting instruments or samples did not refresh the pattern view properly.
- [Fix] <js> Even after removing all patterns, they were still visible.

Other formats
- [Fix] <js> IMF: Filter cutoff was upside down. 
- [Fix] <js> MED: Correctly import patterns with less channels than the maximum used amount (http://bugs.openmpt.org/view.php?id=1036).
- [Fix] <js> STM: More accurate tempo calculation and better support for old format versions.
- [Fix] <js> Possible small memory leaks and crashes with malformed STP files.

Misc
- [Fix] <js> Loading the default keyboard configuration didn't load all default keys since OpenMPT 1.27.01.00, causing issues such as making instrument number entry with the regular number keys impossible.
- [Fix] <js> More accurate song length calculation for pattern loops that have no start command (SB0).


v1.27.04.00 (28 January 2018, revision 9537)
--------------------------------------------
Pattern tab
- [Fix] <js> Shrinking a selection did not work as intended when merging an effect command for the second row of two merged rows.
- [Fix] <js> It was possible to interpolate columns even if pattern editing was disabled. 

Sample tab
- [Imp] <js> When dropping a sample with no filename from another module, copy the module name to the filename field instead.
- [Fix] <js> Dropping a sample from another module did not adjust its parameters to the new module format.
- [Fix] <js> When reading an ITI file as a sample, the middle-C sample was not used as intended in ITIs written with old versions of Schism Tracker.

Instrument tab
- [New] <js> SFZ: Support loop_crossfade opcode for creating crossfaded loops when importing samples.
- [Fix] <js> With extremely long envelopes (>= 46300 ticks), the closest envelope point to the cursor was not computed correctly, leading to some mouse actions not working on the intended envelope node.

MPTM::Custom Tuning
- [Fix] <jh> SCL: Do not replace ISO 8859-1 characters with space when writing the name.

XM
- [Fix] <js> E60 loop bug was not considered in song length calucation.

MOD
- [New] <js> Support MOD files from the Inconexia demo by Iguana.
- [Mod] <jh & js> Tighten M15 and MOD file rejection heuristics.

Other formats
- [Fix] <js> J2B: Ignore frequency limits from file header. Fixes Medivo.j2b, broken since OpenMPT 1.26.
- [Fix] <js> STM: Last character of sample name was missing.

Stream Export
- [Fix] <js> Vorbis: Do not show ABR bitrates that are not supported (http://bugs.openmpt.org/view.php?id=1074).

Misc
- [Fix] <js> The total song length was sometimes estimated as "0mn60s" instead of "1mn00s" or similar.

Bundled plugins
- [Fix] <js> LFO Plugin: Closing the plugin editor while the pattern editor was open could lead to the LFO waveform being changed unintentionally.
- [Fix] <js> ParamEq: Center frequency should be capped at a third of the sampling rate, not half.


v1.27.03.00 (17 December 2017, revision 9370)
---------------------------------------------
General tab
- [Imp] <js> Always ensure that tempo tapping is done with a high-resolution timer. This may improve tapping accuracy if no module is playing.
- [Fix] <js> Restart position spinner was sometimes unavailable after deleting orders (http://bugs.openmpt.org/view.php?id=1056).
- [Fix] <js> Update channel plugin lists when inserting or moving plugins (http://bugs.openmpt.org/view.php?id=1058).

Pattern tab
- [Fix] <js> Effect visualizer: Dropdown lists were not DPI-aware.

Playback
- [Fix] <js> Volume envelopes of previewed notes in pattern or instrument editor were not volume-ramped correctly, causing audible clicks.

IT
- [Fix] <js> Fix broken volume envelopes with negative values as found in breakdwn.it by Elysis.

Stream Export
- [Fix] <jh> RAW encoder was set as the default encoder by mistake since OpenMPT 1.27.01.00.

Misc
- [Fix] <js> Save As dialogs changed the working directory, preventing removable media from being ejected after saving to such drive (http://bugs.openmpt.org/view.php?id=1060).
- [Fix] <js> High-resolution timers were not disabled when playback was stopped, possibly leading to unintentional increased power consumption.
- [Fix] <js> Allow numbers with trailing newlines to be pasted into decimal and signed numer edit fields (http://bugs.openmpt.org/view.php?id=1055).
- [Fix] <js> Example pattern data was not displayed correctly in the manual.
- [Fix] <js> Autosave was broken in OpenMPT 1.27.02.00.

Third-Party Libraries
- [Imp] Update libopusenc (v0.1.1), mpg123 (v1.25.8), ogg (v1.3.3), opusfile (v0.10).


v1.27.02.00 (4 November 2017, revision 9221)
--------------------------------------------
Pattern tab
- [Imp] <js> Provide tooltips for order list items to see their position (e.g. for creating a pattern jump target) and pattern name.
- [Imp] <js> Clipboad Manager is now resizable.
- [Fix] <js> Switching between normal and "extended" effects (Exy/Sxy) could confuse the parameter that was being searched for.

Sample tab
- [Fix] <js> Setting loops through the context menu did not create an undo point.

IT::Compatible Playback Mode
- [Fix] <js> In Compatible Gxx mode, allow sample changes next to a tone portamento effect if a previous sample has already stopped playing (fixes livingston_-_booger_4.it).

MOD
- [Fix] <js> Slides and delayed notes are executed on every repetition of a row with row delay (fixes "ode to protracker", http://bugs.openmpt.org/view.php?id=1053).

Other formats
- [Fix] <js> MID import: Take XG / GS drum channel setup into account for deciding whether to import note-offs.

Stream Export
- [New] <js> Can now choose which sequences to export (http://bugs.openmpt.org/view.php?id=33).
- [Reg] <jh> Remove the rather useless export file size limitation.

Misc
- [Imp] <js> Better support for opening files with very long path names via DDE.
- [Fix] <js> Possible crash when closing a currently playing module with lots of speed changes.
- [Fix] <jh> On Wine, keyboard input was not possible in some dialogs (http://bugs.openmpt.org/view.php?id=1037).

Third-Party Libraries
- [Imp] Update mpg123 (v1.25.7)


v1.27.01.00 (27 September 2017, revision 9000)
----------------------------------------------
General tab
- [Imp] <js> Indicate whether a plugin is bridged (http://bugs.openmpt.org/view.php?id=904).

Pattern tab
- [New] <js> Allow locking playback to a pattern selection through context menu or shortcut (http://forum.openmpt.org/index.php?topic=5720.0).
- [New] <js> Added option "Play notes when transposing" which previews the transposed note if the pattern selection only spans one pattern cell (tx Kab).
- [New] <js> New shortcut "Apply current instrument to existing only". Unlike "Apply current instrument", this does not affect notes without instrument numbers. Can also be found in "Change Instrument" context sub-menu.
- [New] <js> New shortcut "Transpose Custom (Quick)", which applies the previously used custom transpose amount if possible, or shows the transpose dialog otherwise (http://bugs.openmpt.org/view.php?id=947).
- [New] <js> New shortcuts "Jump to previous / next entry in column" can be used to quickly jump to the next non-empty entry in the currently selected note, instrument, etc. column.
- [New] <js> VU meters are now also shown for instrument plugins. Plugin VU meters can have their own colours defined in the Display options (http://forum.openmpt.org/index.php?topic=2006.0).
- [New] <js> Can now fade in from or fade out to arbitrary values other than 0% (http://bugs.openmpt.org/view.php?id=48).
- [New] <js> Pattern Properties: Can now add and remove rows at the beginning of the pattern (http://bugs.openmpt.org/view.php?id=280).
- [New] <js> Pasting multiple patterns without inserting new patterns is now possible when using Mix Paste and Paste Flood. Note: Overflow Paste has to be enabled to continue pasting past the current pattern's end (http://bugs.openmpt.org/view.php?id=812).
- [New] <js> Add "Select Column" which really only just selects the current column. Default: Ctrl+Shift+L.
- [New] <js> Show selection size in status bar.
- [New] <js> Added option to disable follow song on click (http://bugs.openmpt.org/view.php?id=667).
- [New] <js> Hidden setting "Pattern Editor.FontDot" can now be used to replace the empty cell placeholder character in custom pattern fonts (tx daXX).
- [New] <js> An accessibility description of the current pattern cell is now provideded for screen readers. The description format can be customized through the setting "Pattern Editor.AccessibilityFormat".
- [Imp] <js> Seeking with sample sync now also keeps track of pingpong-looped samples.
- [Imp] <js> Overwriting a MIDI macro with a PC event automatically converts the macro parameter.
- [Imp] <js> When configuring a pattern's tempo swing settings, the "Use Global Settings" button can now be used to copy the default swing settings to this pattern.
- [Imp] <js> Seeking now updates the vibrato / tremolo / panbrello position.
- [Imp] <js> Show pattern location of undo / redo action in menu entries.
- [Mod] <js> Rename old "Select Column" to "Select Channel".
- [Mod] <js> "Maintain sample sync on seek" is now enabled by default on new installations. 
- [Fix] <js> Recording MIDI macros over existing PC events resulted in incorrect pattern data.
- [Fix] <js> Various order editing features (e.g. drag & drop) did not always work correctly when extending the sequence past the 256th order item.
- [Fix] <js> When pasting multiple patterns, patterns with names containing a "|" were not pasted correctly.

Sample tab
- [New] <jh & js> Can now import 64-bit PCM WAV and AIFF samples.
- [New] <js> Can now fade in from or fade out to arbitrary levels other than 0% (http://bugs.openmpt.org/view.php?id=48).
- [New] <js> Can now change the stereo width of a sample.
- [New] <js> Show selection length in beats (based on current tempo).
- [Imp] <js> Improved resampling accuracy when using the built-in resamplers.
- [Imp] <js> Directly apply global volume changes to playing channels.
- [Imp] <js> Directly update the sample rate of playing channels after resampling (only IT / MPTM / S3M).
- [Imp] <jh> mpg123 is now shipped with OpenMPT, so MP3 sample import is now supported out of the box on all systems.
- [Imp] <js> Remember previously used values when adding silence or resizing samples (http://bugs.openmpt.org/view.php?id=965).
- [Imp] <js> If not bound to a shortcut, the Application key opens the context menu.
- [Imp] <js> Can now resize sample in milliseconds instead of samples.
- [Imp] <js> Can now display cursor position in hex (http://bugs.openmpt.org/view.php?id=963).
- [Mod] <js> For samples whose path is known, offer this path when saving them rather than a name based on the possibly incomplete filename field.
- [Fix] <js> Small noise bursts when previewing sample or instrument after module was paused (http://bugs.openmpt.org/view.php?id=941). 

Instrument tab
- [New] <js> Undo / Redo for instruments (http://bugs.openmpt.org/view.php?id=126).
- [New] <js> Can now import SFZ instruments. A list of supported opcodes can be found in the manual.
- [New] <js> Allow saving all instruments at once by shift-clicking the save button.
- [New] <js> An accessibility description of the currently selected envelope point is now provideded for screen readers.
- [Imp] <js> Directly apply global volume changes to playing channels.
- [Imp] <js> Indicate whether a plugin is bridged (http://bugs.openmpt.org/view.php?id=904).
- [Imp] <js> If a control is disabled, show in tooltip text why this is the case.
- [Imp] <js> Improve tuning accuracy in PAT instruments.
- [Imp] <js> If not bound to a shortcut, the Application key opens the context menu.
- [Imp] <js> Can now display cursor position in hex (http://bugs.openmpt.org/view.php?id=963).
- [Reg] <js> No longer allow per-instrument resampling to be used in IT and XM files. Legacy modules are not affected.

Comments tab
- [Imp] <js> The Tab key can now be used to insert soft tabs (http://bugs.openmpt.org/view.php?id=148). 
- [Imp] <jh> Use the full available space for the comments text edit control for MPTM and XM files. For IT, limit the displayed width to 75 chars (http://bugs.openmpt.org/view.php?id=148). 
- [Fix] <jh> Do not force raster font and character width for the comment font. This results in unintended bad font rendering, especially on Wine (http://bugs.openmpt.org/view.php?id=873).

Tree view
- [New] <js> New shortcut: Switch to instrument library (and back to module), default: Alt+I
- [New] <js> Ctrl+Shift+Enter loads the selected instrument or sample into an unused slot.
- [New] <js> Can now preview samples and instruments using MIDI input as well. Shortcuts bound to MIDI CCs also work here now.
- [Imp] <jh> Add new hidden option Display.FSUpdateInterval (default 500ms) to rate-limit instrument library updates.
- [Imp] <js> If not bound to a shortcut, the Application key opens the context menu (http://bugs.openmpt.org/view.php?id=964).
- [Imp] <js> Show modules with Amiga-style file extensions (i.e. mod.songname, http://bugs.openmpt.org/view.php?id=640).
- [Imp] <js> Refreshing the instrument browser retains the previously selected file / folder.

VST / DMO Plugins
- [New] <js> Add hidden setting "VST Plugins.EnableMidiMappingInEditor" to no longer open the MIDI Mapper when shift-clicking in plugin editors (http://forum.openmpt.org/index.php?topic=5794.0).
- [Imp] <js> The default DMO effects are now also available on Windows Server and Wine without any additional downloads (http://bugs.openmpt.org/view.php?id=862).
- [Fix] <js> Plugins sharing the same filename no longer cause OpenMPT to rescan them on every startup (http://forum.openmpt.org/index.php?topic=5719.0). Note: OpenMPT will have to rescan all plugins once on first launch of this version.
- [Fix] <js> In some situations, the "Plugin has previously crashed" notification could appear on every startup until a new plugin was eventually registered.

VST::Plugin Bridge
- [Imp] <js> Cache effGetTailSize opcode for improved performance.

Playback
- [New] <js> Added the Amiga Resampler, which emulates how the Amiga's soundchip (Paula) works by means of BLEP synthesis. Can be enabled from the Mixer options only for Amiga-type modules (http://bugs.openmpt.org/view.php?id=803).
- [Imp] <js> Increased accuracy of the sample position and sample rate to drift less when playing very long samples.
- [Imp] <js> All built-in DSPs (Bass Extension, Reverb, Surround) are now also available in 64-bit OpenMPT builds. Disclaimer: These DSPs have a rather low quality and should only be used for legacy projects. Plugins should be used instead to improve the sound of your modules.
- [Imp] <js> Rearranging, adding and removing channels no longer stops active NNA channels.
- [Fix] <js> For very high sample rates (starting at 88 kHz), low filter cutoff frequencies resulted in silent filter output.
- [Fix] <js> There were some tiny differences between portamento commands that were supposed to be identical (e.g. FF2 and FE8).
- [Fix] <js> If the order list was longer than 256 items and there was a pattern break effect without a position jump on the last pattern of the sequence, it did not jump to the correct restart order.

MPTM
- [Fix] <jh> It was not possible to read custom tunings written by OpenMPT 1.17.02.46 to 1.17.02.48 since OpenMPT 1.22.

MPTM::Custom Tuning
- [New] <jh> Added Scala .scl export.
- [Imp] <jh> Cleaned up tuning dialog.
- [Imp] <jh> Show cents in addition to ratios in tuning dialog.
- [Imp] <js> Allow decimal point as specified by the system locale to be used for entering tuning ratios.
- [Mod] <jh> Simplified tuning management. All tunings are now tune-specific tunings (i.e. embedded in MPTM files) - built-in, local and sandbox tunings are gone. Used built-in or local tunings are converted into tune-specific tunings during loading and will be written to the MPTM file when saving. The user is notified when this change is applied. Local tunings are loading from the local_tunings.tc file in this case.
- [Fix] <jh> Scala .scl import was broken (http://forum.openmpt.org/index.php?topic=3717.0).
- [Fix] <jh> Support for loading very early tunings (pre-1.17.02.46).
- [Reg] <jh> Local tunings do not exist anymore. Contents of local_tunings.tc are unpacked to individual tuning files on first start.

IT
- [Fix] <js> Having a vibrato command in both the volume and effect column applies vibrato twice. The volume column depth parameter takes precedence if it is not 0.

IT::Compatible Playback Mode
- [Fix] <js> Do not process auto-vibrato at all if the rate (speed) is 0. Previously, the fade-in (sweep) was still applied and audible with vibrato waveforms other than sine.
- [Fix] <js> A lone instrument number should only reset sample properties to those of the corresponding sample in instrument mode.
- [Fix] <js> Reset portamento when using a lone instrument number to retrigger a stopped note.
- [Fix] <js> If the start row of a pattern loop is past the end of the current pattern (e.g. when continued from a previous pattern due to missing SB0 effect), advance to the next pattern (http://bugs.openmpt.org/view.php?id=913).

XM
- [Fix] <js> Having a vibrato command in both the volume and effect column doubles the vibrato speed. The effect column depth parameter takes precedence if it is not 0.

XM::Compatible Playback Mode
- [Fix] <js> A non-delayed note-off for an instrument with no volume envelope enables fade-out, which can be heard when a volume command is applied afterwards.
- [Fix] <js> Separate portamento up and down effect memory.
- [Fix] <js> Just like in IT / S3M, note delays that are on the same row as a pattern delay retrigger the note on every repetition.
- [Fix] <js> Note-Off + Instrument Number + Retrigger did not fade out the note correctly.
- [Fix] <js> Reset envelope key-off status with instrument number.
- [Fix] <js> Properly emulate FT2's broken "ramp down" tremolo waveform (E71).
- [Fix] <js> More accurate emulation of arpeggio limits to "fix" some arpeggios in dubmood's "Mario Airlines".

S3M
- [Fix] <js> A portamento immediately following an arpeggio continues at the last arpeggiated note.
- [Fix] <js> Do not advance tremolo position on first tick.

MOD
- [New] <js> Added support for MOD command E0x (Set LED filter). Only supported when using the Amiga Resampler.
- [Imp] <js> Update heuristic for disabling panning commands to fix constant_romance.mod by chromag.
- [Fix] <js> Base arpeggio on portamento position rather than initial note (http://bugs.openmpt.org/view.php?id=902).

Other formats
- [New] <da & js> Can now read Soundtracker Pro II (STP) modules (http://bugs.openmpt.org/view.php?id=755).
- [New] <js> Can now read Digital Tracker / Digital Home Studio (DTM) modules.
- [New] <js> Support for synthesized instruments in Startrekker modules. Instrument files must have the same name as the module itself, followed by either ".nt" or ".as".
- [Imp] <js> Greatly improved MIDI import. New features include support for user-definable quantization level, XG and GS drum kits, sustain pedal, loop points, channel / master transpose, type 2 (multi-song) MIDI files, and many others (http://bugs.openmpt.org/view.php?id=124).
- [Imp] <js> Allow samples in DMF, GDM and MDL files to not have a default volume (http://bugs.openmpt.org/view.php?id=850).
- [Imp] <js> Tighten heuristics for rejecting invalid 669 files.
- [Mod] <jh> MO3: mpg123 is now shipped with OpenMPT, so unmo3.dll support has been removed. The internal MO3 decoder is always used.
- [Fix] <js> Possible crash with some valid FAR files.

Stream Export
- [New] <jh> Added raw PCM and floating-point export.
- [Imp] <jh> Opus export is now also possible at sample rates that are not native to the Opus codec. They are automatically resampled.
- [Reg] <jh> Removed long-deprecated BladeEnc and Lame_Enc MP3 encoder support. MP3 export via libmp3lame (openmpt-lame.dll, libmp3lame.dll or similar), as well as MP3 export via ACM codecs (lame_acm, Fraunhofer, or others) is still supported.

Module cleanup
- [Imp] <js> Unused channel removal is now more aggressive and removes any channels that contain no notes, no PC events and no global commands (so a channel that contains only Note Cuts or only portamento commands will be removed).
- [Imp] <js> Rearranging patterns no longer clears the pattern undo.

Audio I/O
- [New] <jh> Experimental direct integration with PulseAudio and ALSA when running OpenMPT through Wine (http://forum.openmpt.org/index.php?topic=5792.0).
- [New] <jh> WASAPI's internal resampler can now be used for arbitrary sample rates. WASAPI is now the default sound device on Windows 7 and later.
- [Mod] <jh> For WASAPI devices, use the high latency provided by PortAudio as the default latency. The low one is way too low.
- [Fix] <jh> Importing sound device settings from OpenMPT 1.22 and older was broken.

Misc
- [New] <js> MIDI Export: Added option to not export an instrument at all (available from the MIDI channel dropdown).
- [New] <js> Added hidden setting "Misc.SaveChannelMuteStatus" (default true), which can be used to avoid channel mute status to be saved in S3M, IT and MPTM files (http://forum.openmpt.org/index.php?topic=5736.0).
- [New] <js> Channel Manager: Channels can be renamed by middle-clicking them (applies instantly).
- [New] <js> "Friendly names" can be set for MIDI input / output ports. By adding a "Device Name=Friendly Name" pair to the [MIDI Input Ports] or [MIDI Output Ports] configuration sections respectively, the real device name gets substituted by the user-supplied name in the user interface (http://bugs.openmpt.org/view.php?id=909).
- [New] <js> MIDI Mapping: Support for 14-bit MIDI controllers. Combinations of CC 0...31 and CC 32...63 are now recognized as double-precision MIDI messages (this feature was advertised in OpenMPT 1.25 as experimental but never worked).
- [New] <js> New shortcut for editing global tempo swing settings (http://bugs.openmpt.org/view.php?id=864).
- [Imp] <jh & js> OpenMPT's file handling is now fully unicode-aware (http://bugs.openmpt.org/view.php?id=164).
- [Imp] <jh> Rather than placing them in the executable directory, LAME DLLs can (and should) now be placed in %APPDATA%\OpenMPT\Components\x86\ for 32-bit builds and %APPDATA%\OpenMPT\Components\x64\ for 64-bit builds respectively to avoid problems with VirtualStore and non-privileged Windows user accounts.
- [Imp] <js> Show the progress of stream and MIDI export in the task bar on Windows 7 and later.
- [Imp] <js> Increase waveform limit in DLS / SF2 files from 16383 to 65535.
- [Imp] <js> Added a great number of user-contributed colour schemes.
- [Imp] <js> Main toolbar and instrument editor grid are now updated more frequently when there are tempo changes (http://bugs.openmpt.org/view.php?id=1025).
- [Imp] <jh> Crash Handler: Added command line option /noCrashHandler which disables ALL custom crash handling.
- [Imp] <jh> Crash Handler: Added command line option /DebugCrashHandler for debugging purposes.
- [Mod] <jh> No longer show the system's crash handler after OpenMPT's own crash report. The old behaviour can be restored by enabling the hidden option Debug.DelegateToWindowsHandler.
- [Mod] <js> In keyboard mapping files, layout-independent scan codes are now stored for note keys, so that notes remain in the correct place regardless whether the current keyboard layout is QWERTY, QWERTZ, AZERTY, Dvorak or anything else. The default key maps are now also layout-independent.
- [Mod] <js> Default shortcuts are now only imported into custom key maps if there is no other shortcut assigned to the same command yet.
- [Mod] <js> MIDI Macro Configuration: Remove checkbox for embedding MIDI macros. They are embedded automatically when required.
- [Fix] <js> Modifying channels outside the channel editor (renaming, moving, etc.) did not update the channel manager instantly.
- [Fix] <js> SF2: Sustain level was not imported.
- [Fix] <js> The "Panic" shortcut never worked (tx isdera).
- [Reg] <jh> The minimum system requirements changed. OpenMPT now requires at least Windows XP or Wine 1.6. Older systems (Windows 98 SE, Windows ME, Windows 2000, as well as Wine 1.0 through 1.5) are no longer supported. OpenMPT 1.27 also drops support for some very old CPUs (http://forum.openmpt.org/index.php?topic=5708).

Bundled plugins
- [New] <js> Added the LFO Plugin, which can automate other plugins' parameters or MIDI CCs.
- [New] <js> MIDI Input / Output Plugin: Added possibility to not send timing information (http://bugs.openmpt.org/view.php?id=982).
- [Imp] <js> MIDI Input / Output Plugin: It is now possible to specify a custom output latency. This value can also be negative, up to the duration of OpenMPT's own output latency.
- [Fix] <js> MIDI Input / Output Plugin: Sporadic freezes and crashes (http://bugs.openmpt.org/view.php?id=843).
- [Fix] <js> DigiBooster Pro Echo DSP did not empty its delay lines when jumping around in the module.

Third-Party Libraries
- [Imp] Update opus (v1.2.1), SoundTouch (v2.0), UnRAR (v5.5.8).

Installer/release package
- [New] A new Cyrillic key map provided by Fler0301, a UK keymap resembling the Impulse Tracker shortcuts by chocosaurus, and updated Norwegian keymap by Rakib and US keymap by LPChip.


v1.26.14.00 (14 August 2017, revision 8772)
-------------------------------------------
Pattern tab
- [Fix] <js> Changing the octave of notes below middle-C was broken in OpenMPT 1.26.13.00.
- [Fix] <js> Resizing a pattern did not properly redraw the row numbers in other pattern windows.


v1.26.13.00 (12 August 2017, revision 8759)
-------------------------------------------
Pattern tab
- [New] <jh> Add hidden setting "Pattern Editor.AlwaysDrawWholePatternOnScrollSlow" for graphics drivers with scrolling issues (http://bugs.openmpt.org/view.php?id=1003).
- [Imp] <js> Increasing / decreasing an order list item now skips non-existing patterns.
- [Fix] <js> Crash when trying to change the octave of a note associated with a general tuning (http://bugs.openmpt.org/view.php?id=1004).
- [Fix] <js> Changing the octave did not work as intended with all tuning group sizes.
- [Fix] <js> Amplification now works correctly for plugin-based instruments with a global volume other than 64 (http://bugs.openmpt.org/view.php?id=1002).
- [Fix] <js> Properly erase playback position marker in order list after right-clicking another order item.

Sample tab
- [Fix] <jh> Possible crash when loading too big Vorbis or Opus samples.
- [Fix] <js> Editing various sample properties did not create an undo point.

Instrument tab
- [New] <js> Envelope points can now also be inserted by double-clicking.
- [Imp] <js> Can now use Home / End keys for sample map navigation (http://bugs.openmpt.org/view.php?id=984).
- [Fix] <js> Drag & Dropping a soundfont instrument did not update the sample editor for replaced samples.
- [Fix] <js> Possible crash with some keyboard shortcuts if there was no envelope (tx Jiyoshi).

Tree view
- [Mod] <js> Switching to another module or updating the module's sample volume now updates sample preview volume on every note, not just when previewing a new sample or instrument.

Mod Conversion
- [Fix] <js> Converting to MOD could crash if the first order list item was not a valid pattern (http://bugs.openmpt.org/view.php?id=996).
- [Fix] <js> Removing unsupported patterns (+++ / --- in MOD / XM) did not work as intended at all.

VST / DMO Plugins
- [Fix] <js> Mark module as modified if renaming a preset through the plugin editor was successful.

VST::Plugin Bridge
- [Imp] <js> Speed up filling of parameter lists.

Playback
- [Fix] <js> Loops shorter than four sample points at the end of a sample could cause the sample data before the loop to become corrupted.

MPTM::Custom Tuning
- [Fix] <js> Transpositions in the instrument note map were not applied correctly when the "Use triggered note rather than translated note for PPS and DNA note check" compatibility setting was enabled.
- [Fix] <jh> Saving single tuning .tun files actually resulted in a tuning collection being saved, which prevented the tuning from being loaded unless its file extension was changed to .tc.
- [Fix] <jh> Prevent changing the type of an existing tuning to General.

MOD
- [Fix] <js> The ProTracker note delay quirk should not retrigger already stopped samples (fixes "Subi loses the Cops" by Subi, tx h0ffman).
- [Fix] <js> Portamento between already stopped sample and another sample kept playing the old sample (fixes "anarchy-main" by Jester).
- [Fix] <js> ProTracker quirk: If there is a note with an out-of-range note delay, it is played on the next row (with an instant portamento), unless there is a new note on that row.
- [Fix] <js> ProTracker quirk: Apply tempo changes after the first tick of the row.

Other formats
- [Fix] <js> Possible crashes with malformed PLM and PSM files.


v1.26.12.00 (2 July 2017, revision 8412)
----------------------------------------
General tab
- [Fix] <js> Cloning effect plugins no longer creates an instrument for them (http://bugs.openmpt.org/view.php?id=970).

Pattern tab
- [Imp] <js> Right-clicking outside of the pattern shows a context menu for adding more channels.
- [Fix] <js> It was possible to use (but not save) l / r / u volume commands in MPTM and e / f volume commands in XM (http://bugs.openmpt.org/view.php?id=975).
- [Fix] <js> Most pattern editing functionality in pattern 2 and higher was broken after deleting pattern 1.

Pattern tab::Find/Replace
- [Fix] <js> Replacing with an extended command (Exx / Sxx) overwrote the parameter to be found.
- [Fix] <js> When re-opening the dialog, the replace parameter was not restored correctly for extended commands.

Sample tab
- [Mod] <js> Lifted the sample limit in sample mode from 199 to 255 (http://bugs.openmpt.org/view.php?id=969).

Mod Conversion
- [Imp] <js> When converting note cuts to XM, rewrite them as a v00 command if the effect column already occupied.

VST::Specific Plugin Fixes
- [Fix] <js> Some resizable GUI plugins (e.g. Roland D-50) were not resized correctly.

MOD
- [Fix] <js> Use M.K. signature instead of M!K! when writing exactly 64 patterns (http://bugs.openmpt.org/view.php?id=958).

Other formats
- [Imp] <js> PT36: Enable VBlank timing as specified in file and read song comment (http://bugs.openmpt.org/view.php?id=962).
- [Imp] <js> M15: Loosen heuristics to allow a few more semi-damaged files to play.
- [Fix] <js> MT2: If there were instruments with both sample and plugin assignments, sample data was not read correctly.

Module cleanup
- [Fix] <js> Remove Duplicates: Patterns with identical contents but different tempo swing settings were merged.

Third-Party Libraries
- [Imp] Update opus (v1.1.5)


v1.26.11.00 (21 May 2017, revision 8187)
----------------------------------------
Pattern tab
- [Imp] <js> Show a warning when duplicating patterns exceeds the pattern limit of the format. 
- [Fix] <js> Channel panning was not always updated from instruments / samples when seeking (tx oerg866).
- [Fix] <js> Out-of-range global volume was not applied correctly in some formats when seeking.

Instrument tab
- [Fix] <js> Convert auto-vibrato sweep when saving XI from MPTM / IT files more accurately.

Tree view
- [Imp] <js> When descending into a directory that contains nothing but one subdirectory, automatically descend further down into that directory.
- [Fix] <js> Deleting patterns was not undo-able.

VST / DMO Plugins
- [Fix] <js> If a plugin's unique ID has changed (e.g. by replacing the plugin DLL with that of another plugin), the old ID was still written to module files.

VST::Specific Plugin Fixes
- [Fix] <js> Crash when trying to use SynthMaster 2.8.
- [Fix] <js> Plugin data of some newer JUCE-based plugins (e.g. latest TAL-Filter-2 version) was not saved correctly inside module files (http://bugs.openmpt.org/view.php?id=946).

Playback
- [Fix] <js> Possible crash when using Duplicate Note Actions with instruments that are associated to plugins (http://bugs.openmpt.org/view.php?id=951).

IT
- [Imp] <js> Properly identify files made with OpenMPT 1.17.02.20-25, CheeseTracker, UNMO3 and some unknown XM conversion tool.
- [Imp] <js> Work-around for reading MIDI macros and plugin settings in some malformed IT files written by old UNMO3 versions.

Installer/release package
- [New] <js> Register OpenMPT as a default application.


v1.26.10.00 (23 April 2017, revision 8041)
------------------------------------------
Pattern tab
- [Fix] <js> "Continue song as soon as MIDI notes are being received" also restarted playback from cursor position if "follow song" was disabled.

Sample tab
- [Imp] <js> Show tooltip explanations for auto-vibrato parameters.

Mod Conversion
- [Imp] <js> Convert auto-vibrato sweep between IT / MPTM and XM more accurately.

Other formats
- [Imp] <js> STM: Add support for "WUZAMOD!" magic bytes and allow some slightly malformed STM files to load which were previously rejected (putup10.stm, putup11.stm) while tightening some other heuristics.
- [Imp] <js> Tighten heuristics for rejecting invalid SoundTracker files.
- [Fix] <js> Detect whether "hidden" patterns in the order list of SoundTracker modules should be taken into account or not. Fixes wolf1.mod, wolf3.mod and jean_baudlot_-_bad_dudes_vs_dragonninja-dragonf.mod.
- [Fix] <js> MO3: Clear MIDI macros for files that were originally saved with Impulse Tracker 1.0 and Scream Tracker prior to version 3.20.

Misc
- [Imp] <jh> About Dialog: Show the real CPU features in addition to the enabled ones.
- [Imp] <js> Use icons with alpha transparency on Wine 1.6 and newer.
- [Fix] <js> Appending a sample-based module to an instrument-based module did not create instruments for the newly added samples.
- [Fix] <js> Merging sequences could sometimes fail when having to duplicate patterns.
- [Fix] <js> Fix icons with broken transparency on some systems.
- [Fix] <js> MIDI Macro Dialog: When viewing controllable plugin parameters, non-existing parameters could show up.
- [Fix] <jh> A bogus warning was shown when launching with /noAssembly command line switch.


v1.26.09.00 (19 March 2017, revision 7821)
------------------------------------------
Pattern tab
- [Fix] <js> Seeking with sample sync did not apply PTM reverse offset effect and the volume slide part of combined volume slide + vibrato commands.
- [Fix] <js> "Copy Orders" shortcut never worked (http://forum.openmpt.org/index.php?topic=5787.0).
- [Fix] <js> Crash when trying to open effect visualizer for a module with no patterns.
- [Fix] <js> When "Loop Pattern" is active, position jump commands no longer jump to the target pattern but restart the current pattern (http://bugs.openmpt.org/view.php?id=15).

Sample tab
- [Fix] <js> 16SV samples created by Fasttracker 2 / Awave were not loaded correctly.

Tree view
- [New] <js> Added "Go to Instrument / Sample directory" context menu entries to file browser to return to the default directories.

Mod Conversion
- [Fix] <js> F20 command was not converted correctly from MOD to S3M / IT / MPTM.

VST / DMO Plugins
- [Fix] <js> Duplicate Note Action checks did not work for instrument plugins with a transposed note map.
- [Fix] <js> Changing to another instrument after an arpeggio did not always stop the last plugin note (http://bugs.openmpt.org/view.php?id=916).

VST::Specific Plugin Fixes
- [Fix] <js> MIDI notes sent by randomid VST by Insert Piz Here were not being received (http://forum.openmpt.org/index.php?topic=5791.0).

XM
- [Imp] <js> Improve detection of some XM files made with ModPlug Tracker that make use of extended filter range.

XM::Compatible Playback Mode
- [Fix] <js> An instrument-less note following a note with an out-of-range offset effect was played at volume 0 (tx eightbitbubsy).

MOD
- [Fix] <js> Sample 15 in "Crew Generation" by Necros was not looped correctly.

Other formats
- [Imp] <da> SFX: Improved import of slide commands (http://bugs.openmpt.org/view.php?id=921).
- [Imp] <js> PLM: Improved import of percentage offset.
- [Fix] <js> Speed up opening of some malformed ITP and truncated AMS files.

Misc
- [Imp] <js> Visually indicate whether playback was stopped or paused by resetting the elapsed time in the status bar to 0:00:00 when stopping.
- [Fix] <jh> Guard against DLL pre-loading attacks when loading dependencies of mpg123 and unmo3 third-party libraries.


v1.26.08.00 (5 February 2017, revision 7557)
--------------------------------------------
General tab
- [Fix] <js> When modifying the number of channels from the pattern editor, the upper part of the General tab was not updated (http://bugs.openmpt.org/view.php?id=903).
- [Fix] <js> Moving, inserting and cloning plugins did not update the tree view completely.

Pattern tab
- [Mod] <js> Do not wrap around the spin wheel for the edit spacing box from 0 to 64.
- [Fix] <js> Correctly center active row when switching to a pattern that has less rows than the previously edited pattern (http://bugs.openmpt.org/view.php?id=899).
- [Fix] <js> Moving channels did not update the channel names in other windows.
- [Fix] <js> The "switch to order list" shortcut also toggled overflow paste.
- [Fix] <js> Quick Channel Settings: Entering a panning value manually did not reset the surround setting visually.
- [Fix] <js> Trying to play a part of a pattern that is not part of the regular play sequence (e.g. rows after a pattern break) caused the pattern to be played from the first row instead.

Sample tab
- [Imp] <js> Add 1:256 and 1:512 zoom factors.
- [Fix] <js> Show the correct PAL sample rate for MOD files when hovering the finetune field.

Tree view
- [Fix] <js> If a soundfont has more than 16 banks, do not cram items of further banks into the first bank's folder.

Mod Conversion
- [Fix] <js> When converting from IT / MPTM / S3M to MOD and vice versa, samples were slightly detuned (MOD plays with PAL middle-C frequency, but was translated using NTSC middle-C frequency).

VST / DMO Plugins
- [Fix] <js> Plugin Editor: Toggling bypass did not live-update the General tab for all plugins but the first (http://bugs.openmpt.org/view.php?id=911).
- [Fix] <js> Completely disable silence detection for VST plugins, as plugins built with old versions of the JUCE framework falsely claim that they support this feature.

Playback
- [Fix] <js> When performing excessive portamento down in IT linear slide mode with legacy period mode enabled or excessive portamento up with Hertz mode, the channel frequency wrapped around since OpenMPT 1.26.01.00 (fixes https://modarchive.org/module.php?175019).

S3M
- [Fix] <js> Increase maximum sample playback frequency for S3Ms saved with Impulse Tracker and Schism Tracker (http://bugs.openmpt.org/view.php?id=898).

Other formats
- [Fix] <js> Possible hangs with malformed files containing cyclic plugin routings.

Misc
- [Fix] <js> Configuring chords with a relative base note was broken since OpenMPT 1.26.01.00.
- [Fix] <js> Tempo Swing dialog: A swing amount of 100% is now displayed correctly on Wine prior to version 2.0.
- [Fix] <js> When switching between multiple windows of a single module, sample and instrument editors are now receiving playback updates instantly.
- [Fix] <js> SF2: Some stereo sample pairs were mismatched.
- [Fix] <js> Running OpenMPT with a relative path to a module file as a parameter did not work as intended.

Bundled plugins
- [Fix] <js> MIDI Input / Output plugin: Identically-named input and output ports could cause the previous plugin state to not be restored properly.

Third-Party Libraries
- [Imp] Update flac (v1.3.2), opus (v1.1.4), PortAudio (v19.6.0), zlib (v1.2.11).


v1.26.07.00 (20 November 2016, revision 7387)
---------------------------------------------
Pattern tab
- [Mod] <js> Remember channel transpose amount also after closing the tab.
- [Mod] <js> When making an order list selection using the keyboard, do not update the play position.
- [Fix] <js> Note Properties: Changing the plugin of a PC event didn't update the parameter list (tx isdera).
- [Fix] <js> Pattern transitions were executed too early if a pattern loop ended on the last row of a pattern.
- [Fix] <js> Dragging a single pattern with "Follow Song" enabled could modify the dragged pattern selection on pattern transitions.
- [Fix] <js> Duplicating patterns did not apply the original pattern's tempo swing settings.
- [Fix] <js> Tempo swing settings were ignored when setting them to 100% for each row for a specific pattern, even if this differed from the global swing settings.
- [Fix] <js> Pasting a partial PC event over a Z80...ZFF effect did not clear the parameter value properly.

Sample tab
- [Fix] <js> Very rare crash when trying to open sample tab.

Instrument tab
- [Imp] <js> Allow a maximum fadeout value of 32767 in MPTM, like in XM.

Tree view
- [New] <js> Add "Open in Explorer" to instrument library directory context menu.
- [New] <js> Insert key can now be used to insert items, Shift-Insert to duplicate them (http://bugs.openmpt.org/view.php?id=529).
- [Fix] <js> Excessive performance drop when modifying a sample or instrument in a module containing hundreds of samples or instruments.

Mod Conversion
- [Imp] <js> Converting an XM instrument with no volume envelope to IT / MPTM now creates an envelope which instantly cuts the sample on key-off.

Playback
- [Fix] <js> Tremolo on quiet notes was broken in OpenMPT 1.26.06.00 (http://bugs.openmpt.org/view.php?id=888). 

S3M
- [Fix] <js> Pattern loops ending on the last row of a pattern were not executed properly (http://bugs.openmpt.org/view.php?id=887).

Other formats
- [Fix] <js> MED: Default 8-channel mode tempo should now be imported correctly.
- [Fix] <js> Possible crashes with malformed ITP and MED files.

Module cleanup
- [Fix] <js> Remove Duplicates: Patterns with identical contents but different time signatures were merged.

Misc
- [Fix] <js> Windows key and other special keys were always intercepted since OpenMPT 1.26.01.00 (http://bugs.openmpt.org/view.php?id=886).

Third-Party Libraries
- [Imp] Update UNMO3 (v2.4.1.2).


v1.26.06.00 (22 October 2016, revision 7297)
--------------------------------------------
Pattern tab
- [Fix] <js> Using overflow paste on the last possible order item overflowed into the beginning of the current pattern.
- [Fix] <js> "Change plugin parameter" only worked if the selection started in the first channel (http://forum.openmpt.org/index.php?topic=5729.0).
- [Fix] <js> Pasting partial PC events could result in invalid parameter numbers or values in patterns.
- [Fix] <js> Duplicating several identical order list items could fail if there were more than 256 order items.

Pattern tab::Find/Replace
- [Fix] <js> Searching for a specific Sxy / Exy parameter didn't bring up the correct parameter when repeatedly opening the Find/Replace dialog.

Sample tab
- [Imp] <js> When reading ITI / XI instruments as samples, prefer reading the sample at middle-C rather than the first sample in the file.
- [Fix] <js> Crossfading did not work if a sample only had a sustain loop.
- [Fix] <js> Adding silence at the beginning of the sample only updated the normal loop points, but not the sustain loop points.

Instrument tab
- [Fix] <js> Allow ITI files saved with old Schism Tracker versions to be loaded.
- [Fix] <js> Saving ITI files for instruments referencing sample slots > 255 made such files unneccessarily incompatible with other trackers.

Tree view
- [Fix] <js> Do not cycle through tree items when keeping keys pressed while a playable item is focussed (http://bugs.openmpt.org/view.php?id=872).

Playback
- [Fix] <js> Even when disabling "loop song", songs with 256 order items or more still looped (http://bugs.openmpt.org/view.php?id=878).

IT
- [Fix] <js> Correctly write MIDI program and bank instrument properties in a way that is also read by other IT-compatible applications.

MOD
- [Fix] <js> Avoid enabling some ProTracker quirks for files most likely created with Scream Tracker 3 (fixes BASIC001.MOD, tx Borg-).
- [Fix] <js> Tremolo effect only had half the intended strength.

Other formats
- [Fix] <js> Crashes with malformed files in various formats.

Module cleanup
- [Mod] <js> "Remove unused channels" will no longer remove channels from 4-channel MODs, as a user may typically want such modules to remain ProTracker-compatible (tx eightbitbubsy).
- [Fix] <js> Possible crash when removing unused plugins.

Misc
- [Imp] <js> Channel Manager: Dragging the mouse over buttons now applies the same action to all hovered buttons rather than toggling the action everytime the mouse moves a bit.
- [Imp] <js> Channel Manager: Visual improvements, especially in high-DPI mode.
- [Imp] <js> Various buttons (e.g. pattern editor and sample map) look nicer in high-DPI mode.
- [Imp] <js> DLS: Experimental support for "art2" chunk.
- [Fix] <js> DLS: Embedded soundfonts could not be read in some cases.
- [Fix] <js> SF2: Region coarse-tune was not imported at all.
- [Fix] <js> MIDI Macro dialog is now DPI-aware.
- [Fix] <js> The Plugin Manager window could be placed off-screen, effectively locking the entire GUI (http://forum.openmpt.org/index.php?topic=5738.0).


v1.26.05.00 (3 September 2016, revision 7025)
---------------------------------------------
Pattern tab
- [Imp] <js> Show clamped values (or "undefined", depending on the format) for out-of-range channel / global volume parameters in the status bar (http://bugs.openmpt.org/view.php?id=866).
- [Fix] <js> Seeking with sample sync could behave strangely with portamento-ed pingpong-looped samples.
- [Fix] <js> Data Entry also modified the effect column when it was only supposed to affect other columns.
- [Fix] <js> If the same pattern occurred several times in a row, the previous / next patterns were not drawn correctly.
- [Fix] <js> The Parameter Editor window was redrawn more often than necessary (multiple times per row, for every tick - tx mandrasigma).

Pattern tab::Find/Replace
- [Fix] <js> Repeated searches for extended commands (Sxy / Exy) did not remember the correct pattern commands to search for.

Instrument tab
- [Imp] <js> Improved handling of drum patches in Gravis Patch files.

Tree view
- [Fix] <js> Some soundfont items were not previewed correctly.

Mod Conversion
- [Fix] <js> Correctly translate Lxy / Kxy with fine slide parameter when converting from S3M / IT / MPTM to MOD / XM.

VST::Specific Plugin Fixes
- [Fix] <js> Genny Beta uses parameter values outside the nominal 0...1 range, which broke when loading and saving modules using this plugin. The affected parameters can still not be automated properly, though (the same issue exists in other hosts).

VST::Plugin Bridge
- [Fix] <js> Some mouse actions did not work in bridged editors on some systems, in particular with Windows 10 Anniversary Update (http://forum.openmpt.org/index.php?topic=5703.0).
- [Fix] <js> Toggling the plugin editor could lead to a crash if the bridged editor took very long to initialize.

MOD
- [Fix] <js> Restart position was not read correctly if placed in the last two orders (http://bugs.openmpt.org/view.php?id=867).

Other formats
- [Fix] <js> MIDI Import: A channel 10 drum program change could cause melodic channels using the same program number to turn into drums (http://bugs.openmpt.org/view.php?id=462).
- [Fix] <js> Possible crashes with malformed IT, MED, MPTM, PSM and Startrekker files.

Misc
- [Fix] <js> MIDI Export: Timing precision was drifting badly, leading to notes not being properly aligned to the PPQN.
- [Fix] <js> MIDI Export: Since OpenMPT 1.26.01.00, exporting a file with a plugin in the first slot would lead to a crash when closing the file later.
- [Fix] <js> MIDI Export: Pitch bend depth was not always exported correctly.
- [Fix] <js> SF2: Region fine-tune was not imported at all. Soundfonts should now hopefully be finally in tune!
- [Fix] <js> SF2: Some sample loops were not imported correctly.
- [Fix] <js> It may have been possible that auto save also triggered on unsaved files right after they were loaded.

Bundled plugins
- [Fix] <js> Possible crash in the MIDI Input / Output plugin when a MIDI message could not be sent.


v1.26.04.00 (7 August 2016, revision 6772)
------------------------------------------
Pattern tab
- [New] <js> Can now record MIDI Pitch Wheel changes to pattern as MIDI macros (http://forum.openmpt.org/index.php?topic=1615.0).
- [Imp] <js> Redirect keys entered in the instrument column to the note column if they didn't trigger any action (tx coda).
- [Mod] <js> Switch direction of instrument selection buttons (http://bugs.openmpt.org/view.php?id=841).
- [Fix] <js> Note Properties: Parameter for "fine portamento up" command was not displayed correctly in MOD / XM files.

Sample tab
- [New] <js> Can now mix-paste from clipboard.
- [New] <js> Can now Paste (Insert) instead of just Paste (Replace) as well.
- [New] <js> Can now import Sun Audio (AU / SND) samples.
- [New] <js> Can now import 64-bit float, µ-law and A-law WAV and AIFF samples.
- [Imp] <js> Remember previously used resampler across sessions (http://bugs.openmpt.org/view.php?id=830).
- [Imp] <js> If there is no loop yet, allow setting the loop start via context menu (sample end becomes loop end).
- [Fix] <js> Cue points were not written correctly to FLAC files.

Comments tab
- [Imp] <js> Ctrl+A can now be used for selecting all text (http://bugs.openmpt.org/view.php?id=706).

Mod Conversion
- [Imp] <js> When converting restart positions to pattern commands, ensure that the modified pattern is unique, so that other instances of the pattern remain unaffected of the change.
- [Fix] <js> Since OpenMPT 1.26.01.00, converting to IT / S3M converted the restart position to a pattern jump command, but did not actually remove the restart position property.

VST / DMO Plugins
- [New] <js> Can now rename plugin presets by clicking on the preset name in the editor. Not all plugins support this.
- [Fix] <js> OpenMPT 1.26.01.00 introduced a behaviour change when restoring plugin parameters: If less plugin parameters could be restored from the file than the plugin actually has (which could happen when upgrading to a new plugin version), they were no longer ignored completely. The old behaviour is now in place again.

VST::Specific Plugin Fixes
- [Fix] <js> Work around strange crash in Admiral Quality NaiveLPF.

MPTM
- [Fix] <js> Possible crash when loading malformed tunings.

S3M
- [Mod] <js> For old ModPlug-made S3Ms, cut notes early rather than limiting them to the maximum supported frequency (fixes off-key frequency slide in watcha.s3m).

MOD
- [Fix] <js> Sample swapping with portamento didn't work as intended for ProTracker MODs.
- [Fix] <js> More accurate ProTracker arpeggio wrap-around emulation.
- [Fix] <js> ADPCM-compressed samples were broken since OpenMPT 1.26.01.00 (http://bugs.openmpt.org/view.php?id=832).

Other formats
- [Imp] <js> MDL: Vastly improved loader.
- [Fix] <js> 669: Unis 669 pan slide effect was too deep.
- [Fix] <js> DMF: Sample loop lengths were off by one.
- [Fix] <js> DSM: Some pattern commands were not imported correctly.
- [Fix] <js> MT2: Ignore plugin automation data for pre-2.5 files.
- [Fix] <js> PSM16: More accurate sample tuning.
- [Fix] <js> STM: Do not load garbage samples in some files (e.g. acidlamb.stm).
- [Fix] <js> ULT: Only import pattern commands supported by the UltraTracker version that was used to save the file. Add support for command 5-C (end loop).
- [Fix] <js> OpenMPT 1.26.03.00 broke import of many pattern commands in DBM, DMF and ULT files.
- [Fix] <js> Several valid (but slightly corrupted possibly due to disk failures or data transfer errors) SoundTracker files were no longer loading in OpenMPT 1.26.03.00.

Module cleanup
- [New] <js> Added option to remove all unused channels (http://bugs.openmpt.org/view.php?id=835).

Misc
- [Mod] <js> Update check: Operating system version is now transmitted if basic update statistics are allowed. We need this information for planning build configurations of future OpenMPT versions.
- [Fix] <js> Memory leak when loading stereo SF2 instruments.

Third-Party Libraries
- [Imp] Update opus (v1.1.3) and UnRAR (v5.4.4).


v1.26.03.00 (11 July 2016, revision 6609)
-----------------------------------------
General tab
- [Fix] <js> Show scaled Dry / Wet ratio when Expanded Mix is enabled.

Pattern tab
- [Imp] <js> When jumping around in the song, update plugin parameters to their latest value.
- [Imp] <js> Grey out add / duplicate / remove channel context menu entries when the maximum / minimum number of channels is reached (http://bugs.openmpt.org/view.php?id=820).
- [Mod] <js> Right-clicking outside a selection no longer cancels the selection (http://bugs.openmpt.org/view.php?id=823).
- [Fix] <js> Position Jump with Parameter Extension was not interpreted correctly if pattern loop was active (http://bugs.openmpt.org/view.php?id=806).
- [Fix] <js> Clicking very quickly on the order list while it was not fully initialized yet could lead to a crash.
- [Fix] <js> Pasting multiple patterns didn't update the pattern list in the tree view (http://bugs.openmpt.org/view.php?id=811).
- [Fix] <js> After removing commands from patterns, their parameters could still show up in clipboard data.

Pattern tab::Find/Replace
- [Fix] <js> Manually entering hexadecimal parameters did not work (http://bugs.openmpt.org/view.php?id=825).

Sample tab
- [New] <js> Can now use any of OpenMPT's own filters for resampling (http://bugs.openmpt.org/view.php?id=740).

Mod Conversion
- [Imp] <js> Better handling of volume slide and portamento command memory when converting from IT / MPTM / S3M to XM.

VST::Specific Plugin Fixes
- [Fix] <js> VOPM no longer crashes randomly when pressing cancel in OPM import / export dialogs.

VST::Plugin Bridge
- [Mod] <js> Initialize COM for plugins that need it.

MPTM
- [Fix] <jh> Fix possible crash when saving modules with custom tunings after deleting instruments from the tree view.

IT
- [Fix] <js> IT-compatible auto-vibrato jumped very coarsely when being applied to high-pitched notes in non-linear mode.

S3M
- [Imp] <js> Warn when writing too much pattern or sample data when saving S3M files.

MOD
- [Mod] <js> Allow MOD files with 1 to 3 channels to be created.
- [Fix] <js> MOD files with more than 128 patterns were not loaded correctly (e.g. NIETNU.MOD).

Other formats
- [Fix] <js> GDM: Some pattern commands were not imported properly since OpenMPT 1.20.
- [Fix] <js> MDL: Pattern import was broken for all but the first pattern.
- [Fix] <js> MT2: Fix some modules with "modern" tempo interpretation.
- [Fix] <js> MTM: Vibrato depth is approximately half as deep as in MOD.
- [Fix] <js> Tighten SoundTracker heuristics to reject more non-module files (e.g. SNES SPC and MP3 files).

Stream Export
- [Imp] <js> Show which sample / instrument / channel is being exported (http://bugs.openmpt.org/view.php?id=808).
- [Imp] <js> Do not export sampless and instruments that only appear on muted channels in instrument export mode (http://bugs.openmpt.org/view.php?id=808).
- [Fix] <js> Do not export muted samples and instruments in instrument export mode (http://bugs.openmpt.org/view.php?id=808).
- [Fix] <jh> Exported Ogg and Opus streams almost always had the same serial number.

Audio I/O
- [Imp] <jh> Allow setting the priority (XP) or MMCSS class (Vista) used for boosting the sound device thread. The hidden options and defaults are "Sound Settings.BoostedThreadPriority" (2) and "Sound Settings.BoostedThreadMMCSSClass" (Pro Audio) (http://forum.openmpt.org/index.php?topic=5655.0).

Misc
- [New] <jh> Allow setting the process priority class through hidden setting "Misc.ProcessPriorityClass" (default is "normal", http://forum.openmpt.org/index.php?topic=5655.0).
- [Mod] <js> Finally completely deprecate MPT 1.16 mix mode and only show it for legacy modules.
- [Fix] <jh> Some input dialogs were not sized correctly when using the build for old Windows versions (http://bugs.openmpt.org/view.php?id=810).

Third-Party Libraries
- [Imp] Update opusfile (v0.8) and UnRAR (v5.4.2).


v1.26.02.00 (22 May 2016, revision 6410)
----------------------------------------
Audio I/O
- [Fix] <jh> Fix playback on some Wave Out drivers (e.g. in Wine 1.7.46, possibly also fixes http://bugs.openmpt.org/view.php?id=620).

Misc
- [Fix] <js> Song length estimation: Length was reported incorrectly for some modules in modern tempo mode and estimation disturbed real-time playback in songs with per-pattern time signature.
- [Fix] <jh> OpenMPT did not detect Wine reliably in the previous release.


v1.26.01.00 (21 May 2016, revision 6400)
----------------------------------------
General tab
- [Imp] <js> In the plugin "Output To" box, there is now also an option to add a new plugin to which the output should be routed.
- [Imp] <js> Cloning an instrument plugin also creates a new module instrument for it.
- [Mod] <js> When cloning plugins, slightly offset the cloned editor window to not confuse it with the original window.

Pattern tab
- [Imp] <js> Double-clicking an empty order list cell creates a new pattern.
- [Mod] <js> Make Play Row behaviour consistent with cursor movement behaviour if "Continuous Scroll" is disabled: When "Cursor Wrap in Pattern Editor" is disabled, the cursor remains on the last row when reaching the pattern end (http://bugs.openmpt.org/view.php?id=753).
- [Mod] <js> When jumping around during live playback and crossing a pattern border, reset all voices.
- [Mod] <js> To make Data Entry more useful, it is now only applied to the first column type of selection, even if it spans several channels (e.g. if the selection starts in the volume column, only volume will be changed).
- [Fix] <js> Show correct (summed up) parameter for commands augmented with Parameter Extension (#xx) in the status bar.
- [Fix] <js> Note Properties: Pre-select correct item in plugin parameter list if plugin has more than 100 parameters.
- [Fix] <js> Recording automation from plugin parameters in IT/XM modules wrote incorrect Zxx parameters.
- [Fix] <js> With "follow song" enabled, order list multi-selections are no longer modified on pattern transitions.
- [Fix] <js> Redraw issues with right-click drawing in the parameter editor.
- [Fix] <js> Patterns were not drawn at all in OpenMPT 1.25 at 0 rows per measure.

Pattern tab::Find/Replace
- [New] <js> Can now find ranges of data (e.g. notes C-5 to D-6) and replace them also with relative values or percentages (http://bugs.openmpt.org/view.php?id=742).
- [Imp] <js> Can now find and replace all columns of PC events (http://bugs.openmpt.org/view.php?id=44).
- [Imp] <js> Replacing notes by +/-1 octave now works as intended for instruments with custom tunings.

Sample tab
- [New] <jh> Ogg Vorbis and Opus sample loading support.
- [New] <js> New shortcuts: Zoom to sample start (1) / end (2), trim to loop end (Ctrl+Shift+T).
- [Imp] <js> Loop cross-fader now also works with sustain loops.
- [Imp] <js> MP3-compressed WAV samples are now also tried to be decoded using Media Foundation rather than just mpg123.
- [Fix] <js> Sample tuner was broken for XM modules.
- [Fix] <js> Stereo IMA ADPCM WAV samples were not read correctly.
- [Fix] <js> Splitting a stereo sample into two mono samples didn't update the tree view.
- [Fix] <js> When extracting a single sample from an SF2 bank, import the sample name rather than the patch name (http://bugs.openmpt.org/view.php?id=758).

Instrument tab
- [New] <js> Added keyboard shortcuts for selecting loop points and moving envelope points by one beat.
- [Imp] <js> Draw selected loop points in different colour.
- [Imp] <js> Show fade-out length in ticks when hovering its edit field.
- [Imp] <js> When entering a MIDI program > 128, automatically convert it to a program + bank combination.
- [Imp] <js> Show plugin program name when hovering MIDI program / bank input fields.
- [Imp] <js> Update status bar when moving envelope points around using the keyboard.
- [Fix] <js> Preview the correct note when pressing octave keys (tx eightbitbubsy).

Tree view
- [Imp] <js> Speed up display of very long order lists.
- [Fix] <js> When removing a plugin, all other plugins were removed from the tree view as well, despite still being present in the module.

VST / DMO Plugins
- [New] <js> Disable the remove button in the plugin manager for DMO plugins, as it confused several users how to re-add the removed plugins.
- [New] <js> Shift-clicking a plugin editor toggle button closes all other editors (tx coda).
- [New] <js> OpenMPT now reads the VST plugin vendor. Searching for a plugin in the plugin manager also searches in the vendor names.
- [Imp] <js> When opening an instrument plugin editor, check if the currently selected instrument would be suitable input instrument for the plugin, rather than just the first instrument that uses this plugin.
- [Imp] <js> If available (on DirectX 9 and newer), DMO plugins now process in floating-point precision rather than 16-bit PCM.
- [Imp] <js> DMO plugins can now be tagged as well.
- [Mod] <js> Editing integer parameters of DMO plugins should be easier now.
- [Mod] <js> Always send both LSB and MSB of bank select. Otherwise some synths (e.g. Roland XV-5080) ignore it.
- [Fix] <js> Plugin editor position was not restored properly on multi-monitor setups.
- [Fix] <js> Possible drift in precision for DMO plugins that query the current play time.
- [Fix] <js> Only the first VST plugin in a module got informed about transport changes.
- [Fix] <js> Some plugins (e.g. Electri-Q) don't like it when querying the names of non-existent parameters, which could e.g. happen when entering PC events into patterns.
- [Fix] <js> Possible crash in 64-bit version of OpenMPT with any plugin (http://forum.openmpt.org/index.php?topic=5651.0).

VST::Specific Plugin Fixes
- [Fix] <js> Image-Line Sawer does not like MIDI CC 121 and 123, so do not send them when resetting playback (tx mallo).
- [Fix] <js> Superior Drummer did not load its samples until playback starts (http://bugs.openmpt.org/view.php?id=750).

Playback
- [Mod] <js> Instead of having one "compatible playback" per file, every playback quirk now has its own flag. This includes a dialog to edit these flags. These flags should not be edited manually, except for the "Set Defaults" functionality.
- [Mod] <js> For old files made with MPT / OpenMPT before v1.24, sample rates are now computed in periods again in linear slide mode. This fixes for example the drum line sample in Zanoma's "Late At Night". Similarly, old OpenMPT-made files that use portamento at speed 1 now sound as in OpenMPT 1.17 - 1.20 again.
- [Fix] <js> Volume column offset + retrigger effect combination was broken for looped samples and could lead to crashes.
- [Fix] <js> Playing a sample at a sample rate close to the mix rate could lead to small clicks when using vibrato.
- [Fix] <js> If no instrument number was provided, New Note Action with empty sample slot and Duplicate Note Action sample checks were broken.
- [Fix] <js> Do not apply offset command next to a note mapped to a non-existing sample slot in instrument mode.
- [Fix] <jh> Bass Expansion DSP was not applied to rear channels (broken since the dawn of time).
- [Fix] <js> Possible crash with excessive portamento down in some formats.

MPTM
- [New] <js> Each sequence now has its own restart position.
- [New] <js> Parameter Extension (#xx) now also works with Position Jump command (http://bugs.openmpt.org/view.php?id=789).
- [Imp] <js> Warn when trying to save too large IT / MPTM files.
- [Mod] <js> Samples are now compressed by default (lossless IT compression).
- [Fix] <js> Extra fine portamento didn't work properly with custom tunings. EEx / FEx now changes the pitch by x finetune steps on the first tick (http://bugs.openmpt.org/view.php?id=731).

IT
- [Fix] <js> Even after fixing it in OpenMPT 1.18, instrument Pitch/Pan Separation was only half as deep as it should be.
- [Fix] <js> Portamento with no active note still applied the portamento effect if the previous note just stopped playing on the previous tick.

IT::Compatible Playback Mode
- [Fix] <js> Default volume of the instrument is recalled if an instrument number is next to a note-off.
- [Fix] <js> Resuming sample playback using a note without instrument number after a note cut was broken.
- [Fix] <js> Remember new instrument number for next instrument-less note even when sample playback is stopped.
- [Fix] <js> A note-less instrument number next to an out-of-range note delay resulted in playing the new sample but using the old sample's length, leading to possible crashes (re-fixes player abuse test 08, got severely broken in OpenMPT 1.23).
- [Fix] <js> Only applies global volume on (multiples of) the first tick (re-fixes player abuse test 16, broke in OpenMPT 1.19).

XM
- [Fix] <js> Some probably hex-edited XM files (e.g. cybernostra weekend.xm) were not loaded correctly.
- [Fix] <js> MadTracker 2 plays portamento-ed notes even if previously no note was playing. Disable this FT2 compatibility fix for XMs made with MadTracker (fixes m3_cha.xm).
- [Fix] <js> Skale Tracker plays notes with out-of-range offset commands. Disable this FT2 compatibility fix for XMs made with Skale Tracker.

XM::Compatible Playback Mode 
- [Fix] <js> Portamento with no active note still played the new note if the previous note just stopped playing on the previous tick (fixes u-k3symb.xm).

S3M
- [New] <js> Added support for old vibrato style which cannot be enabled in the Scream Tracker UI and is probably not used by any modules anyway.
- [Fix] <js> Pattern loop start resets on pattern transitions (http://bugs.openmpt.org/view.php?id=757).
- [Fix] <js> Do not distinguish between vibrato types in effect memory, so that e.g. U1F followed by H00 causes the second effect to play a H1F vibrato. Effectively, this also means that Kxx will never play a fine vibrato (tx eightbitbubsy).

MOD
- [New] <da & js> Support for ProTracker 3.6 IFF-style modules (http://bugs.openmpt.org/view.php?id=752)
- [Fix] <js> ProTracker does not validate the sample loop length, which can lead to detuned chip samples if the loop length is longer than the actual sample (fixes MOD.shorttune2).
- [Fix] <da & js> Try to detect NoiseTracker files disguising as ProTracker MODs and fix Dxx pattern commands for such files (http://bugs.openmpt.org/view.php?id=749, fixes 1.11song2.mod and 2-3song6.mod).
- [Fix] <da & js> Properly import finetune of His Master's Noise Tracker modules (fixes abridge.mod, questioff.mod and others, http://bugs.openmpt.org/view.php?id=749)
- [Fix] <js> Some trimmed MOD files were not loaded correctly (fixes quartex.mod).
- [Fix] <js> Infinite pattern loops were not handled properly.
- [Fix] <js> With Amiga limits enabled, do not go below period 113, independent of finetune setting.

Other formats
- [New] <da & js> Can now read SoundFX / MultiMedia Sound (SFX / MMS) modules (http://bugs.openmpt.org/view.php?id=741).
- [New] <js> DBM: Added support for echo DSP.
- [New] <js & jh> Added built-in MO3 support that does not rely on the closed-source UNMO3.
- [Imp] <js> MT2: Support for the full dynamic range of drum channels.
- [Imp] <js> MT2: Try to apply track routing by copying plugin chains.
- [Fix] <js> MT2: Plugin parameters were not restored correctly.
- [Fix] <js> MT2: Do not reset instrument fade value if NNA is set to Note Fade (fixes driven.mt2 by Screes)
- [Imp] <js> MT2: Import more pattern commands.
- [Fix] <js> MT2: Some sample to instrument associations were missing (fixes Dream Alone by Sonic)
- [Fix] <da & js> Various Ultimate SoundTracker heuristic fixes (http://bugs.openmpt.org/view.php?id=751).
- [Fix] <js> MDL: The tail of compressed samples was slightly off in OpenMPT 1.25.
- [Fix] <js> J2B: Properly import non-existing patterns.
- [Fix] <js> Files with lots of NUL bytes at the start are no longer falsely detected as Ultimate SoundTracker modules.
- [Fix] <js> Possible crashes with malformed AMF, AMS, DBM, IT, MDL, MED, MPTM, MT2, PSM and MMCMP-, XPK- and PP20-compressed files. 

Module cleanup
- [New] <js> Add option to merge identical patterns (http://bugs.openmpt.org/view.php?id=738).
- [Fix] <js> Detecting unused samples in instrument mode will now get slightly less confused about instrument-less notes.

Stream Export
- [Imp] <jh> Ogg Vorbis and Opus support is now built-in and no longer requires an external library.
- [Imp] <jh> Add a new "MP3 (compatible)" export file type that is implemented only via libmp3lame and is the same as the old libmp3lame CBR mode with strictly ID3v1 tags only.
- [Imp] <jh> Switch libmp3lame non-compatible MP3 export from CBR to ABR mode since ABR gives better quality.
- [Imp] <js> Temporary export files are now marked as temporary in the file system to avoid writing them to disk if possible.
- [Mod] <jh> Relax Lame CBR mode restrictions: Allow bit reservoir, do not enforce ISO padding and bit reservoir restrictions, write out lame info tag, always use ID3v2.
- [Fix] <jh> Render to Sample slot failed when exporting quad surround. As quad surround samples cannot be loaded yet, the channel count selection is now limited to mono or stereo for Render to Sample.
- [Reg] <jh> Only show a single MP3 encoder. If libmp3lame is available, it is by far the best option. If the user provided a BladeEnc.dll, they almost certainly want it preferred to any ACM encoder. Selecting a different encoder is still possible by disabling the components of higher priority encoders.
- [Reg] <jh> Remove hidden setting Export.MP3LameAllowID3v2inCBR (now always true for "MP3 / CBR" and always false for "MP3 (compatible) / CBR").

Misc
- [New] <js> Added hidden setting Misc.DistinguishModifiers to distinguish between left and right modifiers (e.g. to create FT2-like play pattern shortcuts).
- [New] <js> Update check: Add possibility to ignore automatic notifications for a specific OpenMPT version.
- [New] <jh> Added command line switch /noWine which disables any Wine-specific code when running OpenMPT in Wine. Only use when instructed to do so by the OpenMPT developers.
- [Imp] <js> SF2: Try to load instruments with left and right layer as stereo samples.
- [Imp] <js> Add browse item in example song and template module menus (http://bugs.openmpt.org/view.php?id=220).
- [Mod] <js> When saving a module file, do not change its extension. Prompt for a new filename when saving a file loaded from an import-only format (http://bugs.openmpt.org/view.php?id=762).
- [Mod] <js> Update check: Use HTTPS by default. On Windows XP and older, always fall back to HTTP as TLS 1.0 is disabled by default on these systems.
- [Fix] <js> MIDI Export: Note cuts were exported incorrectly and bloated the MIDI size (http://bugs.openmpt.org/view.php?id=746).
- [Fix] <js> SF2: Many soundfont samples were completely detuned since OpenMPT 1.20.
- [Fix] <js> Sometimes a wrong MIDI input device was remembered (http://bugs.openmpt.org/view.php?id=756).
- [Fix] <js> Creating / loading a looped 16-bit stereo sample shorter than 4 samples could lead to a crash.
- [Reg] <jh> The bandwidth of the polyphase 8-tap resampling filter is no longer configurable and fixed at the previous default of 97% now. The setting only affected the upsampling part of the filter and not the downsampling part, which was rather unintuitive. The bandwidth stays configurable for the XMMS-ModPlug filter.

Bundled plugins
- [New] <js> DigiBooster Pro Echo DSP is now a built-in plugin that can also be used in module types other than DBM.
- [New] <js> The MIDI Input / Output plugin now sends MIDI Clock events.
- [Mod] <js> The MIDI Input / Output plugin is now built right into OpenMPT and no longer shipped as a separate DLL file.
- [Fix] <js> SysEx messages received from a MIDI device are now handled properly by the MIDI Input / Output plugin.

Third-Party Libraries
- [Imp] Update lhasa (v0.3.1), UNMO3 (v2.4.1) and UnRAR (v5.3.11).

Installer/release package
- [Fix] <js> Note Off shortcut was missing in US_mpt-ft2_classic.mkb / US_mpt-it2_classic.mkb keymaps (tx Garian).
- [Mod] <js> Added FT2-like "play pattern from start" / "play song from pattern start" shortcuts to US_mpt-ft2_classic.mkb.


v1.25.04.00 (21 November 2015, revision 5785)
---------------------------------------------
General tab
- [Fix] <js> Plugin gain control was not accessible to some screen readers (http://bugs.openmpt.org/view.php?id=337).

Pattern tab
- [New] <js> Allow to skip forward / backward with navigation keyboard shortcuts and scroll wheel during playback if "follow song" is enabled.
- [Fix] <js> Recording MIDI CCs from MIDI was broken in MPTM files since OpenMPT 1.25.01.00.

VST::Plugin Bridge
- [Fix] <js> Opening the MIDI Mapping Dialog from a bridged plugin GUI could freeze the tracker.

IT/MPTM
- [Fix] <js> Global time signature values exceeding 255 rows were not loaded (but saved) correctly.

XM::Loading
- [Fix] <js> If the order list is empty, fill it with pattern 0 instead (fixes lamb_-_dark_lighthouse.xm).

MOD::Loading
- [New] <js> Support CD61 (6-channel Octalyser), FA04-FA08 (Digital Tracker), NSMS and LARD (unknown 4-channel, probably hex-edited) magic bytes in MOD files.
- [Imp] <js> Relaxed format detection heuristics for SoundTracker modules to allow more (broken) files to be loaded.

Other formats
- [Fix] <js> 669: More thorough file validation to reject files that vaguely resemble 669 files. MOD files with a song title starting with the letters "if" or "JN" had a high chance of being mis-identified as 669 modules.
- [Fix] <js> AMF: Some malformed files could result in very long loading times.
- [Fix] <js> IMF, MT2: Possible crash with some malformed files.
- [Fix] <js> MTM: Files generated by UNMO3 were not loaded properly. Generally improved playback compatibility.

Stream Export
- [Fix] <jh> ID3v2.4 tags were malformed in OpenMPT 1.25.03.00, leading to the first audio frame being skipped when playing the MP3 file (http://bugs.openmpt.org/view.php?id=725).

Misc
- [Fix] <js> MIDI Mapping Dialog: MIDI Learn did not work when opening the dialog from a plugin editor (http://forum.openmpt.org/index.php?topic=5550.0).
- [Fix] <js> Using key bindings in paths longer than 260 characters should now work properly.
- [Fix] <js> Disabling "Repeat notes on hold" for all notes at once was broken.
 

v1.25.03.00 (31 October 2015, revision 5703)
--------------------------------------------
Pattern tab
- [New] <js> Added hidden setting "Pattern Editor.EditStepAppliesToCommands" to also apply edit step to command letters (tx uctumi).
- [Imp] <js> Support effect-column volume slides when using sample sync.
- [Imp] <js> Forward / backward mouse buttons can be used to switch to next / previous order.
- [Fix] <js> Go To Dialog was not filled with sensible default values since OpenMPT 1.25.01.00.

Sample tab
- [Imp] <js> Pre-select the input field in the sample resize dialog (http://bugs.openmpt.org/view.php?id=705).
- [Imp] <js> Silence tool now works the same way for stereo samples as it does for mono samples.
- [Imp] <js> Time Stretch and Pitch Shift are now abortable.
- [Imp] <js> When trying to load a module into a sample slot, open it directly in the tree view for importing samples.
- [Imp] <js> Forward / backward mouse buttons can be used to switch to next / previous sample.
- [Mod] <js> When loading several samples, only ask once if they should be associated with an instrument (http://bugs.openmpt.org/view.php?id=340).
- [Fix] <js> Properly update all sample lists when slicing a sample.
- [Fix] <js> Resampling a sample with a very high sample rate (> 1 MHz) crashed the program.

Instrument tab
- [New] <js> Option in sample map context menu to remove all sample associations.
- [Imp] <js> Added keyboard shortcut for scaling envelopes (default: Ctrl+E).
- [Imp] <js> Ctrl+Right-click can now also be used to delete an envelope point.
- [Imp] <js> Nicer envelope drawing at higher zoom levels. Adjust default zoom level for High-DPI screens.
- [Imp] <js> After grabbing a sustain or loop point with the mouse, it can now also be moved using the keyboard shortcuts for moving nodes.
- [Imp] <js> Show sample numbers in Sample Map editor (http://forum.openmpt.org/index.php?topic=1795.msg15678#msg15678).
- [Imp] <js> When trying to load a module into an instrument slot, open it directly in the tree view for importing instruments.
- [Imp] <js> Forward / backward mouse buttons can be used to switch to next / previous instrument.
- [Fix] <js> Previewing several notes at once was broken for XM modules.
- [Fix] <js> Bogus keys were added for some envelope editor shortcuts.

VST / DMO Plugins
- [New] <js> Allow the user to enter plugin-specific tags in the plugin selection dialog. The name filter now searches for both plugin names and tags (patch partially provided by arseniiv, http://bugs.openmpt.org/view.php?id=541).
- [Imp] <js> When loading a module, indicate which plugin is being loaded in the status bar (http://forum.openmpt.org/index.php?topic=1693.0).
- [Fix] <js> Plugin editor minimizing should now also work with Wine. As a consequence, minimizing now only works through double-clicking, there are no minimize / maximize buttons any more.
- [Fix] <js> No longer apply auto-suspend logic to plugins that don't output any audio, as they can never fulfil it.

VST::Specific Plugin Fixes
- [Fix] <js> When closing Electri-Q's editor while it was minimized and having its resizeable GUI enabled, the GUI would no longer work on any host as it stored a bogus default window size.

VST::Plugin Bridge
- [Imp] <js> Implement audioMasterOpenFileSelector opcode for opening load / save file dialogs from some plugin GUIs (e.g. VOPM; http://bugs.openmpt.org/view.php?id=539).
- [Imp] <js> Speed up preset and parameter name retrieval (e.g. in plugin editor preset menu).
- [Mod] <js> Optimized audioMasterGetTime opcode caching.

MPTM::Custom Tuning
- [Fix] <js> Pitch effects (portamento, arpeggio) triggered after a note-off were broken since OpenMPT 1.22.

MOD
- [Mod] <js> As the majority of trackers including ProTracker seem to interpret F20 as tempo rather than speed, OpenMPT now does the same. The only other programs I could find that treat F20 as speed are Scream Tracker 3 and Impulse Tracker.
- [Fix] <js> Invert Loop position was not reset with instrument numbers.
- [Fix] <js> Offset beyond sample loop end was broken.

MOD::ProTracker 1/2 Mode
- [Fix] <js> Very short sample loops starting at the first sample point were detuned.

Other formats
- [Imp] <js> Better handling of tempos > 255 in MED.
- [Mod] <js> ITP: For the rare case that an ITP file loaded a 24-bit or higher quality WAV sample as an instrument, always enable the auto-normalize feature for those samples, as this was the default and fixed setting for loading such samples during most of the time when the ITP format was actively supported.
- [Fix] <js> MT2: Better handling of filters and synchronized samples.
- [Fix] <js> Crash in MED loader.
 
Stream Export
- [Imp] <jh> Write ReplayGain tags when exporting VBR MP3 using libmp3lame (http://bugs.openmpt.org/view.php?id=712). Can be disabled using "Export.MP3LameCalculateReplayGain", "Export.MP3LameCalculatePeakSample" and "Export.MP3ID3v2WriteReplayGainTXXX" settings. 
- [Imp] <jh> ID3v2 padding size is now configurable via hidden settings "Export.MP3ID3v2MinPadding" and "Export.MP3ID3v2PaddingAlignHint".
- [Imp] <jh> Use ID3v2.4 tags also when exporting VBR MP3 using libmp3lame. Toggle hidden setting "Export.MP3LameID3v2UseLame" to revert to ID3v2.3 tags.

Misc
- [New] <js> Allow to change between sharp and flat accidentals in Display settings.
- [New] <js> Added hidden settings "Display.HighResUI", which can be used to enable DPI-awareness in OpenMPT. Right now it is disabled by default because there are no high-DPI icons yet. In the future, people may want to keep this setting disabled when using plugin UIs that are not DPI-aware.
- [Fix] <js> Do not process keyboard commands while export dialogs are active (http://bugs.openmpt.org/view.php?id=704).
- [Fix] <js> Crash in 64-bit builds when trying to append a module.
- [Fix] <js> After changing the default rows per beat, the new value was not used in tempo approximation for classic and alternative tempo mode if the song was not currently playing.
- [Fix] <js> Some menu items were not greyed out when they should have been (http://bugs.openmpt.org/view.php?id=710).
- [Fix] <jh> Fix resource exhaustion on Wine when invoking any popup windows via a keyboard hotkey (http://bugs.openmpt.org/view.php?id=713).
- [Reg] <js> Remove hidden setting "Misc.ShowHackControls". All it did was showing an input field for changing the sequence margins, which can already be controlled through a different setting "Pattern Editor.DefaultSequenceMargins".

Third-Party Libraries
- [Imp] Update PortAudio (SVN r1963) and SoundTouch (v1.9.2).


v1.25.02.00 (13 September 2015, revision 5600)
----------------------------------------------
General tab
- [Fix] <js> Cloning plugins failed to copy the patch data in 32-bit legacy builds (and regular 32-bit builds before OpenMPT 1.25).

Pattern tab
- [Imp] <js> Update vibrato effect memory when seeking.
- [Fix] <js> Undoing pattern size changes didn't update the scrollbar size (http://bugs.openmpt.org/view.php?id=702).
- [Fix] <js> Possible crash when resizing pattern during playback with smooth pattern scrolling enabled.
- [Fix] <js> In smooth scroll mode, the dragging rectangle sometimes had the wrong colours.

Sample tab
- [New] <js> Can now slice samples at their cue points into several separate samples.
- [Imp] <js> Add support for Vorbis comments LOOPSTART and LOOPLENGTH in FLAC files to specify loop points (some audio engines seem to use this).
- [Fix] <js> Writing FLAC samples with a sample rate above 65535 Hz that was not a multiple of 10 Hz, or any sample rate above 655350 Hz failed. Note for software developers: Since FLAC sample rates are capped at 655350 Hz, OpenMPT now writes the real sample rate in a Vorbis comment called SAMPLERATE if it exceeds this limit. Feel free to add support for this tag in your software.

Instrument tab
- [Imp] <js> Also show the currently playing note in the status bar for notes received via MIDI (tx Xemogasa)
- [Fix] <js> Possible crash when recording MIDI while there was no instrument yet (tx Xemogasa).

Tree view
- [New] <js> Allow folders to be shown in lower part of sample browser through a right-click option.

VST / DMO Plugins
- [Fix] <js> Loading FXBs with parameter sets instead of chunks was broken.
- [Fix] <js> Update plugin name and slot number in editor window when renaming or moving a plugin.
- [Reg] <js> Disable the plugin window minimize feature on Wine, as it does not work as intended.

Playback
- [Fix] <js> Pitch envelopes were upside down in non-linear slides mode since OpenMPT 1.24.01.00.
- [Fix] <js> Avoid VSTi notes to stack up in XM files due to missing NNA handling (no, you should still not use VSTis in XM).

IT::Loading
- [Fix] Patterns containing command-less parameter values (which can be entered in some IT-compatible trackers) were imported incorrectly (fixes ckbounce.it).

MOD::ProTracker 1/2 Mode
- [Fix] <js> ProTracker offset quirks were partly broken since OpenMPT 1.24.04.00 (fixes professionaltracker.mod)

MOD::Loading
- [Imp] <js> If there are two Fxx commands on the same row and one can be interpreted as Set Speed and the other as Set Tempo, always treat the module to have CIA timing instead of VBlank timing.

Other formats
- [Imp] <js> MIDI export has been considerably improved. More commands are exported and it uses one MIDI track per instrument rather than one per pattern channel (http://bugs.openmpt.org/view.php?id=535).
- [Fix] <js> OKT: Portamento up and down were swapped.
- [Fix] <js> Possible crashes and hangs with malformed DMF, PLM, IMF, IT and MPTM files.

Audio I/O
- [Imp] <jh> Detect Wave Out errors during playback, display the detailed error code and message to the user, and try to gracefully shut down the device.
- [Fix] <jh> Fix stalled UI after longer playback with Wave Out devices, especially on Windows XP.

Misc
- [Imp] <js> Add Pitch Bend messages to MIDI macro generator.
- [Imp] <js> Add Zxx Macro Configuration dialog to the View menu and make its shortcut global.
- [Fix] <js> Song length estimation: Pattern breaks in a pattern followed by a --- pattern were sometimes calculated incorrectly in OpenMPT 1.25.01.00.
- [Fix] <js> There was an excessive performance drop on some GUI parts in the previous version.


v1.25.01.00 (16 August 2015, revision 5484)
-------------------------------------------
General tab
- [New] <js> Module artist can now be specified.
- [New] <js> Modules can now override the globally configured resampling mode. This setting is only saved in MPTM files, but can also be changed in other formats to quickly change a single module's resampling mode.
- [Mod] <js> Removed player settings button, as the most common (and only?) use case - changing the resampling mode - can now be achieved directly from this tab.
- [Mod] <js> In IT files, the default tempo can no longer exceed 255.
- [Fix] <js> The dB values shown in tooltips were wrong.
- [Fix] <js> When modifying default channel volume or panning using the sliders, default values were reset for all other channels on the same page (tx Xemogasa).

Pattern tab
- [New] <js> In the order list, it is now also possible to just copy the order list pattern numbers instead of their content ("Copy Orders" in context menu or Ctrl+Shift+C by default).
- [New] <js> Added option for smooth (tick-by-tick) pattern scrolling.
- [New] <js> Added hidden setting "Pattern Editor.NoEditPopup", which disables the "editing is disabled" popup and allows note previewing (keyjazz) in all pattern editor columns while editing is disabled.
- [Imp] <js> Apply DNA and NNA settings to live note preview. Entering Note Cut / Off / Fade also instantly previews its effect.
- [Imp] <js> Effect visualizer window size is now remembered across sessions.
- [Mod] <js> Reset beat highlight together with measure highlight (http://bugs.openmpt.org/view.php?id=662)
- [Fix] <js> When deleting orders, the pattern view did not switch to the newly selected order afterwards (tx coda).
- [Fix] <js> Effect visualizer could still not show up properly in some cases (http://forum.openmpt.org/index.php?topic=5476.0).
- [Fix] <js> Make note and data entry shortcuts always operate on octaves instead of +/- 12 notes when using custom tunings (http://bugs.openmpt.org/view.php?id=681).
- [Fix] <js> Show correct note name in status bar for custom tuning notes.
- [Fix] <js> Sample seeking didn't work properly on channels where the last note event was a note-off and didn't apply pitch envelopes.
- [Fix] <js> Panning commands were still applied when seeking even if ProTracker 1/2 mode was enabled.
- [Fix] <js> Playing patterns not present in the order list was broken since OpenMPT 1.24.03.00 (http://forum.openmpt.org/index.php?topic=5495.0).
- [Fix] <js> Jumping to a pattern through the order list would still execute the last row of the previous pattern in some cases since OpenMPT 1.24.03.00.
- [Fix] <js> Fix inconsistencies in the previous / next pattern displays when jumping around in the order list.
- [Fix] <js> Duplicating and inserting patterns didn't update the tree view properly.

Sample tab
- [New] <jh> Add Media Foundation (AAC, WMA, ASF, MP1, MP2, MP3, WAV-MSADPCM, ...) sample decoding support on Windows 7 and later (http://bugs.openmpt.org/view.php?id=422).
- [New] <jh> Support loading OggFlac sample files.
- [Imp] <js> Added dropdown menu to New button for duplicating samples.
- [Imp] <jh> Add a dropdown menu to the Open button which allows explicitly importing only known sample formats or only raw samples. This allows importing known formats as raw samples as well as allows avoiding the possibility of raw samples getting mis-interpreted as some known format.
- [Imp] <js> Don't reset sample draw status when modifying a sample.
- [Imp] <js> Show dB values for volume and percentage for panning in tooltip.
- [Fix] <js> Time stretch ratio calculator was always based on the current tempo, not on the user-supplied tempo.

Instrument tab
- [Imp] <js> Added dropdown menu to New button for duplicating instruments.
- [Imp] <js> Pitch/Pan Separation note list uses tuning note names.
- [Imp] <js> Show dB values for volume and percentage for panning in tooltip.

Tree view
- [Mod] <js> Sample / instrument preview is now stopped using Note Cut / Off / Fade keys instead of automatically fading out after some seconds.
- [Fix] <js> Dropping files made the tree view inaccessible until a new drag & drop action was initiated (tx coda).
- [Fix] <js> Previewing UAX samples played them at the wrong frequency.

VST / DMO Plugins
- [New] <js> Instrument random variation is now applied to the velocity of notes sent to instrument plugins.
- [New] <js> Tremor (Ixx) is now also supported for instrument plugins (http://forum.openmpt.org/index.php?topic=2736.0).
- [New] <js> Added hidden setting "VST Plugins.EnableAutoSuspend" which activates plugin auto-suspension for all plugins (later, this will be configurable per plugin). If a plugin didn't emit any sound during the last four seconds, its sound output is automatically suspended.
- [New] <js> It is now possible to override the project path reported to plugins (some plugins can store data alongside the module file) by using the hidden setting "VST Plugins.ProjectPath". In the setting value, %1 is replaced by the module path and %2 by the module filename (tx zetaPRIME).
- [Imp] <js> Automatically create instruments for newly added instrument plugins (http://forum.openmpt.org/index.php?topic=2867.0).
- [Imp] <js> Indicate bitness of non-native plugins in the plugin selection dialog.
- [Imp] <js> The default plugin editor is now DPI-aware.
- [Imp] <js> Allow sending incoming MIDI notes to plugins even if no instrument is assigned to them (pass data as-is).
- [Imp] <js> Loading and restoring missing plugins now also works when adding them through the Scan Folder button.
- [Fix] <js> Some VST plugins (e.g. SmartElectronix Ambience) write directly to the memory chunk that is passed to them when loading preset files. This memory block was not writeable since OpenMPT 1.22 and thus caused a crash.
- [Fix] <js> In OpenMPT 1.24, no more than one missing plugin was reported after loading a module.

VST::Specific Plugin Fixes
- [Fix] <js> HERCs Abakos stopped working in OpenMPT 1.22.02.00.

VST::Plugin Bridge
- [Imp] <js> Added support for audioMasterGetChunkFile opcode.
- [Fix] <js> MIDI events sent to 64-bit plugins or 64-bit OpenMPT were garbled.
- [Fix] <js> A couple of plugins whose editor previously froze (e.g. 4klang) will now work fine.
- [Fix] <js> KORG M1 crashed if the editor of more than one shared instance was opened (http://bugs.openmpt.org/view.php?id=683).

Playback
- [Imp] <js> Improve NNA channel allocation by also taking volume envelopes into account: If all NNA channels are used and are playing at full note volume, but are effectively muted due to their volume envelope, they can now be reused.
- [Fix] <js> Crash when playing extremely high-pitched samples.

MPTM
- [New] <js> Support for decimal default tempo (e.g. 123.45 BPM). Note that it is not possible to set decimal tempos using pattern commands yet (http://bugs.openmpt.org/view.php?id=145).
- [New] <js> Support for decimal tempo for instruments' pitch/tempo lock.
- [New] <js> In modern tempo mode, a swing factor can be configured which determines how much every row of a beat contributes to the beat (globally in the Song Properties and per pattern in the Pattern Properties). Unlike manual tempo changes, this will not mess up the timing information sent to plugins (http://bugs.openmpt.org/view.php?id=506).
- [Mod] <js> Newly created MPTM files use modern tempo mode and extended filter range.
- [Fix] <js> Fix potential misreading of some global song settings (was very unlikely to happen).

MPTM::Custom Tuning
- [New] <js> 'd' and '+' can now be used in note names.
- [Mod] <js> Behaviour change: When executing tone portamento and the sample doesn't change between the notes, re-apply the sample settings such as default volume and panning like with normal samples.
- [Fix] <js> Editing a tuning's note name no longer requires to remove the octave number first.

IT::Compatible Playback Mode
- [Fix] <js> Position jump effect on the same row as a pattern loop end immediately cuts the pattern loop.

XM
- [Imp] <js> Detect files made with MilkyTracker 0.90.87 or later and enable FT2 pan law for them.

S3M
- [Fix] <js> In S3M files not made with OpenMPT or Scream Tracker, support portamento between different samples again like in old versions of ModPlug Tracker (fixes k_vision.s3m, made in IT).

MOD
- [Mod] <js> Heuristically enable ProTracker 1/2 mode if 8xx commands seem likely to be used as sync markers rather than panning in 4-channel MODs.
- [Mod] <js> Treat EXO8 modules to have paired patterns like FLT8 modules.
- [Fix] <js> As in XM and IT, don't reset pattern loop counter on pattern breaks.

Other formats
- [Fix] <js> MT2: Don't load samples for instruments which already have a VST instrument assigned.
- [Fix] <js> Fixed crashes with malformed MED and MDL files and hangs with some truncated compressed IT samples.

Stream Export
- [New] <js> It is now possible to export to a sample slot rather than a file (http://bugs.openmpt.org/view.php?id=561).

Audio I/O
- [Mod] <jh> Add Debug.StopSoundDeviceBeforeDump (default false) setting and change the default behaviour to stop the audio device after dumping the crash information. This helps debugging crashes inside the audio thread with the default settings.
- [Mod] <jh> Remove "Sound Settings.Enable*" hidden settings. Allow switching off individual sound device backends via "Components.Block*" instead.
- [Fix] <jh> PortAudio latency calculation was wrong for WASAPI exclusive mode devices.
- [Fix] <jh> WaveRT devices are now shown as such (instead of WDM-KS) in the options.
- [Fix] <jh> Under increased system load, it was possible that WaveRT devices would stop rendering audio.

Misc
- [New] <js> In the settings dialog, the default artist name and default behaviour for new files (module type / template) can now be specified on the General tab.
- [New] <js> Add the possibility to forget all song window settings in the Display settings.
- [New] <js> Hidden setting Misc.AllowMultipleCommandsPerKey added to allow more than one keyboard shortcut being bound to the same key combination (may do unexpected things with existing mappings with overlapping shortcuts, so beware).
- [Imp] <js> Add dropdown menus to "New" and "MIDI Record" buttons in the main toolbar to select file type and MIDI device respectively.
- [Imp] <js> Tuning dialog: Mouse wheel can now be used to scroll the note map.
- [Mod] <js> Default directories and auto save settings have been merged into a new "Paths / Auto Save" settings tab. "Create backup files" has been moved there as well. "MIDI Record" option has been moved to the MIDI setup.
- [Mod] <jh> Show more useful information in the About dialog.
- [Mod] <jh> More defensive CPU feature detection for really old CPUs.
- [Fix] <js> Using Win+Space to change the Windows input language now takes effect immediately and no longer locks command input.
- [Fix] <jh> UnRAR code required Windows XP, while the rest of the code also works with Windows 2000. Drop the version requirement back to Windows 2000.
- [Fix] <js> Song duration estimation: Pattern loops were only calculated correctly when placed on the last channel. Pattern breaks leading to a row greater than the current pattern's size were not computed correctly.
- [Fix] <js> Fix possible crash when changing the number of channels, mostly happening when appending modules.
- [Fix] <js> When saving an external sample fails while closing the module containing the sample, the module remains open so that the user can investigate the problem.
- [Fix] <js> Hideable message box visibility settings were read from the wrong settings variable since OpenMPT 1.22.07.00.

Third-Party Libraries
- [Imp] Update lhasa (v0.3.0), SoundTouch (v1.9) and UnRAR (v5.3.2).

Installer/release package
- [Mod] <js> A great new set of example songs, with a number of free to use samples in "ExampleSongs\Samples" folder.
- [Mod] <js> Installer now places the OpenMPT icon directly in the Start menu rather than a subfolder.
- [Mod] <js> Updated US_it2_(lpchip).mkb.


v1.24.04.00 (19 April 2015, revision 4951)
------------------------------------------
Pattern tab
- [Fix] <js> Seeking with sample sync didn't apply portamento and note delay + row delay combinations accurately in some cases.

Playback
- [Fix] <js> On rows with a row delay effect, offset commands were executed on every row repetition in the previous version.

IT::Compatible Playback Mode
- [Fix] <js> Note delays are capped by the ticks per row + fine pattern delay tick count, not taking row delay into account.

MOD::ProTracker 1/2 Mode
- [Fix] <js> Instrument swapping is also applied if there was an empty sample slot "playing" (fixes arpeggios in "mr gang !!!." by arios).

Misc
- [Fix] <jh> There was a major performance regression in the previous version, mostly noticeable on Wine.


v1.24.03.00 (18 April 2015, revision 4941)
------------------------------------------
General tab
- [Fix] <js> The "Set" button for updating plugin parameters was still present by accident. Clicking the button could lead to problems with descriptive parameter values (tx eightbitbubsy).

Pattern tab
- [New] <js> Can now transpose a whole channel in all patterns via the channel header context menu (including a new shortcut).
- [New] <js> New fade curves in amplification dialog: Exponential, Logarithmic, Square Root, Quarter Sine, Half Sine.
- [Imp] <js> Greatly improved seek performance when "Maintain sample sync on seek" is enabled.
- [Mod] <js> Remove arbitrary limiting of the order list scrollbar to the first stop index in MOD / XM.
- [Fix] <js> Continuous scroll didn't work when entering chords (http://bugs.openmpt.org/view.php?id=132).
- [Fix] <js> Volume column offset command was still being displayed in the Note Properties for IT files (http://bugs.openmpt.org/view.php?id=647).
- [Fix] <js> When only enabling Amiga limits for MOD but not ProTracker 1/2 mode, invalid notes were not coloured as such.
- [Fix] <js> When switching between modules or resizing the window, it was possible for the pattern display to show garbage (http://bugs.openmpt.org/view.php?id=665).
- [Fix] <js> Clicking on the first and last item of an order selection loses the selection, like clicking any other item.
- [Fix] <js> Seeking with sample sync could misbehave when encountering PC events.

Sample tab
- [New] <js> The MPTM volume column offset command has been revamped: 9 custom cue points can be selected for each sample in the waveform's context menu, which can then be triggered using o01...o09 (http://bugs.openmpt.org/view.php?id=91).
- [New] <js> Crossfader can now use constant power (instead of constant volume) fade law for even smoother loop transitions. The sample can now optionally be faded back to its original content after the loop end. 
- [New] <js> New fade curves in amplification dialog: Exponential, Logarithmic, Square Root, Quarter Sine, Half Sine.
- [Mod] <js> Middle-C finetune adjustments are now made in cents (1/100th of a semitone) instead of Hertz.
- [Fix] <js> Inputting a new middle-C frequency created an undo step for every entered digit.
- [Fix] <js> Pitch shift was broken for stereo samples.

Instrument tab
- [New] <js> Can now load and save envelopes (http://bugs.openmpt.org/view.php?id=398).
- [Imp] <js> Entering a negative envelope scaling factor also yields sensible results for the volume and filter envelope now.
- [Mod] <js> Apply DNA and NNA settings to released notes when previewing notes (http://bugs.openmpt.org/view.php?id=437).

Tree view
- [Imp] <js> Show the missing samples dialog when using "Reload All" if there are any missing samples left.
- [Fix] <js> Preview was detuned for some samples (http://bugs.openmpt.org/view.php?id=14).

Mod Conversion
- [Fix] <js> Tempo commands broke when converting XM to MOD.

VST / DMO Plugins
- [New] <js> Plugin editors now have minimize / maximize buttons, which can be used to shrink a plugin window to only display the title and menu bar.

Playback
- [Fix] <js> With "loop song" disabled, the loop detection was a bit too aggressive and would stop playback when encountering nested pattern loops.

IT
- [Fix] <js> Tick-0 effects were not executed on the first tick of row repetitions (pattern delay effect) since OpenMPT 1.23.

XM
- [Fix] <js> Out-of-range global volume commands should not be ignored in XM (fixes "Reflecter" by Zodiak).

S3M
- [Fix] <js> Properly limit sample frequency and cut the sample when sliding too high.
- [Fix] <js> Tick-0 effects were not executed on the first tick of row repetitions (pattern delay effect) since OpenMPT 1.23.

MOD::Loading
- [Imp] <js> VBlank heuristic: Do not use VBlank timing if it results in a longer tune than regular CIA timing (http://bugs.openmpt.org/view.php?id=654).

MOD::ProTracker 1/2 Mode
- [New] <js> Support for ProTracker oneshot loops: If the loop start is right at the start of the sample, play through the whole sample once and then repeat just the loop part.

Other formats
- [New] <js> Can now read PLM (Disorder Tracker 2) files.
- [Mod] <js> Allow loading PAT instruments with 0 layers (such as DOO.PAT from the original GUS sample set).
- [Fix] <js> PTM: The weird behaviour of the panning command I observed was due to DOSBox' broken GUS panning. Now panning commands are imported as expected again.

Audio I/O
- [Mod] <jh> Allow smaller buffer sizes for Wave Out devices.

Misc
- [Imp] <js> Song length estimation: Properly handle panning, parameter extension (#xx), and tempo / volume slides that are on the same row as a set speed effect.
- [Imp] <jh> VU meter's decay speed is now configurable via hidden setting "Display.VuMeterDecaySpeedDecibelPerSecond". Default value is 88.
- [Mod] <js> No longer mark module as modified when switching between sequences (http://bugs.openmpt.org/view.php?id=141).
- [Fix] <js> The bold and italic styles were ignored on custom pattern and comments fonts.
- [Fix] <js> It was possible to switch song tabs while being in a modal dialog, which could lead to crashes when exiting the dialog.
- [Fix] <js> Tooltips were missing in some windows in the 32-bit build (http://bugs.openmpt.org/view.php?id=646).
- [Fix] <js> Channel Manager window was not sized properly.
- [Fix] <jh> OpenMPT 1.24 was previously no longer running on Windows 98 + KernelEx.

Third-Party Libraries
- [Imp] Update UnRAR (v5.2.6).


v1.24.02.00 (16 February 2015, revision 4761)
---------------------------------------------
Pattern tab
- [New] <js> Added support for custom pattern fonts as well as upscaled variants of the built-in fonts for High-DPI devices.
- [Imp] <js> Data entry shortcuts / scroll wheel do now take the default volume into consideration, i.e. when making a data entry in an empty volume column field next to a note, a volume command is inserted (http://forum.openmpt.org/index.php?topic=5411.0).
- [Imp] <js> Show verbose effect descriptions in the status bar instead of the short versions (http://bugs.openmpt.org/view.php?id=51).
- [Imp] <js> Note-offs from past notes are no longer written when recording notes into patterns (http://bugs.openmpt.org/view.php?id=645).
- [Mod] <js> In IT and XM, the o command (Offset) can no longer be entered into the volume column, as it's an OpenMPT-specific command. Old files using this command will still play as intended. 
- [Fix] <js> The Parameter Editor refused to work under random conditions.

Sample tab
- [New] <js> Added new shortcuts to center waveform around loop points.
- [Fix] <js> Splitting a stereo sample into mono samples didn't update the sample list in other tabs.

Instrument tab
- [Fix] <js> Plugin list was updated on every instrument change, leading to a small but noticeable performance drop.

Comments tab
- [New] <js> It is now possible to use a custom font for displaying module comments.

Tree view
- [Fix] <js> When converting samples to instruments, the instrument folder in the tree view was not updated properly (tx eightbitbubsy).
- [Fix] <js> OpenMPT 1.24 introduced a perceivable delay when loading samples for preview.

Mod Conversion
- [Imp] <js> Properly convert between IT / MPTM Hxx and XM 4xx vibrato depth.

Playback
- [Fix] <js> Vibrato was too weak in IT / MPTM with linear frequency slides since the previous version (http://bugs.openmpt.org/view.php?id=623).
- [Fix] <js> Fine portamento was sometimes too weak in IT / MPTM with linear frequency slides since the previous version.

IT
- [Mod] <js> Allow loading IT files with tempo 31 normally.

IT::Compatible Playback Mode
- [Fix] <js> Default sample and instrument panning is only reset by notes, not instrument numbers.
- [Fix] <js> Panbrello is not reset until the next note or panning command.

MOD
- [Mod] <js> To match ProTracker, the portamento target is no longer reset when a new note is encountered (like in FT2), but it is reset when the target is reached (like in IT). Fixes the intro in nuhanenatanssi.mod.
- [Fix] <jh> Fixed random crash in ProTracker 1/2 mode when using on-the-fly sample swapping (http://bugs.openmpt.org/view.php?id=626).

Other formats
- [Fix] <js> STM: Samples were not loaded correctly in some files, e.g. fracture in space" by Purple Motion (tx deus-ex, http://www.un4seen.com/forum/?topic=15448.msg113496#msg113496)
- [Fix] <js> STM: Volume slide nibbles are now prioritized correctly (fixes "fracture in space" by Purple Motion).

Stream Export
- [Mod] <jh> Remove >48 KHz support for Vorbis export. Even though Vorbis supports these sampling rates, it's not tuned for them, and using >48 KHz for any lossy codec generally does not make any sense at all.
- [Fix] <jh> Detection of available MP3 encoders was sometimes broken in the previous version.

Audio I/O
- [New] <jh> Added hidden options EnableWaveOut, EnableDirectSound, EnableASIO, EnablePortAudioWASAPI, EnablePortudioWDM-KS, EnablePortAudioDS, EnablePortAudioASIO in [Sound Settings] to disable certain types of audio drivers, if required for debugging.

Misc
- [New] <jh> Added hidden settings "Debug.StopSoundDeviceOnCrash" (default true) and "Debug.TraceAlwaysDump" (default false) which can be useful to debug sound device related problems that do not manifest in a crash.
- [Imp] <js> Various parts of the program are now DPI-aware: Parameter editor, pattern editor, channel manager, plugin manager, splitter positions, MIDI Input/Output Plugin
- [Fix] <js> When using the Song Properties dialog to change some properties of an IT file, re-saving the file always popped up the Save As dialog.


v1.24.01.00 (21 December 2014, revision 4662)
---------------------------------------------
General tab
- [Imp] <js> Clicking on the song type opens Song Properties dialog.
- [Imp] <js> If available, show a descriptive parameter value for plugin parameters instead of its numerical representation.

Pattern tab
- [New] <js> Ctrl + (Shift +) Scroll wheel can now be used as a replacement for the "(Coarse) Data Entry" shortcuts (http://bugs.openmpt.org/view.php?id=613).
- [Imp] <js> When previewing instruments with a fadeout value of 0, instantly stop them on key-up instead of letting them play forever.
- [Fix] <js> "Continue song as soon as MIDI notes are being received" didn't work in some situations.
- [Fix] <js> When using "Continue song as soon as MIDI notes are being received", the Edit Step setting was erroneously applied to the first note.
- [Fix] <js> When dragging a selection in the order list one order to the right, the document was marked as modified even though there was no change.
- [Fix] <js> Fixed crash when a module has no patterns at all.
- [Fix] <js> When only one parameter column was selected, the interpolation context menu didn't offer to interpolate this column.

Sample tab
- [New] <js> Support resampling to any arbitrary sampling rate using r8brain-free. Includes new keyboard shortcuts for upsampling, downsampling and resampling.
- [New] <js> As upsampling no longer automatically converts the sample to 16-bit, 16-bit conversion is now a separate option.
- [New] <js> Custom background and selection colours can now be specified (http://bugs.openmpt.org/view.php?id=371).
- [Imp] <js> Adjusting the sample frequency updates all playing notes' sample frequency (only works with IT and MPTM for now).
- [Imp] <js> Improved sample loop point input behaviour so that a loop start value greater than the current loop end value can be entered without having to enter the new loop end first.
- [Imp] <js> Finetune and transpose modifications are now undo-able.
- [Imp] <js> Visually distinguish sustain loop and sample grid markers.
- [Imp] <js> No longer show unsupported sample vibrato types in IT (Ramp Up) and XM (Random).
- [Fix] <js> Ramp Up and Ramp Down labels in XM vibrato settings were swapped since forever.
- [Fix] <js> When editing XM vibrato settings, the edit cursor always jumped back to the first character in the edit field.
- [Fix] <js> Rearranging samples (e.g. through song cleanup or the tree view) no longer messes up the undo buffer history (http://bugs.openmpt.org/view.php?id=600).
- [Fix] <js> The sample transpose dropdown was missing two complete octaves. The range has been extended and turned upside down (can now be understood intuitively as "C-5 is being played like note x").
- [Fix] <js> Silencing a single sample point lead to a crash (http://bugs.openmpt.org/view.php?id=610).

Instrument tab
- [New] <js> ITI instrument files can now contain external samples (like MPTM files). Select "Impulse Tracker Instruments with external Samples" from the save dialog (http://forum.openmpt.org/index.php?topic=2515.0).
- [New] <js> The first instrument of a soundfont can now be loaded directly without registering the soundfont in OpenMPT.
- [New] <js> Custom background colour can now be specified.
- [Imp] <js> Since Impulse Tracker's fade-out value is 32 times less precise than what is displayed in the editor, automatically round it when the user makes fade-out adjustments in IT files.
- [Imp] <js> When previewing instruments with a fadeout value of 0, instantly stop them on key-up instead of letting them play forever.
- [Mod] <js> Disallow OpenMPT-only "attack" setting to be used in IT and XM files. Old files using this setting still play as intended.
- [Fix] <js> When loading an instrument, force all sample views of the same module to be updated.
- [Fix] <js> Modifying envelopes using the keyboard didn't mark the module as modified.

Tree view
- [New] <js> Dropping a module or folder on the sample browser opens this module or folder for browsing.
- [New] <js> Dropping a soundfont file on the upper part of the tree view adds it to the list of soundfonts.
- [New] <js> Due to the change from external instruments in the ITP format to external samples in MPTM, "Set Path" and "Save" have been moved to samples. External samples are marked with [external], missing external samples are marked with [missing].
- [New] <js> Sample waveforms can now be reloaded from disk (e.g. after editing a sample in an external application) if OpenMPT knows the sample's original path, e.g. after loading or saving it, or using MPTM's external sample feature (http://bugs.openmpt.org/view.php?id=207).
- [New] <js> The first instrument of a soundfont can now be previewed directly from the sample browser (without registering the soundfont in OpenMPT).
- [Mod] <js> Apparently, some versions of Ableton Live mark exported WAV files as "temporary". Such files are no longer ignored in the sample browser.
- [Fix] <js> Duplicating samples was broken in OpenMPT 1.23.
- [Fix] <js> Previewing IMA ADPCM-compressed samples from the tree view was broken if the previously previewed sample was a stereo sample.

Mod Conversion
- [Imp] <js> When converting from IT / MPTM to XM, move volume column portamento to the effect column if possible, as it has a different meaning in XM.
- [Fix] <js> When converting from XM to IT / MPTM, volume column effects were not always limited properly.

VST / DMO Plugins
- [Imp] <js> When adding a new plugin through the plugin manager that is missing from some open file, it is now automatically loaded and restored in that file.
- [Imp] <js> "Randomize Parameters" now applies a customizable randomization factor - much more useful than completely random parameters.
- [Fix] <js> Regularly send editor idle commands to plugins with open editors.

VST::Plugin Bridge
- [Imp] <js> The plugin bridge does now also create crash dumps automatically. OpenMPT's /fullMemDump command line switch also applies to these dumps.
- [Mod] <js> By default, all instances of the same plugin do now share one bridge process, since a handful of plugins require this - and the loading performance is much better, too.
- [Fix] <js> Catch potential crashes while loading the plugin, like in OpenMPT (fixes instant crashes with multiple instances of SideKick v3 in different processes).

Playback
- [New] <js> S70 / S71 / S72 commands do now also work with instrument plugins.
- [Imp] <js> Smooth MIDI macros do now, to some extent, work with external MIDI messages. They interpolate from the previous Zxx or \xx parameter from the same channel to the new parameter.
- [Mod] <js> In all mix modes since 1.17RC2, a way too long volume ramp (some times up to 100 times longer than the user-supplied ramp setup) was applied for extreme global volume changes. This is now disabled except for legacy 1.17RC2 mix mode.
- [Mod] <js> Re-implemented stereo separation to be applied on the master mix. This means that it also works as expected with stereo samples and plugins now.
- [Fix] <js> NNA / DCA settings were not applied properly to plugins assigned to sample-less instruments.
- [Fix] <js> Instrument plugin arpeggio was executed on muted channels / instruments.
- [Fix] <js> Linear frequency slide mode (in all formats except XM, which already worked as intended) has been re-implemented to fix some unwanted inaccuracies which can add up very quickly when using extra-fine slides.
- [Fix] <js> Glissando should only affect tone portamento, not portamento up / down effects.

MTPM
- [New] <js> MPTM files can now contain external (on-disk) samples. When checking the "Keep sample on disk" checkbox in the sample editor, the sample data is not stored directly in the MPTM file but a relative link to the original sample file is kept (http://bugs.openmpt.org/view.php?id=368).

IT
- [Imp] <js> Added support for reading encrypted edit time in old IT files with no edit history present (discovered through Impulse Tracker source release, yay).

XM
- [Mod] <js> Revert XM compatibility export to always write out 256 order items.
- [Fix] <js> Use "normal" compatible mix mode instead of FT2 panning mix mode for XM files that were compatibility-exported with OpenMPT 1.22 or older, and XM files made with other trackers that use linear panning.

XM::Compatible Playback Mode
- [Fix] <js> Make arpeggio after portamento effect behave even more like in Fasttracker 2.

S3M::Compatible Playback Mode
- [New] <js> Compatible playback mode for S3M: When enabled, OpenMPT emulates certain Scream Tracker quirks as it did until now (linked pattern effect memory and ignored effects on muted channels). Compatible mode is disabled automatically for files made with less compatible trackers. S3M files made with OpenMPT always have this mode enabled, and its state is not saved in S3M files.

MOD
- [Imp] <js> Amiga frequency limits can now also be enforced without activating ProTracker 1/2 mode.

MOD::Loading and Saving
- [Mod] <js> M.K. and M!K! files that only have Amiga-compatible notes in their patterns automatically enforce Amiga frequency limits now (http://bugs.openmpt.org/view.php?id=563).
- [Fix] <js> Saving a sample loop with an odd length is now handled better (http://bugs.openmpt.org/view.php?id=590).
- [Fix] <js> Any non-ASCII characters were accidentally removed when loading a MOD file (broke in OpenMPT 1.22).

MOD::ProTracker 1/2 Mode
- [Fix] <js> Glissando is only applied on rows with a portamento effect, and never on the first tick of these rows.

Other formats
- [New] <js> Added support for a MOD variant introduced by SoundTracker 2.6 and Ice Tracker (http://bugs.openmpt.org/view.php?id=597).
- [Imp] <js> SoundTracker auto-slides are now imported using the volume column.
- [Imp] <js> MT2: Completely rewrote loader. Some files that would previously not load properly do now load. Support for VST plugins, drum patterns and some extended MT2 pattern commands has been added.
- [Fix] <js> ITP: Always load embedded MIDI macros for files made with OpenMPT 1.19 or older, since back then they were always read, no matter if the embed flag was set or not.
- [Fix] <js> ITP: Loading extended song properties was broken since OpenMPT 1.21.
- [Reg] <js> ITP: Saving and editing ITP files is no longer supported. ITP files are now imported as normal IT files. ITP's functionality is superseded by MPTM's new external sample functionality.

Stream Export
- [Fix] <js> F00 "stop song" abort detection for XM files didn't abort if there were samples playing with a global volume of 0.

Module cleanup
- [New] <js> "Remove unused sample data" now also finds samples with identical stereo channels and offers to optimize them to mono.
- [Imp] <js> Give information about how many plugins were removed.
- [Fix] <js> Removing unused samples no longer creates two undo points per sample.

Audio I/O
- [New] <jh> Support direct mode for Wave Out devices. This is mostly useful on Wine systems where it (for certain setups) prevents the Wine-internal resampler from kicking in.
- [Imp] <jh> Increased latency and period precision to allow sub-millisecond latencies.
- [Imp] <jh> Added per-device type default audio settings.
- [Mod] <jh> Query PortAudio for the default latency of PortAudio sound devices.
- [Mod] <jh> When changing between mono / stereo / quad channel configurations, always reset the channel mapping to default instead of basing the new one on the previous one.
- [Mod] <jh> Add a hidden setting setting "Sound Settings.PreferSameTypeIfDeviceUnavailable" which optionally changes the algorithm for selecting the fallback device if the device selected by the user (or read from the configuration) is currently unavailable. When this setting is set, a device of the same type as the currently selected is preferred instead of just defaulting to wave mapper.
- [Fix] <jh> If the soundcard is currently unavailable, some ASIO drivers allow opening the driver and report zero input and output channels in that case. Other drivers do not support loading the driver. In both cases, OpenMPT will now disallow selecting the driver in the setup dialog and hide it until restarting OpenMPT or the sound devices get rescanned.

Misc
- [New] <js> Dropping a folder that contains modules or VST plugins opens / registers them directly now (http://bugs.openmpt.org/view.php?id=510).
- [New] <js> Remember window positions for each tune individually when it is being saved. Plugin window positions are now stored using the same mechanism instead of being embedded into the module files. (http://forum.openmpt.org/index.php?topic=3280.0).
- [New] <js> Added a first-start dialog to set up some common settings. The corresponding settings have been removed from the installer.
- [Imp] <js> Song length estimation: Slightly improve calculation of nested pattern loops (http://bugs.openmpt.org/view.php?id=591).
- [Imp] <js> Song length estimation shows the length of all "hidden" subtunes in the current sequence.
- [Imp] <js> Made the MIDI Mapping dialog's mapping list more human-readable.
- [Imp] <jh> VU Meter: Rear channels are now also shown in quad mode.
- [Mod] <js> When merging the default key map into a custom key map, event types are now completely ignored, so if e.g. the user has assigned a certain key on "key hold" but the default key map uses the same key on "key down" only, this version is no longer added.
- [Mod] <js> Autosave: When "Use song's original directory" is enabled, but the song has not been saved so far, it is now saved in a sub folder called "Autosave" instead of the root of the settings directory. In this case, modules created from templates are now also autosaved into this folder instead of the template folder.
- [Mod] <jh> Added setting LoadOnStartup in [Components] to optionally load all optional components (such as MP3 encoders, UNMO3, etc.) on startup rather than first use. KeepLoaded (also in [Components]) determines whether components stay in memory after they have been used (this is the default behaviour). 
- [Mod] <js> Rename "Colours" settings tab to "Display".
- [Fix] <js> Soft Panning check box in Mixer settings didn't work (http://bugs.openmpt.org/view.php?id=602).
- [Reg] <js> Removed noSettingsOnNewVersion command line switch. It's no longer necessary as there is also a hidden setting that does the same.

Third-Party Libraries
- [Imp] Update lhasa to version 2014-07-12 (adds support for lhx archives).
- [Imp] Update FLAC to v1.3.1 (improved decoding and encoding efficiency, fixed two vulnerabilities when loading malicious FLAC files).
- [Imp] Updated PortMidi to revision 228 (fixes potential 64-bit issues).


v1.23.05.00 (6 September 2014, revision 4238)
---------------------------------------------
Pattern tab
- [Imp] <js> "Edit Plugin assigned to PC Event" shortcut is now "Toggle PC Event/instrument plugin editor" (can now also be used to toggle the editor of the plugin assigned to the currently selected instrument).
- [Imp] <js> Deleting and inserting items in the order list automatically adjusts playback, sequence override and play lock positions.
- [Imp] <js> Greatly improve seek performance when "Maintain sample sync on seek" is enabled and there are samples with very small loops.
- [Imp] <js> When inserting a new pattern while a +++ or --- pattern is focussed in the order list, use the currently edited pattern for determining the new pattern's length.
- [Fix] <js> In windowed mode, the note properties dialog was not always visible.
- [Fix] <js> The order list's scrollbar's "Right Edge" menu entry was not working (http://bugs.openmpt.org/view.php?id=567).

Sample tab
- [Fix] <js> Enabling a sample loop when there were no loop points didn't update the loop point display.
- [Fix] <js> Silencing samples was slightly broken (http://bugs.openmpt.org/view.php?id=555).
- [Fix] <js> Undo could crash in some situations when the total undo buffer size previously exceeded the configured buffer limit.
- [Fix] <js> It was impossible to call the save dialog for a sample / instrument with a pipe character in the name (also applies to instrument tab, http://bugs.openmpt.org/view.php?id=564)
- [Fix] <js> Fixed possible crashes when using undo / redo, most notably when sample undo was disabled completely (http://bugs.openmpt.org/view.php?id=584).

Instrument tab
- [Imp] <js> In the sample map editor, show faint red dots for notes that are already assigned to another sample (http://forum.openmpt.org/index.php?topic=4112.msg37495#msg37495).
- [Fix] <js> Trying to play notes above B-9 caused a crash (http://bugs.openmpt.org/view.php?id=549).

Tree view
- [Fix] <js> Stopped voices sometimes still contributed to the active sample / instrument list (http://bugs.openmpt.org/view.php?id=568).

VST / DMO Plugins
- [New] <js> Plugin editor positions are now stored in module files.
- [Imp] <js> Allow drag and drop actions on plugin editors to drop preset files from Explorer.
- [Fix] <js> Program names starting with non-ASCII characters were not formatted properly.
- [Reg] <js> Partly reverted the behaviour introduced in OpenMPT 1.23.03.00 to only re-send patch numbers if they're not bank 1 patch 1, to fix legacy module playback.

Playback
- [Mod] <js> When resuming paused (not stopped) playback, previously playing samples are continued.
- [Fix] <js> "Maintain sample sync on seek" should now also work when playback was previously stopped.
- [Fix] <js> Glissando in semitones mode didn't take finetune into account (http://bugs.openmpt.org/view.php?id=585).

IT::Compatible Playback Mode
- [Fix] <js> Tone portamento target is now completely cleared with new notes, so that subsequent Gxx effects have no effect.

XM
- [Fix] <js> Clear MIDI macros for XM files made with FT2 to prevent Zxx effects from doing anything.
- [Fix] <js> Correct nominal dB values for FT2 pan law mix mode.

XM::Compatible Playback Mode
- [Fix] <js> Tentatively fix arpeggio after pitch slide behaviour (http://bugs.openmpt.org/view.php?id=542).

MOD::ProTracker 1/2 Mode
- [Fix] <js> ProTracker applies instrument changes on the first tick, even if there's a note delay (http://bugs.openmpt.org/view.php?id=574).
- [Fix] <js> Properly implemented ProTracker-style sample swapping, which is only supposed to happen at the end of the sample and not instantly.
- [Fix] <js> Correctly handle a few more edge cases of ProTracker-style 9xx offset handling.

Misc
- [New] <jh> Add hidden setting "Misc.ShowSettingsOnNewVersion" (default true) which can permanently disable showing of the settings dialog on new versions, in addition to the one-time command line switch /noSettingsOnNewVersion.
- [Imp] <js> Add support for 64-bit Vorbis library builds from mingw-w64 with slightly different file names.
- [Imp] <js> When adding a new shortcut that conflicts with an existing shortcut, do not automatically delete the existing shortcut but rather ask the user what to do.
- [Imp] <js> Add global dummy shortcut keybinding to prevent default keybindings from doing anything into if you don't like them (http://bugs.openmpt.org/view.php?id=550).
- [Imp] <js> Slightly improved icons for systems with 32-bit display mode but mysteriously missing alpha channel (http://bugs.openmpt.org/view.php?id=520).
- [Mod] <js> Merge "Note Off/Cut/Fade" and "Note Off/Cut/Fade (without instrument number)" to never write an instrument number next to those events.
- [Fix] <js> Scale main toolbar elements according to DPI settings (http://bugs.openmpt.org/view.php?id=513).
- [Fix] <js> Setting the default MIDI volume behaviour for new instruments in the Options dialog was broken.
- [Fix] <js> Potential fix for DDE error when launching OpenMPT through an associated file from Explorer (http://bugs.openmpt.org/view.php?id=461).
- [Fix] <js> After loading a new keybinding file, effect keys were no longer working until the user switched to a module with different effect keys (tx stinkbug).

Third-Party Libraries
- [Imp] Update UnRAR (v5.1.6).


v1.23.04.00 (14 June 2014, revision 4113)
-----------------------------------------
Pattern tab
- [New] <js> Added possibility to interpolate the instrument column.
- [Imp] <js> Stay at current order / pattern when removing something from the order list (http://bugs.openmpt.org/view.php?id=511).
- [Fix] <js> With overflow paste, marking the pasted pattern area was not working when the paste ended exactly in the last pattern row (broke in OpenMPT 1.23.02.00).
- [Fix] <js> Select / Copy Select keys should no longer interfere with mouse dragging (tx coda).
- [Fix] <js> Don't crash when the module doesn't have any patterns.
- [Fix] <jh> Fixed flickering of current-row highlight in pattern view on Wine (http://bugs.openmpt.org/view.php?id=522).

Sample tab
- [Fix] <js> Setting sustain loop points by typing the values in didn't update the waveform display.
- [Fix] <js> When removing DC offset from a sample, the wrong volume variable on channels currently playing the modified sample was modified.

Tree view
- [Fix] <js> It was not possible to drag and drop drums from sound banks (http://bugs.openmpt.org/view.php?id=536, x64 only).

VST / DMO Plugins
- [Imp] <js> Improve preset menu creation in the plugin editor for plugins with less than 128 presets, so that the menu is only created when needed (speeds up e.g. bridged VOPM).
- [Imp] <js> When trying to load a plugin where both the 32-bit and 64-bit version are registered in OpenMPT, prefer the native version.
- [Fix] <js> When trying to play notes in a VST GUI with no instrument assigned yet, prevent notes from being stuck after closing the instrument creation confirmation (tx coda).

VST::Plugin Bridge
- [Fix] <js> Don't crash when a plugin sends an opcode that isn't expected to have a data pointer set (http://bugs.openmpt.org/view.php?id=519).
- [Fix] <js> Unknown vendor-specific opcodes that send pointers are now rejected, as they cannot work over the bridge.

XM
- [Fix] <js> More intelligent extraction of the selected MIDI program for files that were not made with ModPlug.
- [Fix] <js> Loading ADPCM-compressed samples broke in OpenMPT 1.23 (http://bugs.openmpt.org/view.php?id=538).

S3M
- [Fix] <js> Some files created with Scream Tracker were detected as being made with Velvet Studio.

MOD
- [Fix] <js> Loading ADPCM-compressed samples was broken ever since OpenMPT 1.22.06.00.

Other formats
- [Fix] <js> IMF: Ignore note cut with a zero parameter.

Audio I/O
- [Mod] <jh> Default to 16-bit output on Wine, since some Wine versions apparently have problems with sample formats > 16bit.
- [Fix] <jh> DirectSound: Emulated drivers do not support primary buffer access. Actually test whether the device is emulated or not and do not advertise primary buffer support if it is.
- [Fix] <jh> Fix clamping / rounding of Wave Out and DirectSound buffer sizes for 24bit samples (http://bugs.openmpt.org/view.php?id=540).

Misc
- [Imp] <js> When loading plugins during startup, the error message that was potentially shown didn't appear in the task bar, making it easy to forget about such a half-initialized OpenMPT instance.
- [Fix] <js> Potential fix for a crash when loading modules through the command-line (tx coda).
- [Fix] <js> "Find MPT Hacks" erroneously identified FT2 pan law mix mode as a hack (http://bugs.openmpt.org/view.php?id=531).


v1.23.03.00 (4 May 2014, revision 4039)
---------------------------------------
VST / DMO Plugins
- [Mod] <js> If an instrument specifies a MIDI program / bank to be used, always re-send this information after restarting playback. Previously, this information was only resent during first play or when it was changed by the user. This fixes some external softsynths controlled through the MIDI I/O plugin.

Audio I/O
- [Fix] <jh> When upgrading from OpenMPT 1.23.01.00 to OpenMPT 1.23.02.00, it was possible that audio was now playing too slow instead of too fast.


v1.23.02.00 (3 May 2014, revision 4035)
---------------------------------------
General tab
- [Fix] <js> Moving plugins unintentionally broke the plugin chain in many cases (http://bugs.openmpt.org/view.php?id=514).

Pattern tab
- [Imp] <js> Don't require shift key to be pressed when entering numeric effect letters on French keyboards (http://forum.openmpt.org/index.php?topic=5279.0).
- [Imp] <js> Channel mute / channel mute on pattern transition shortcuts got extended to cover all channels covered by the selection instead of just the channel where the cursor is.
- [Mod] <js> After pasting pattern data, the pasted area is automatically selected (http://bugs.openmpt.org/view.php?id=498).
- [Fix] <js> When "loop pattern" was enabled, jumping between patterns could trigger sample syncing while playback was paused.
- [Fix] <js> Other small fixes in playback adjustment code when jumping around.
- [Fix] <js> Undoing channel deletion didn't work properly.
- [Fix] <js> Dragging an order selection also works if the first selection point isn't visible.

Sample tab
- [New] <js> Added sample transpose shortcuts to quickly change the middle-C frequency.
- [Fix] <js> Fade operation was broken in 64-bit builds (http://bugs.openmpt.org/view.php?id=507).
- [Fix] <js> Crossfading sample loops modified one sampling point too much, which couldn't be undone properly.
- [Imp] <js> WAV / FLAC saving: When there's only a sustain loop and no normal loop, ensure that it is treated as a sustain loop after reloading the sample (like it was done in older versions, tx dusthillguy).
- [Fix] <js> Load / Save / New shortcuts are now also handled properly when the upper panel is focussed.
- [Fix] <js> Adding silence to a sample that's not 8-bit mono broke in OpenMPT 1.23.

Tree view
- [New] <js> In the instrument library, Ctrl+Enter loads the selected instrument into the currently active sample / instrument editor window (http://bugs.openmpt.org/view.php?id=499).
- [Imp] <js> Ctrl+Enter starts label editing.

VST::Plugin Bridge
- [Fix] <js> Fixed KarmaFX EQ, a couple of VarietyOfSound plugins and possibly others that don't set any specific time flags, but still call audioMasterGetTime.

Playback
- [Imp] <js> For XM files, a new mix mode "Compatible (FT2 Pan Law)" has been added which is the same as the "compatible" mix mode, but this enforces FT2's pan law, while the "normal" compatible mix mode no longer does so. This should make tunes created with OpenMPT 1.22 or older not break drastically anymore if they make use of a lot of panning stuff.
- [Fix] <js> Fixed potential crash in 64-bit version when playing certain songs with instrument envelopes (tx xTr1m).

IT::Compatible Playback Mode
- [Fix] <js> Sustained envelopes were released too early if the loop end was hit on exactly the same tick as the note-off event.

MOD::ProTracker 1/2 Mode
- [Imp] <js> Added ProTracker-style offset when note but no instrument number is specified (fixes h0ffman's Revision 2014 tracked music entry).

Module cleanup
- [Fix] <js> Rearranging samples broke in the previous version (http://bugs.openmpt.org/view.php?id=497).

Audio I/O
- [Fix] <js> With new installations (and probably also upgraded ones), it was possible that OpenMPT was internally rendering at a different sample rate than the sound device was outputting (http://forum.openmpt.org/index.php?topic=5265.0).

Misc
- [Imp] <js> All parts of the Song Properties dialog are now updated instantly when switching between formats.
- [Imp] <js> Made S3M Amiga frequency limits option editable from the Song Properties dialog.
- [Mod] <js> Changed manual format from PDF to CHM. When opening help from certain dialogs, the relevant manual page is automatically opened.
- [Fix] <js> SF2 sample frequency conversion was broken in 64-bit builds (http://bugs.openmpt.org/view.php?id=508).
- [Fix] <js> Modifying patterns, samples, etc. should now always update other views of the same type of the same module properly.
- [Fix] <js> DefaultTemplate option was looking for the template file in the wrong paths.


v1.23.01.00 (29 March 2014, revision 3998)
------------------------------------------
General tab
- [New] <js> Added a tempo tap button. Click several times in a row to tap in the wanted beats per minute.
- [New] <js> Can now clone plugins (and entire plugin chains) to another slot (http://bugs.openmpt.org/view.php?id=35).
- [Imp] <js> When moving a plugin, the entire plugin chain starting from that plugin can now (optionally) be moved.
- [Imp] <js> Show real preset name instead of "current" in the plugin configuration (http://forum.openmpt.org/index.php?topic=3284.0).
- [Mod] <js> Allow editing the global volume in legacy XM files that still have it set to a non-default value.

Pattern tab
- [New] <js> Added redo functionality and named undo points.
- [New] <js> Experimental feature: Seeking in a module tries to keep sample sync. This only works under some basic conditions, e.g. samples with ping-pong loops or portamento effects are not supported. Can be enabled from the general options.
- [New] <js> Alt-clicking a channel header solos / unsolos the channel (tx Rapture).
- [Imp] <js> When right-clicking an order list item, playback no longer jumps to this item anymore if "Follow Song" is active.
- [Mod] <js> Unified note properties dialog from three tabs into one single dialog.
- [Mod] <js> Renamed "row spacing" to "edit step".
- [Fix] <js> Effect letter input does now work when a non-latin keyboard layout (e.g. Cyrillic) is being used (http://bugs.openmpt.org/view.php?id=478).
- [Fix] <js> "Copy Pattern" from the order list context menu didn't copy the last channel properly.
- [Fix] <js> Don't apply split note settings when entering special (^^, ==, etc.) notes.
- [Fix] <js> OpenMPT could crash when displaying default volumes was enabled and an instrument was deleted through the tree view (http://forum.openmpt.org/index.php?topic=5253.0).
- [Fix] <js> Quick Channel Settings: Moving the channel volume slider always disabled the surround settings (http://forum.openmpt.org/index.php?topic=5214.0).
- [Fix] <js> Parameter Editor: Initial point spacing was a bit off, so the last point was sometimes not visible.
- [Fix] <js> Channel Manager buttons are placed properly when using the WinXP theme (http://forum.openmpt.org/index.php?topic=3460.0).
- [Fix] <js> Sometimes, when changing the editor size (e.g. by maximizing a module window), the pattern would stop scrolling.

Sample tab
- [New] <js> Added redo functionality and named undo points.
- [New] <js> Added zoom levels greater than 1:1 (http://forum.openmpt.org/index.php?topic=3563.0).
- [Imp] <js> The sample grid is now visualised using dashed lines.
- [Imp] <js> Sample drawing is now also available for stereo samples.
- [Imp] <js> Sample tuner is now multi-threaded and uses SSE2 instructions when available (this speeds up the tool greatly for big samples).
- [Imp] <js> Slightly more stable frequency calculation when scrolling through the transpose list in IT / S3M formats.
- [Imp] <js> Use MIDI note velocity when previewing samples.
- [Imp] <js> When normalizing loaded samples, prevent their volume from being 0.
- [Mod] <js> Pitch shifting and time stretching does now also work for 8-bit samples without upsampling them first.
- [Fix] <js> Position marks do no longer flicker and disappear when desktop compositing (and thus, Aero) is turned on. The same fix is also applied to the envelope editor, where the problem was less pronounced (http://bugs.openmpt.org/view.php?id=372).
- [Fix] <js> When zooming into samples longer than 32767 sampling points, it was possible that the last few points were not visible (http://bugs.openmpt.org/view.php?id=162).
- [Fix] <js> The zoomed-out sample display was not always accurate on CPUs with AMD MMX extensions or SSE.
- [Fix] <js> With sample selections > 1 second, the fractional part of the selection length was not displayed correctly.

Instrument tab
- [New] <js> Shift-clicking the pitch / tempo lock checkbox enables / disables the lock for all instruments (http://forum.openmpt.org/index.php?topic=5212.0).
- [Fix] <js> Sample slots occupied by the last instrument could be overwritten when loading a new instrument into another slot (http://forum.openmpt.org/index.php?topic=5253.0).
- [Fix] <js> Note preview always uses lowpass filter if "Channel default" filter type is specified. Previously, this was random and depended on how the playback channel has been used previously.
- [Fix] <js> XM panning envelope points should have a range of 0...63 instead of 0...64 (whyyyyy).
- [Fix] <js> Envelopes longer than 32767 ticks can now be scrolled correctly.
- [Fix] <js> Envelope grid is now also displayed correctly on Windows 98.

Tree view
- [New] <js> Double-clicking the instrument library path opens a folder browser dialog to quickly browse to a new location.
- [New] <js> The instrument library is now refreshed automatically when there are changes in the folder (e.g. adding new files).
- [New] <js> Backspace can now be used to go up one directory in the instrument library.
- [Imp] <js> Reduce flicker when sample / instrument status live update is enabled.
- [Imp] <js> Shift + Del in instrument library deletes files permanently (like in Windows Explorer).
- [Mod] <js> If "no loud samples" is enabled, the treeview preview is as loud as it would be in the currently active module's sample editor. Otherwise, it's played at 0dB as before (http://forum.openmpt.org/index.php?topic=5234.0).
- [Fix] <js> Selecting a pattern from the tree view to edit automatically set the document as modified.

Mod Conversion
- [Imp] <js> When converting to MOD, try to compensate for the lack of sample transpose by transposing pattern notes.
- [Imp] <js> When converting to MOD, write default speed and tempo to patterns, if possible.
- [Fix] <js> When converting an IT or XM with instruments to S3M or MOD, the last instrument was not deleted properly, which could lead to some strange sounds until the file would be re-opened.
- [Fix] <js> When converting from XM to MOD, the sample transpose wasn't reset.

VST / DMO Plugins
- [New] <js> Official plugin bridge that you can use to run 64-bit plugins in 32-bit OpenMPT and vice versa, or even plugins of the same bitness as OpenMPT if necessary. Can be enabled per plugin from the plugin manager, or can be force-enabled by setting "VST Plugins.BridgeAllPlugins" to 1.
- [New] <js> The arpeggio pattern effect is now also sent to instrument plugins (http://bugs.openmpt.org/view.php?id=479).
- [New] <js> Added an option in the plugin manager to scan a folder (including subfolders) for plugins (http://forum.openmpt.org/index.php?topic=1692.0).
- [Imp] <js> Raised plugin limit from 100 to 250.
- [Imp] <jh> Actual output latency is now passed to plugins that query it (instead of user's wanted latency).
- [Imp] <js> Plugin Selection Dialog: The up / down keys can be used to select a plugin while the name filter is focussed.
- [Imp] <js> Plugin Selection Dialog: Plugin paths are displayed in a scrollable text box now, so that the complete path can be seen in case it's too long.
- [Imp] <js> Implemented audioMasterGetChunkFile opcode.
- [Imp] <js> Implemented more timing information for plugins that want it.
- [Imp] <js> When rescanning plugins on startup is taking too long, show a progress dialog.
- [Mod] <js> Optimize VST window redrawing a little bit by not filling the window with the default background colour (removes flicker when resizing plugin windows).
- [Fix] <js> OpenMPT should no longer "forget" plugins randomly (http://bugs.openmpt.org/view.php?id=18).
- [Fix] <js> Plugins with same internal ID should no longer confuse OpenMPT's plugin cache (http://bugs.openmpt.org/view.php?id=25).
- [Fix] <js> Some plugins could produce a crash when using the buffer clearing option in export (tx coda).
- [Fix] <js> When recording a plugin's MIDI output, avoid it from being directed back to the same plugin's editor window.
- [Fix] <js> Plugin version is no longer checked when loading preset files (old OpenMPT wrote other values there, so some old presets were no longer readable).
- [Fix] <js> Plugin editor keyboard focus was lost after loading or saving plugin presets (http://bugs.openmpt.org/view.php?id=456).
- [Fix] <js> Don't add no longer existing plugins used in a module file to the list of known plugins after they have been found in the cache (http://forum.openmpt.org/index.php?topic=2304.0).
- [Fix] <js> Presets > 1000 can now also be selected in the plugin editor.
- [Reg] <js> Removed native jBridge support in favour of our own bridge. you can still use jBridge using the default method of plugin stubs, of course.

VST::Specific Plugin Fixes
- [Fix] <js> Poise by One Small Clue should no longer crash if the editor is still open when unloading the plugin (tx coda).
- [Fix] <js> AAS Strum Acoustic GS-1 and Strum Electric GS-1 no longer crash on startup (http://bugs.openmpt.org/view.php?id=454).
- [Fix] <js> ProteusVX no longer breaks OpenMPT's plugin window (http://bugs.openmpt.org/view.php?id=79).
- [Fix] <js> Fixed problems with Korg Wavestation (notes not being triggered / ghost notes) when using the panic button or jumping around in the sequence.

Playback
- [Fix] <js> When interpolation is enabled, interpolated values are no longer read from beyond the loop end, which could lead to clicks and other problems (http://bugs.openmpt.org/view.php?id=304).
- [Fix] <js> Don't potentially crash if the restart order position is followed by nothing but skip patterns.
- [Fix] <js> Glissando should now behave more as one expects in compatible mode (no longer resets after portamentos).
- [Fix] <js> Very small ping-pong loops were detuned sometimes, depending on the mixing frequency (http://schismtracker.org/scdev/read/1447/).
- [Fix] <js> Envelope carry was broken on sample-less channels (only relevant when using envelopes to automate plugins).

MPTM
- [Fix] <js> Loading some modules made with older versions of OpenMPT could produce wrong results when fixing pattern delays if there were parameter control events (since OpenMPT 1.22.06.00).

IT
- [Fix] <js> IT / MPTM instruments referencing sample slots >= 256 from versions older than OpenMPT 1.20 were not readable (http://bugs.openmpt.org/view.php?id=448).
- [Fix] <js> Legacy MPTM file detection could make OpenMPT assume that some valid IT files were invalid MPTM files in some extremely rare cases (tx stinkbug).

IT::Compatible Playback Mode
- [Fix] <js> Panbrello random waveform takes speed parameter into account now. The speed parameter determines for how many ticks the random value should be held.
- [Fix] <js> S5x resets panbrello phase.
- [Fix] <js> If there's a note delay, slide commands in the volume column next to it should not start before the delay has finished.

XM
- [Mod] <js> Volume column panning commands are now imported in the same "dumb" way (16 commands ranging from 0 to 60 instead of 0 to 64) as in FT2 and OpenMPT prior to version 1.20.
- [Mod] <js> For increased compatibility with FT2, the "compatible" mix mode uses the square root pan law (instead of linear pan law) when playing XMs.
- [Fix] <js> Support F00 "stop song" behaviour (it actually just sets the ticks per row to 65536 in FT2, so we can emulate that easily).
- [Fix] <js> Some rare files with malformed sample headers were not loading correctly anymore since OpenMPT 1.20.04.00.

XM::Compatible Playback Mode
- [Fix] <js> The E90 command retriggers the note instantly and only once per row.
- [Fix] <js> Lxx actually sets the panning envelope position if the volume envelope's sustain flag is set.
- [Fix] <js> If there's a note delay, volume column effects are not executed on the first tick and, if there's an instrument number, not on the delayed start tick.
- [Fix] <js> Mind-boggling combinations of portamento and note delay should now behave as in FT2.
- [Fix] <js> The lowest 3 bits of finetune are ignored (must be multiple of 8).
- [Fix] <js> Frequency wrap-around behaviour has been refined a bit to work more like in FT2.
- [Fix] <js> Output period is clamped to 1...31999 (very theoretical range that should only be exceeded with overflowing portamentos).

S3M
- [Fix] <js> If the sample number next to a portamento effect differs from the previous number, the old sample is now kept, but the new default volume is being applied (http://bugs.openmpt.org/view.php?id=474).

MOD
- [Fix] <js> If the sample number next to a portamento effect differs from the previous number, the old sample is now kept, but the new default volume is being applied (http://bugs.openmpt.org/view.php?id=474).
- [Fix] <js> EEx + pattern break handling was always skipping rows whenever an EEx has been found after a Dxx, not only if they were on the same row (fixes Guitar Slinger and Endless by Jogeir).

Other formats
- [New] <js> Added support for 16SVX IFF samples - they are loaded as big-endian samples, while some sources suggest that they should be little-endian. Since I don't have any 16SVX samples, I can only guess which implementation would be correct.
- [Imp] <js> UMX: Added support for Unreal 1997/98 beta files (patch by sezero, http://bugs.openmpt.org/view.php?id=472).
- [Mod] <js> File format change notice: Plugin library names are stored as UTF-8 (instead of ANSI) in module files (MPTM / IT / XM) now. This won't make a difference in 99% of all plugin names probably - I've never come across a plugin DLL with non-ASCII characters.
- [Mod] <js> ITP file format change notice: Instrument paths are now relative to the ITP file if possible and are stored as UTF-8 (instead of ANSI). Embedded samples are now compressed using IT compression.
- [Fix] <jh> DMF: A bogus space was inserted in front of song messages.
- [Fix] <js> DBM: Some fixes mostly related to volume slides and envelopes.
- [Fix] <js> ITP: Song name was not being read.
- [Fix] <js> MT2: Fixed possible crash with some MT2 files (http://www.un4seen.com/forum/?topic=15448.msg107346#msg107346).
- [Fix] <js> MT2: Channel volume was not imported at all.
- [Fix] <js> STM: Imported volume commands were slightly off when there was another command next to them.
- [Fix] <js> UAX: Unnecessary empty sample slots were being created.
- [Fix] <jh> Loading split stereo samples from a truncated file could crash since OpenMPT 1.22.04.00 (http://bugs.openmpt.org/view.php?id=486).
- [Fix] <jh> Made PP20 / MMCMP / XPK unpackers more robust.

Stream Export
- [Imp] <jh> Default codec settings (per codec) and file tags are remembered.
- [Imp] <jh> Also show lossy codecs in pattern render to wave dialog.
- [Imp] <js> Resulting file size is no longer limited to 2 GB.
- [Fix] <js> Export no longer fails if song starts with separator (+++) patterns (http://forum.openmpt.org/index.php?topic=5170.0).
- [Fix] <jh> When switching focus to a different window and then back to OpenMPT, the window became unresponsive (http://bugs.openmpt.org/view.php?id=487).

Audio I/O
- [New] <jh> Add an alternate (1-bit) dithering algorithm. Default is still the original ModPlug Tracker dither (0.5-bit).
- [Mod] <jh> Since Windows Vista, there is an unpleasant limiter / compressor in the audio path for floating-point audio APIs with non-exclusive access. OpenMPT clips floating-point samples automatically to prevent this limiter from kicking in when necessary.
- [Imp] <jh> Sound device settings are now remembered per device.
- [Imp] <jh> Added options to open the sound device right at the program start and keep playing silence when stopping sound (useful for ASIO drivers with long initialization times).
- [Imp] <jh> Various improvements to sound device latency handling and ASIO buffer size selection.
- [Imp] <jh> Various improvements to DirectSound output.
- [Imp] <jh & js> Allow specifying a flexible channel mapping instead just the base channel offset for ASIO drivers.
- [Fix] <jh> Insanely high latencies in WASAPI exclusive mode have been reduced.
- [Fix] <jh> Implement all driver to host messages that are required to be handled by the ASIO 2.1 specification.
- [Fix] <js> Fixed possible freeze during start on Windows XP during Kernel Streaming initialization (patch from http://sourceforge.net/p/audacity/mailman/message/31421748/, tx Tomoya).

Misc
- [New] <js> Added (experimental) feature to append existing modules to a currently open module. This copies over all pattern, samples, instruments, plugins, etc. as far as it's possible.
- [New] <js> Added hidden setting for loading a default template ("Paths.DefaultTemplate" - can be either a full path or just a filename that can be found in the template folder, http://bugs.openmpt.org/view.php?id=476).
- [New] <js> MIDI Mapping does now also work with aftertouch messages.
- [New] <js> Added a "Samples" tab to the options dialog which exposes all previously hidden sample and instrument editor options. Two new key behaviours for how to stop sample editor note previews have been added.
- [New] <js> Added command line switch /noAssembly which disables any SIMD-optimized code.
- [Imp] <jh & js> OpenMPT's file handling is now almost fully unicode-aware (http://bugs.openmpt.org/view.php?id=164).
- [Imp] <js> OpenMPT is now large address aware.
- [Imp] <js> Replaced the "slightly" aged Win95-style icon set with a more modern one.
- [Imp] <js> Default key bindings are now automatically added to existing, possibly incomplete keybindings (http://bugs.openmpt.org/view.php?id=4).
- [Imp] <jh> Improved OpenMPT close time by only writing values to the settings files that were actually changed in OpenMPT.
- [Imp] <js> Reduced OpenMPT's initial memory consumption by about 5 MB.
- [Mod] <js> Disabled mix mode RC3 for XM / IT in Song Properties.
- [Mod] <js> New high-resolution application icon by Nobuyuki.
- [Mod] <jh & js> Restructured Sound Card, Player and Equalizer options tabs into Sound Card, Mixer and DSP. Changed the unit of volume ramping settings from samples to microseconds so that stays consistent across sample rate changes.
- [Mod] <js> After 16 years of rotozooming, it's time for a new toy in the About dialog.
- [Fix] <js> Scroll / Num / Caps Lock keys should now work better with toggle-able shortcuts (http://bugs.openmpt.org/view.php?id=13).
- [Fix] <js> Randomly disappearing combo boxes should hopefully be a problem of the past (http://forum.openmpt.org/index.php?topic=3518.0).
- [Reg] <js> Removed simple noise reduction DSP. Noone is going to miss this.
- [Reg] <jh> Removed support for importing old registry-based settings. If you really need to import your settings from a version older than OpenMPT 1.17.02.40 (including MPT 1.16), install and run OpenMPT 1.22 before installing a newer version.

Bundled plugins
- [Imp] <jh & js> The MIDI Input / Output Plugin can now compensate for OpenMPT's audio output latency by delaying the MIDI output accordingly.

Third-Party Libraries
- [Imp] Update flac (v1.3.0), SoundTouch (v1.8.0), smbPitchShift (v1.2), UNMO3 (v2.4.0.5).

Installer/release package
- [New] <js> Added key maps that are compatible with MPT's classic FT2 / IT keymaps (US_mpt-ft2_classic.mkb, US_mpt-it2_classic.mkb, tx Gargaj).


v1.22.07.00 (16 November 2013, revision 3235)
---------------------------------------------
Tree view
- [Fix] <js> Space key couldn't be used when editing labels.
- [Fix] <jh> The global VU meter didn't work properly when previewing instruments in OpenMPT 1.22.06.00.

VST / DMO Plugins
- [Fix] <js> When rendering the full module (i.e. not a selection), the song position was not reset properly, so some plugins were not in sync.

Stream Export
- [Fix] <jh> Exporting to a directory or file name with non-ASCII characters could fail in OpenMPT 1.22.06.00 (http://forum.openmpt.org/index.php?topic=5158.0).


v1.22.06.00 (2 November 2013, revision 3063)
--------------------------------------------
Pattern Tab::Note Properties
- [Fix] <js> IT / S3M volume slide mapping was a bit off.

Tree view
- [Fix] <js> Note-off on key-up was accidentally also applied to the lower part of the tree view.

VST / DMO Plugins
- [Imp] <js> Audio is no longer paused while a plugin is loaded.
- [Fix] <js> SysEx messages are sent to plugins in a different way now. This fixes SysEx messages sent through OpenMPT's MIDI Input / Output plugin.

MPTM::Loading
- [Fix] <js> Loading MPTM files made with older versions of OpenMPT could trash some Parameter Control parameters.
- [Fix] <js> Reading extended instrument and song properties in files with no samples was broken for the I-don't-know-how-manieth-time (also applies to IT files).

IT::Compatible Playback Mode
- [Fix] <js> In Compatible Gxx mode, sliding between two different samples shouldn't switch to the new sample (like in XM).

XM::Loading
- [Imp] <js> Don't enable smooth ramping heuristic for old XM revisions (this feature was introduced in a later version of Fasttracker 2).

MOD::Loading
- [Imp] <js> When loading SoundTracker modules, automatically enable ProTracker 1.x mode.
- [Imp] <js> Re-enabled support for ADPCM-compressed samples.

Other formats
- [Imp] <js> Updated RAR unpacker. All RAR formats up to the current RAR 5.0 are now supported.
- [Imp] <js> DBM: Support for panning envelopes, 32-bit samples, pattern names, multiple songs and various other small improvements.
- [Imp] <js> Added support for AMS (Velvet Studio) format revision 2.0.
- [Fix] <js> AMS (Velvet Studio): Default speed and tempo broke in OpenMPT 1.22.03.00. Instrument fadeout was too quick. Vibrato Envelope is now imported more correctly.
- [Fix] <js> AMS (Extreme's Tracker): 16-bit sample support was broken.
- [Fix] <js> DSM: Fixed broken patterns and added support for delta-encoded samples.
- [Fix] <jh> Loading some malformed files in various format could lead to a crash (introduced in OpenMPT 1.22.03.00).
- [Fix] <jh> WAV Loader: Loading 24-/32-bit WAV files as module crashed since OpenMPT 1.22.04.00 (http://bugs.openmpt.org/view.php?id=436).
- [Fix] <jh> When loading modules from a ZIP file, no longer overwrite existing song comments with ZIP file comments (broke in OpenMPT 1.22.02.00).

Stream Export
- [New] <jh> Use a common dialog for WAV and compressed exporting. Support for FLAC (built-in), Opus and OGG Vorbis has been added.
- [New] <jh> WAV export also supports tags now.
- [New] <jh> Can now also normalize audio during compressed export (via temporary file).
- [New] <js> Added option to clean output buffers of plugins before exporting (renders up to 20 seconds of silence per plugin, http://bugs.openmpt.org/view.php?id=19).
- [New] <jh> Added option to disable cue point writing on pattern transitions in WAV export (http://forum.openmpt.org/index.php?topic=5131.0).

Audio I/O
- [New] <jh> Added support for Kernel Streaming sound output on Windows XP and for WaveRT on Vista or newer. Both drivers are listed as "WDM-KS" in the soundcard options dialog.
- [New] <jh> Added a button to re-enumerate sound devices to soundcard options dialog. This allows selecting sound devices that got added / installed while OpenMPT was already running.
- [Imp] <jh> Removed static limit of 16 DirectSound and 8 ASIO devices.
- [Mod] <jh> Remove /wavex command line option (not relevant anymore on any of the supported Windows versions)
- [Mod] <jh> Always default or fallback to a Wave Out device which is by far the most stable and has the least surprising user experience.
- [Mod] <jh> Slightly changed audio thread code to avoid sporadic deadlocks in Wine.

Misc
- [New] <js> Added command-line option /fullMemDump to write a minidump with heap when OpenMPT crashes.
- [Imp] <jh> Limit WFIR cutoff setting to a sensible range.
- [Mod] <jh> Calculate mixer channel statistics over the interval as maximum used channels instead of an approximation of average used channels.


v1.22.05.00 (31 August 2013, revision 2622)
-------------------------------------------
General Tab
- [Imp] <js> Plugin parameters are now also updated while dragging the corresponding slider (tx madbrain).

Sample Editor
- [Imp] <js> Don't limit size of loaded sample file to the size of physical memory (old code relict).

Instrument Editor
- [Imp] <js> FLAC files are also shown in the file selection dialog.

Tree view
- [New] <js> Can now drag and drop samples / instruments between modules (tx madbrain).
- [Imp] <js> Releasing note keys now also stops sample / instrument previews (tx madbrain).
- [Fix] <js> Previewing sound font instruments in the treeview broke in OpenMPT 1.22.04.00 (http://bugs.openmpt.org/view.php?id=429).
- [Fix] <js> Trying to rename items that are not part of a song folder crashed the application.
- [Fix] <js> Adding and renaming sequences didn't update the tree view properly.

Playback
- [Fix] <js> Fine / extra fine portamento slides in IT / S3M with a parameter of 0 were broken in OpenMPT 1.22.04.00 (http://bugs.openmpt.org/view.php?id=433).

Other formats
- [Fix] <jh> DSM: Support files that start with a slightly different header than usual DSM files (http://forum.openmpt.org/index.php?topic=5091).

Audio I/O
- [New] <jh> Added 32-bit floating point output for drivers that support it.

Misc
- [Reg] <jh> Remove mpt_intl.ini and mpt_intl.dll support code which was solely usable to translate the options list in the general options tab.

Third-Party Libraries
- [Imp] Update zlib (v1.2.8).


v1.22.04.00 (6 August 2013, revision 2581)
------------------------------------------
Pattern Editor
- [Imp] <js> If more than one channel is selected, channel record select and channel reset shortcuts are now applied to all selected channels (tx coda).
- [Imp] <js> Also show name of unsupported commands in status text. Only really useful when importing files that contain effects not compatible with the current edit format.
- [Fix] <js> When removing channels or rows from a pattern, a crash could occur when the cursor was previously placed in a now inaccessible part of the pattern.
- [Fix] <js> After stopping playback, scrolling to previously invisible channels would reveal their last visible VU meter state (broke in OpenMPT 1.22).

Sample Editor
- [New] <jh> Support for floating point .wav files written with old versions of Syntrillium CoolEdit.
- [Mod] <jh> Normalization of 24-/32-bit samples on load is now optional. Disable it by setting "Sample Editor.MayNormalizeSamplesOnLoad" to 0.
- [Mod] <jh> When normalizing of 24-/32-bit samples on load, the sample's global volume is now adjusted to reflect the volume change if possible.
- [Fix] <js> Fixed crash when trying to trigger a note > B-9.
- [Fix] <jh> Reduce quantization noise by correcting the rounding and scaling in floating point conversion and float or 24-/32-Bit normalization when loading such WAV samples.

Tree view
- [Imp] <js> Can now load more than 64 soundfonts (http://bugs.openmpt.org/view.php?id=333).
- [Fix] <js> Fixed a rare crash when switching between previewed files in tree view (probably present since OpenMPT 1.22.01).
- [Fix] <js> Fixed various issues with editing sequence / instrument / pattern names.

VST / DMO Plugins
- [Imp] <js> Plugin Selection Dialog: When using the name filter, highlight matching plugin by default instead of the "no plugin" entry (tx coda).
- [Fix] <js> Preset names with ampersand characters in them weren't drawn properly in the plugin editor.

Playback
- [Imp] <js> Improved internal sample frequency precision.
- [Imp] <jh> Improved precision of polyphase 8-tap resampling filter tables by 1 bit.
- [Mod] <js> Disabled some questionable "optimisations" with cubic spline and linear interpolation that would disable interpolation depending on volume levels and sample frequency.
- [Fix] <js> In IT compatible and "old random variation" mode, panning variation was not applied if the same instrument also had a panning envelope.
- [Fix] <js> Pitch / Pan separation wasn't applied if the channel was panned way to the left.
- [Fix] <jh> Dithering is also applied when using 24-Bit output.
- [Fix] <jh> When applying global volume, ramping up and down lengths were mixed up. For stereo or quad output, the global volume ramping length was also only half the configured length.
- [Fix] <jh> In quad channel output mode, also apply equalizer to rear channels.
- [Fix] <jh> Avoid tiny rounding errors when converting between integer and floating point samples in the mixer.
- [Fix] <jh> Apply AGC volume changes to all channels at once instead of potentially decrementing volume in between processing different output channels. Also, limit ramp down speed to 1 step per sample (as it was for mono output).

MPTM::Loading
- [Mod] <js> Removed order truncation note for old MPTM files with long order lists (the order list was not actually truncated).

IT::Compatible Playback Mode
- [Fix] <js> Fine volume slides in the volume column are only executed on the first tick, and not on multiples of the first tick in case of a pattern delay.

XM
- [New] <jh & js> Added extra smooth ramping option in Song Properties to emulate Fasttracker 2's ramping algorithm (kills most percussion sounds). Set "Misc.SmoothFT2Ramping" to 1 to automatically detect if an XM file was made with Fasttracker 2 to enable this settings automatically.

XM::Loading and Saving
- [Fix] <js> A default speed / tempo of 0 should be ignored in XM headers (fixes transwave by jazz & motion).
- [Fix] <js> Saving XM files with non-existing patterns past the highest existing pattern number in the order list does no longer crash.

XM::Compatible Playback Mode
- [Fix] <js> Emulate FT2's very weird frequency wrap-around behaviour with 2xx effects (http://bugs.openmpt.org/view.php?id=386).
- [Fix] <js> Note-Off + Note Delay + Panning ignores the panning effect.
- [Fix] <js> Arpeggio emulation is now finally 100% accurate with speeds greater than 16.

MOD
- [Fix] <js> EEx + Dxx on the same row causes the target row of Dxx to be skipped in ProTracker (fixes condom_corruption by Travolta).
- [Fix] <js> When using EEx, there should be only one "first tick" event. Ticks that are multiples of the song speed are longer treated as first ticks.
- [Fix] <js> SoundTracker modules with "hidden" patterns in their order list didn't play properly anymore (probably since v1.22.03, affected e.g. Bad Dudes soundtrack).

MOD::ProTracker 1/2 Mode
- [Fix] <js> Frequency limiting was not always done correctly (Fixes black_queen.mod).

Other formats
- [Imp] <js> AMS: Added support for reversed sample loops (starting at sample end).
- [Imp] <js> PTM: Note Cut and some other commands should work better, added support for effects Jxx - Mxx (note slides) and Nxx (reverse sample + offset). Some effects show up as "?" in patterns now, this does not affect playback.
- [Mod] <jh> Replaced LHA unpacker by lhasa. Should be more reliable and support more LHA variants, including PMA and LZS.
- [Fix] <js> RAR support broke in OpenMPT 1.22.02.
- [Fix] <js> MT2: Repeated pattern events are now loaded correctly.
- [Fix] <js> MT2: Convert effects from XM to IT on loading, this fixes e.g. global volume commands.
- [Fix] <js> DSMI AMF: Version 8 / 9 files didn't load correctly.

Stream Export
- [Imp] <jh> Normalizing is now also available for 32-Bit WAV output.
- [Mod] <jh> Always enable "Export as MP3" menu entry and display a useful message box when no MP3 codec is found.
- [Fix] <jh> Rendered output is not clamped before normalizing anymore. WAV output is now dithered properly.
- [Reg] <jh> Remove possibility to export MP3 encapsulated in .wav files. It's not 1999 anymore.

Module cleanup
- [Mod] <js> "Remove unused patterns" no longer automatically executes "rearrange patterns".

Misc
- [New] <js> Added option in the MIDI configuration to ignore certain MIDI CCs when recording to pattern.
- [Mod] <jh> Removed /nomp3 command line switch as MP3 support is now initialized on demand instead of when launching OpenMPT.
- [Mod] <jh> 24-/32-bit samples in DLS files are no longer normalized on load.
- [Fix] <js> Song Length Estimation handles some pattern loops more correctly now (http://bugs.openmpt.org/view.php?id=416).
- [Fix] <js> Song Length Estimation doesn't break with some tempo slide down commands anymore (http://bugs.openmpt.org/view.php?id=416).
- [Reg] <jh> Enable MMX / 3DNow! / SSE acceleration is gone. This option is now always enabled when available.
- [Reg] <js> Removed hidden setting ITCompressionVerification (algorithm has been proven to be stable and verification is now part of the internal test suite).


v1.22.03.00 (18 May 2013, revision 2094)
----------------------------------------
Pattern Editor
- [New] <js> Clipboard entries can now be renamed in the Pattern Clipboard Manager by double-clicking them (http://bugs.openmpt.org/view.php?id=374).
- [Imp] <js> When using Insert Rows, the selection is not cleared anymore, allowing the user to execute the same command several times in a row.
- [Fix] <js> Reverted playback cursor display behaviour to how it worked before OpenMPT 1.22 (the playback cursor no longer stays in the pattern after playback has stopped).
- [Fix] <js> Pattern Step didn't update pattern VU meters properly.

Sample Editor
- [Fix] <js> Split stereo sample didn't update the instrument list in the pattern editor (http://bugs.openmpt.org/view?id=382).

Mod Conversion
- [Imp] <js> When converting to MOD or XM, --- and +++ order items are automatically removed and pattern jump commands are updated accordingly.

VST / DMO Plugins
- [Fix] <js> Changing MIDI input focus to a plugin editor only worked right after focussing the editor for the first time.

Playback
- [Mod] <js> Behaviour change: Allow S9F next to a note to work with looped samples (http://bugs.openmpt.org/view.php?id=12).
- [Fix] <js> Extra-smooth ramping is now also applied with no and linear interpolation (http://bugs.openmpt.org/view.php?id=291).
- [Fix] <js> Per-instrument ramping settings were ignored during wave export in some cases.
- [Fix] <jh> Fix volume ramping on samples played on the first row / tick of a song. Ramping is no longer disabled completely to fix pops due to global volume changes on the first row.

IT::Saving
- [Fix] <js> If an instrument referenced sample numbers >= 256, the sample mapping would break in IT and MPTM files (http://forum.openmpt.org/index.php?topic=5014.0).

XM
- [Fix] <js> Portamento didn't reset finetune in jam007.xm (http://bugs.openmpt.org/view.php?id=390).
- [Fix] <js> Only instrument numbers should reset sample panning, not lone notes (http://bugs.openmpt.org/view.php?id=385).

XM::Compatible Playback Mode
- [Mod] <js> No longer apply global volume on tick 2, since this was only part of the truth (http://bugs.openmpt.org/view.php?id=388).
- [Fix] <js> Fixed Rxy + note / instrument combination (http://forum.openmpt.org/index.php?topic=4999.0).
- [Fix] <js> Note Off for an instrument with no volume envelope only should fade the sample out if there is a volume command in the volume column (http://bugs.openmpt.org/view.php?id=387).
- [Fix] <js> Instrument number resets tremor count (http://bugs.openmpt.org/view.php?id=384).

XM::Loading and Saving
- [Mod] <js> +++ and --- entries are no longer exported to XM files. +++ entries are removed when reading old XM files made with ModPlug.

MOD::Loading
- [Imp] <js> Changed 8xx panning scheme detection heuristic to be less strict (fixes LOOKATME.MOD).

Other formats
- [New] <js> Can now import DIGI (Digi Booster) modules.
- [Imp] <js> DMF: Offset without note should now work.
- [Imp] <js> DMF: Volume 1 should be silent.
- [Fix] <js> MT2: Linear frequency slides were not enabled.
- [Fix] <js> MT2: Stereo samples were not loaded correctly.
- [Fix] <js> MT2: Sample tuning is more precise now (but still not perfect in all occasions).
- [Fix] <js> Reading song message in 669, AMS, DMF, FAR, ULT and MTM files could lead to crashes (since OpenMPT 1.22.02, http://forum.openmpt.org/index.php?topic=5002.0).
- [Fix] <js> Reading ZIP files could lead to crashes (since OpenMPT 1.22.02).

Module cleanup
- [Fix] <js> Rearrange instruments was broken... again.

Audio I/O
- [Fix] <jh> Fixed another possible crash with ASIO devices (http://bugs.openmpt.org/view.php?id=379).
- [Fix] <jh> Fixed crash in quad channel mode (crash occurred only since OpenMPT 1.22.02, but the source for it was there since probably forever).

Misc
- [Imp] <js> Added "made with" tracker identification to most module formats. Can be viewed in Song Properties.
- [Mod] <js> Warning log messages are no longer shown during auto save.


v1.22.02.00 (20 April 2013, revision 1917)
------------------------------------------
Instrument tab
- [Mod] <js> When importing DLS drum samples into an XM instrument, pick the center of the sample's assigned note range as a transpose amount instead of the lowest note of the note range (http://bugs.openmpt.org/view.php?id=376).

Tree view
- [Mod] <js> Instrument previews in the tree view are now played at 0dB.

VST / DMO Plugins
- [Imp] <js> If a plugin editor is focussed, MIDI is now always routed to that plugin.
- [Mod] <js> effBeginSetProgram and effEndSetProgram opcodes are sent when performing a program change.
- [Fix] <js> audioMasterGetPreviousPlug / audioMasterGetNextPlug opcodes were not doing anything that made sense.

VST::Specific Plugin Fixes
- [Fix] <js> OpenMPT could possibly freeze when starting WASAPI output of a module that uses the Sytrus plugin (and possibly other plugins).

IT
- [Fix] <js> Instrument numbers higher than the last instrument act like empty instruments.

IT::Compatible Playback Mode
- [Fix] <js> Fixed a rather rare envelope carry bug introduced in OpenMPT 1.22.01.00.

MOD::Loading and Saving
- [Imp] SoundTracker Loader: Made file rejection heuristics a bit more strict.
- [Fix] SoundTracker Loader: Fixed possible division by zero.
- [Fix] Saving: Maximum sample length was off by a few bytes.
- [Fix] Saving: It was still possible for samples to misalign if the saved sample was originally larger than 128 KiB and had an odd sample count.

Other formats
- [Fix] <js> PSM16 loader: Master volume was not loaded properly.

Audio I/O
- [Imp] <jh> Boosting of audio thread priority can now be disabled in the Sound Card settings. On Windows Vista and later, MMCSS is now used for boosting.
- [Imp] <jh> Support for exclusive device access has been added for WASAPI devices.
- [Mod] <jh> Renamed "Use secondary buffers" option to the negated form "Use primary buffer".
- [Fix] <jh> Fixed a possible crash when stopping a Wave Out device and possible freezes with ASIO / WASAPI devices.

Misc
- [New] <js> Added global, always active VU meter with clip indicator in the main toolbar (http://bugs.openmpt.org/view.php?id=144).
- [Imp] <js> MIDI CC shortcuts should now work in pretty much all places.
- [Imp] <js> When changing MIDI input devices, the change is applied instantly. Previously the old MIDI device was kept open.
- [Fix] <js> Time display was not updated anymore in OpenMPT 1.22.01.00 when jumping around in the order list without actually playing the module.
- [Fix] <js> Options dialog: Pre-amp warning was also shown when changing stereo separation.


v1.22.01.00 (6 April 2013, revision 1749)
-----------------------------------------
Pattern tab
- [New] <js> Can now copy multiple patterns at once (http://forum.openmpt.org/index.php?topic=3706.0).
- [New] <js> Added the Pattern Clipboard Manager to use more than one internal clipboard (http://bugs.openmpt.org/view.php?id=41).
- [New] <js> Chord Editor: Added the possibility to make chords relative to a note entered in the pattern instead of a fixed base note (http://bugs.openmpt.org/view.php?id=360).
- [New] <js> Added shortcut to find nearest instrument number in a channel (tx coda).
- [New] <js> Added shortcuts to toggle PC keyboard / MIDI record note off (http://bugs.openmpt.org/view.php?id=326).
- [New] <js> Added shortcuts: Select Row, Select Event (http://forum.openmpt.org/index.php?topic=3247.0).
- [New] <ks> Added hidden setting "Pattern Editor.RowDisplayOffset" in to specify displayed row offset in the pattern editor (does not affect Goto dialog or pattern effects).
- [Imp] <js> Added fake grace note support for record quantization: If there's already a note on the quantized row, move one row downwards.
- [Imp] <js> Chord mode does now also work if no record channels are selected.
- [Imp] <js> "Record Note Off" also works with chords now.
- [Imp] <js> Higher live record precision.
- [Mod] <js> Play Whole Row While Recording is now also applied to Quick Paste and Clear+Step commands (tx coda).
- [Fix] <js> Play Whole Row While Recording didn't work properly when Row Spacing was set to a value other than 0. Note stops didn't work, either (tx coda).
- [Fix] <jh> Pattern display no longer lags with high Wave Out latency values.
- [Fix] <js> When entering a chord, notes played via instrument plugins were not stopped on key-up.
- [Fix] <js> Setting channel panning from Quick Channel Settings dialog didn't reset the surround flag live.
- [Fix] <js> When inputting MIDI notes > B-9, they are now stopped properly on key-up (tx Knoeki).
- [Reg] <js> Removed possibility to copy parts of the order list in favour of the new multi-pattern copying.

Pattern tab::Find/Replace
- [Imp] <js> Replacing has been sped up significantly, especially with large modules (http://bugs.openmpt.org/view.php?id=334).

Sample tab
- [New] <ks> Can now import MPEG samples (MP1 / MP2 / MP3, requires mpg123).
- [Imp] <js> ITI files can now also be read as samples (only reads the first sample, naturally).
- [Imp] <js> Sustain loop preview is now updated instantly (http://bugs.openmpt.org/view.php?id=108).
- [Mod] <js> 8-Bit/Mono conversion items are now also shown in the context menu if a selection has been made.
- [Fix] <js> Memory was leaked when loading a sample into an empty sample slot and undoing that action.
- [Fix] <js> Inserting samples didn't clear previously existing sample names since some time ago.
- [Fix] <js> The sample filename wasn't imported properly when loading a FLAC sample with embedded RIFF chunks.
- [Fix] <js> Selection length display didn't show the correct length in seconds for long samples.

Instrument tab
- [Imp] <js> Mouse wheel and middle mouse button can be used in Sample Map (http://bugs.openmpt.org/view.php?id=345).
- [Imp] <js> Next / Previous Instrument shortcuts and the Tab key also work on the sample map now (tx coda).
- [Imp] <js> Revised sample slot allocation behaviour when loading sample files as instruments.
- [Mod] <js> Filter mode is now disabled for IT modules (defaults to "Channel default").
- [Fix] <js> After cleaning up instruments, inserting a new instrument would reveal the old (deleted) samples.

Tree view
- [New] <js> Some items (order list, pattern / sequence / sample / instrument names) can now be edited directly from the tree view.
- [Imp] <js> Previewing instruments does not open the audio device for every new preview anymore. Previewing the same file multiple times in a row no longer reloads it from disk every time.
- [Imp] <js> It is now possible to switch between the upper and lower part of the tree view by pressing the Tab key (http://bugs.openmpt.org/view.php?id=101).
- [Imp] <js> Soundfont instruments can now also be previewed for other notes than middle-C.
- [Imp] <js> Pause / Stop playback keyboard shortcuts also work when no module is loaded (to stop preview in tree view).
- [Imp] <js> Navigating with keyboard (e.g. using alphanumeric keys in the instrument browser) should work much better now.
- [Fix] <js> Previewing instruments only worked about every other time.

Mod Conversion
- [Imp] <js> Volume column a/b/c/d slide memory is now fixed when converting to MOD / XM / S3M.
- [Imp] <js> 000 (arpeggio with no parameters) commands are now removed when converting from MOD / XM to other formats.
- [Fix] <js> When resizing small patterns to 64 rows for MOD / S3M, the pattern break command was inserted on the new last row (63) instead of the original last row.

VST / DMO Plugins
- [New] <js> Can now load and save FXB (plugin preset bank) files.
- [New] <js> Can now copy & paste current preset in the plugin editor.
- [New] <js> Added an option in the plugin editor to route a plugin's MIDI output to the pattern / sample / instrument editor.
- [Imp] <js> If no default directory for presets is specified, the plugin's directory is suggested in the load / save dialog by default.
- [Imp] <js> Current program name is now suggested when saving FXP files.
- [Imp] <js> Better preset list creation for plugins that don't support retrieval of indexed program names (such as VOPM).
- [Imp] <js> Plugin Selection Dialog: Selecting "no plugin" no longer makes OpenMPT forget the last used plugin.
- [Imp] <js> Offline rendering state is sent to plugins that request it.
- [Fix] <js> The preset menu is now updated correctly if the plugin requests a GUI update (e.g. internal bank switching).

Playback
- [Imp] <js> Instrument envelopes are now also evaluated if no sample, but a MIDI channel is assigned to the instrument - great for automating plugins using envelopes and macros.
- [Imp] <js> Retrigger note also works with instrument plugins on rows without a note, and also with Cxx volume commands in XM.
- [Mod] <jh> In quad surround mode, the surround channel settings overwrites the reverb channel setting now (previously, it was the other way around).
- [Fix] <js> Fixed problem where one had to press the play button twice after stopping playback (http://bugs.openmpt.org/view.php?id=325).
- [Fix] <js> A crash could occur when using reverb with a mixing frequency higher than 50 KHz (http://bugs.openmpt.org/view.php?id=329).

IT / MPTM
- [New] <js> Experimental support for saving IT-compressed samples. To enable, set the ITCompressionMono=x and/or ITCompressionStereo=x (x is a sum of the following possible values: 1 = normal IT; 2 = Compatibility Export IT; 4 = MPTM) in mptrack.ini's [Misc] section; set ITCompressionVerification=1 to verify if samples are compressed correctly. Compressed stereo samples won't load in older versions of OpenMPT, and compressed samples will cause trouble when reading extended song or instrument properties in old versions, so be careful if you want to be backwards-compatible.

IT::Compatible Playback Mode
- [Imp] <js> Slightly changed arpeggio tick processing to be more accurate with pattern delays.
- [Fix] <js> Retrigger note (Qxy) was broken for instrument plugins in IT compatible mode since OpenMPT 1.20.01.00 (tx Nahkranoth).
- [Fix] <js> There is no unified effect memory between the volume column effects, and the volume slide commands there also don't share their effect memory with the effect column slides.
- [Fix] <js> Envelope reset should now work correctly (http://bugs.openmpt.org/view.php?id=330).
- [Fix] <js> pxx should also reset the surround flag, like all other panning commands.
- [Fix] <js> SCx shouldn't "click" anymore (just like normal note cuts).
- [Fix] <js> Various fixes regarding portamento between different samples, and especially portamento in multisample instruments.

XM::Compatible Playback Mode
- [Fix] Reverted envelope handling changes made in OpenMPT 1.20.01.00 to fix gh-kott.xm.

XM::Loading
- [Mod] <js> Less false positives when trying to detect old versions of MPT.

S3M
- [Fix] <js> SCx shouldn't "click" anymore (just like normal note cuts).

S3M::Loading and Saving
- [Imp] <js> Added support for loading SAx panning (as found in PANIC.S3M, automatically translated to S8x panning).
- [Mod] <js> The channel order is now written in a L1 L2 L3... R1 R2 R3... scheme, instead of L1 R1 L2 R2 L3 R3..., so that channels are evaluated in the same order in ST3 and OpenMPT (ST3 first evaluates "left" channels, then "right" channels - note that this change does not affect the actual panning, though).

MOD::ProTracker 1/2 Mode
- [Imp] <js> Vibrato and Tremolo are not applied on first tick anymore..
- [Imp] <js> Added ProTracker arpeggio wrap-around emulation (fixes the snare sound in doh's "Jim is dead").
- [Fix] <js> The frequency range is now limited properly by taking the sample's finetune setting into account.

MOD::Loading and Saving
- [Imp] <js> Drastically improved support for 15-sample (Ultimate SoundTracker and clones) modules. For example, original Ultimate SoundTracker effects are now handled much better (e.g. in sll7.mod).
- [Mod] <js> Sample pre-amp volume is based on the number of channels, to have the highest possible sample pre-amp without clipping.
- [Mod] <js> Changed heuristic ProTracker 1.x detection: If there are more than four sample swaps between two notes, ProTracker 1.x mode is enabled (previously it was just 16 sample swaps per pattern). This fixes e.g. hoisaga1.mod by Ramon.
- [Mod] <js> Can now create MODs with up to 99 channels.

Other formats
- [Imp] <js> WAV Loader: Loops that only cover the first sample point are ignored during import now.
- [Imp] <js> ITP Saver: If an instrument cannot be saved, a warning is shown.
- [Fix] <js> PAT Loader: Sample frequency was not imported correctly since OpenMPT 1.20.02.00.
- [Fix] <js> MTM Loader: Files with only one pattern were rejected (tx ant1).
- [Fix] <js> Tentative fix for some DLS sounds not loading correctly (http://bugs.openmpt.org/view.php?id=331).

Module cleanup
- [Mod] <js> "Reset variables" also resets channel settings now.
- [Fix] <js> After rearranging samples, some bogus sample slots became visible again when adding a new sample afterwards.

Audio I/O
- [New] <jh> Added support for WASAPI output devices.
- [Mod] <jh> Options Dialog: Changed "Buffer Length" value into "Latency" (real audio latency) and "Update Interval" (for GUI updates). Old buffer length settings are automatically converted to the new quantities.
- [Fix] <jh> Reported ASIO latency was slightly off, so that pattern playback syncing might have been a little off (not very noticeable since ASIO has very low latencies anyway).
- [Reg] <js> Removed poorly implemented Invert Stereo option. It's not 1995 anymore.

Misc
- [New] <js> Added keyboard shortcut: Play song from start of pattern (same as play pattern from start, but doesn't loop the pattern).
- [New] <jh> Add hidden setting "Display.ShowSplashScreen".
- [Imp] <js> Elapsed time display in the status bar is a lot more accurate now (no more rounding errors that pile up over time).
- [Imp] <js> Exclusive file reading rights are no longer requested, so it is now possible to open files that are being read by other applications at the same time (http://bugs.openmpt.org/view.php?id=352).
- [Imp] <js> Editing sample / instrument names on the comments page limits the name length during input instead of just trimming long strings afterwards.
- [Imp] <js> When clicking the "MIDI Record" button and the device is not ready, opening the device is now tried again after the popup settings dialog is closed.
- [Imp] <js> Reduced memory usage.
- [Mod] <js> Improved extension detection when reading files from zip files. When no preferred file extension is found, the biggest file in the archive is now preferred.
- [Mod] <js> Changed default song name to be empty instead of "untitled".

Bundled plugins
- [Imp] <js> The MIDI Input / Output Plugin now stores device names in presets / modules, so that the order of MIDI devices is no longer important (when having e.g. more than one USB to MIDI interface, their device IDs might change depending on which one was plugged in first).
- [Fix] <js> The MIDI Input / Output Plugin could crash when changing devices while MIDI data was being processed.


v1.21.01.00 (22 December 2012, revision 1472)
---------------------------------------------
Pattern tab
- [New] <js> Added option to quantize notes that are recorded live (select from context menu or shortcut).
- [New] <js> Added "Data Entry" shortcuts to increase or decrease the value of the currently selected pattern cells (note, instrument, effect parameters), either by +/- 1 or by a coarse value depending on the column (http://forum.openmpt.org/index.php?topic=3907.0).
- [Imp] <js> If no selection has been made, interpolation shortcuts now interpolate between the nearest notes / instruments / commands above and below the cursor position.
- [Imp] <js> Added shortcuts for Record Select / Split Record Select (tx DJBouche).
- [Fix] <js> Resizing a pattern only created an undo point when the pattern was reduced.
- [Fix] <js> Set Instrument also works if "No Instrument" is chosen (http://forum.openmpt.org/index.php?topic=4178.0).
- [Fix] <js> Non-existing patterns above the highest existing pattern are not displayed as "???" in the order list anymore.

Sample tab
- [New] <js> Can now load and save FLAC samples.
- [New] <js> Added new stereo to mono sample conversion modes: Keep only left / right channel, split stereo sample into two mono samples.
- [Imp] <js> Added shortcuts for "Zoom into Selection" (http://forum.openmpt.org/index.php?topic=4877.0), 8-bit and mono conversion.
- [Imp] <js> When triggering a note, the note frequency is displayed next to the note name in the status bar.
- [Imp] <js> It is now possible to drag and drop multiple samples from explorer.
- [Imp] <js> When saving a sample, the actual sample name is now suggested if no sample filename is specified in IT / S3M / MPTM modules.
- [Imp] <js> Added hidden INI setting "Sample Editor.DefaultFormat" to specify the default format to use when saving samples (possible values: wav, flac, raw).
- [Imp] <js> Added hidden INI setting "Sample Editor.FLACCompressionLevel" to set the compression level (0...8) when saving FLAC samples.
- [Fix] <js> Reducing the size of the sample undo buffer could sometimes lead to freezes (http://bugs.openmpt.org/view.php?id=314).
- [Fix] <js> Fixed a possible crash when creating undo points (e.g. when using loop crossfade with an invalid crossfade length).
- [Fix] <js> Saved WAV files should now finally have a correct file size in the header.

Instrument tab
- [Imp] <js> Moving the envelope tail (using Ctrl + Drag) also works properly if the distance between the moved point and the following point is small.
- [Imp] <js> It is now possible to drag and drop multiple instruments from explorer.
- [Imp] <js> Dragging the mouse over the sample map doesn't invert every note's assignment but applies the same action to all notes now (http://bugs.openmpt.org/view.php?id=244).
- [Fix] <js> Importing DLS / SF2 samples into the sample editor does now properly remove sample attributes not supported by the current format.

Tree view
- [Fix] <js> Rearrange samples / instruments was really buggy.

MIDI Macros
- [Fix] <js> MIDI Macro letters u and v also take global / channel / instrument volume into account.
- [Fix] <js> Zxx is now only applied on first tick (like in Impulse tracker), before any other effects, \xx remains "sane" and is applied on every tick.

VST / DMO Plugins
- [Imp] <js> The Preset menu in the plugin editor is now filled on demand (when clicking it for the first time) to keep the GUI responsive when opening the editor of plugins that have many presets.
- [Fix] <js> Changing the preset from the plugin editor didn't mark the module as modified (http://bugs.openmpt.org/view.php?id=317).

Playback
- [Fix] <js> Reverse pattern loops that are obfuscated through pattern jump commands should now also work correctly when "Loop Song" is off and during Wave Export (http://bugs.openmpt.org/view.php?id=311).

XM::Compatible Playback Mode
- [Fix] <js> Volume column lxx / rxx doesn't overwrite the effect memory of Pxy anymore.

XM::Loading and Saving
- [Fix] <js> Importing patterns >= 240 didn't work in OpenMPT 1.20.04.00 (http://bugs.openmpt.org/view.php?id=308).
- [Fix] <js> XM instrument saving failed in all versions of OpenMPT 1.20 if there were samples in the sample map that were only referenced below C-1 or above B-8 (http://bugs.openmpt.org/view.php?id=324).

S3M
- [Fix] <js> Pattern loops on muted S3M channels were still being processed.

Misc
- [Imp] <js> Added possible fix for some SF2 inaccuracies (tx BeRo).
- [Imp] <js> Added basic support for DLS Level 2 regions (they are just treated like DLS Level 1 regions).
- [Fix] <js> Fixed crash when loading some DLS samples.
- [Fix] <js> Fixed possible integer overflow when reading song messages from files.
- [Fix] <js> Song length detection won't affect actually stored high offset parameter anymore.


v1.20.04.00 (27 October 2012, revision 1398)
--------------------------------------------
General tab
- [Fix] <js> Input boxes in general tab didn't allow for horizontal scrolling.

Pattern tab
- [New] <js> Can now also transpose by arbitrary amounts. Select from context menu or shortcut.

Sample tab
- [Fix] <js> Unsupported types of WAV files (e.g. MP3-compressed WAV) won't crash the program anymore.
- [Fix] <js> Loading XI files as samples could lead to a crash (tx Lucas).
- [Fix] <js> Mass sample export file names were sometimes not sanitized correctly (http://bugs.openmpt.org/view.php?id=300).

Tree view
- [New] <js> It is now possible to rearrange (drag and drop), insert and duplicate (through the context menu) samples and instruments.

VST / DMO Plugins
- [Fix] <js> Plugin Selection Dialog: Adding new plugins didn't focus them as intended.
- [Fix] <js> Plugin Editor: Bypassing a plugin from its editor didn't mark the module as modified.

VST::Specific Plugin Fixes
- [Fix] <js> EZDrummer didn't load its samples until playback was started since OpenMPT 1.20.01.00, for the same reason as the Korg plugins which stopped working (tx coda).

XM::Compatible Playback Mode
- [Fix] <js> Improved XM tremor effect compatibility.

XM::Loading and Saving
- [Imp] <js> Full tempo range (32 - 512) is now also supported for the default tempo in compatibility export, as Fasttracker 2 actually "supports" this (not through the GUI, but it won't sanitize such values in files) and XMPlay also does.
- [Imp] <js> Improved detection of files made with MPT.

MOD
- [Fix] <js> Partly undid Set Finetune changes from OpenMPT 1.20.02.00 (fixes The Wanderer II by Jogeir)

Other formats
- [Fix] <js> ITP Saver: ITP files saved with OpenMPT 1.20.03.00 were corrupted. Files saved with this version can be fixed by writing the byte sequence 10 00 02 (hex) at position $2B (instead of 01 00 00).

Audio I/O
- [New] <js> Added hidden INI setting "Sound Settings.ASIOBaseChannel" in category to specify the first ASIO channel to use for sound output (as a quick and dirty semi-solution for http://bugs.openmpt.org/view.php?id=128).

Misc
- [Imp] <js> Using the mouse wheel to scroll edit controls with spin buttons works on all such controls now (http://bugs.openmpt.org/view.php?id=99).
- [Mod] <js> Changed default resampling type to XMMS-ModPlug.
- [Fix] <js> Wave Export file names were sometimes not sanitized correctly (http://bugs.openmpt.org/view.php?id=300).
- [Fix] <js> Installer shouldn't overwrite key settings files anymore.


v1.20.03.00 (22 September 2012, revision 1359)
----------------------------------------------
Pattern tab
- [New] <js> Playback can now be locked to an order range. The range can be specified from the context menu of an order selection. Locked orders are then shown with a different background colour (http://forum.openmpt.org/index.php?topic=2620.0).
- [Imp] <js> For visual guidance during editing, non-existing pattern numbers are now greyed out.
- [Imp] <js> Added a keyboard shortcut for opening the Quick Channel Settings dialog.
- [Mod] <js> Entering note-offs via MIDI doesn't put an instrument number next to them anymore.
- [Fix] <js> Cursor doesn't exceed the pattern anymore when moving it beyond the right border.
- [Fix] <js> When opening the pattern tab for the first time, the order list should not be scrolled randomly anymore if not necessary.

Pattern tab::Quick Channel Settings Dialog
- [New] <js> Added freely assignable keyboard shortcuts for switching between channels and returning to the pattern editor.
- [Imp] <js> The dialog is now always hidden when changing focus to another window, not only when switching back to the lower part of the pattern view.
- [Fix] <js> Tab order is now correct.

Sample tab
- [Fix] <js> 8SVX Loader: Loops are now also loaded properly if the loop end is precisely at the sample end.

Instrument tab
- [New] <js> "Pitch Bend Range": For instrument plugins, enter the instrument's Pitch Wheel Depth into this box and OpenMPT will now automatically adjust portamento / vibrato commands for this instrument plugin so that they behave identical to sample portamento / vibrato.
- [Imp] <js> Sustain / Loop points cannot be enabled anymore if there is no envelope.
- [Mod] <js> Velocity handling option has been turned into a checkbox (should be easier to grasp).
- [Fix] <js> Loading AIFF files as instruments (or previewing them from the tree view) works now.

VST / DMO Plugins
- [New] <js> Plugins can now also receive tracker portamento (Hxx / 4xx and the like). Vibrato is emulated through pitch wheel messages; the behaviour is identical to sample vibrato if the plugin's actual Pitch Wheel Depth is set up correctly in the instrument tab.
- [Imp] <js> Portamento Up / Down effects are now implemented properly: Memory and fine slides do finally work. (Fine and extra fine slides are currently not supported in the XM format, but you should not use plugins in that format anyway!). The behaviour is now also identical to sample portamento if the plugin's actual Pitch Wheel Depth is set up correctly in the instrument tab. For existing songs, a new option has been added to the Song Properties to retain the old behaviour.
- [Fix] <js> Randomize Parameters reset focus to main window instead of plugin window (http://bugs.openmpt.org/view.php?id=294)
- [Fix] <js> Randomize Parameters doesn't ask the plugin if a parameter is automatable anymore, as some plugins do not seem to set this property at all.
- [Fix] <js> OpenMPT didn't write more than 255 plugins to the settings file since version 1.20 (http://bugs.openmpt.org/view.php?id=267)
- [Fix] <js> A memory leak that occurred when trying to register invalid or missing plugins (e.g. on startup) has been fixed.

IT::Compatible Playback Mode
- [Fix] <js> A channel's key-off status is kept with portamento notes if "Compatible Gxx" is disabled or there is no instrument number next to the new note.

IT::Loading
- [Fix] <js> Overly long (26 characters) sample / instrument name strings found in IT files made with older versions of MPT are now read correctly again.
- [Fix] <js> Silent samples were sometimes loaded into sample slots that were actually supposed to be empty.

XM
- [Fix] <js> All fine slide commands (E1x, E2x, EAx, EBx, X1x, X2x) are supposed to have their own memory. Previously, it was shared between some of the commands.

XM::Compatible Playback Mode
- [Fix] <js> Notes next to note delays are now ignored if the delay is greater than the current speed (*ignoring* any pattern delays). Previously this was only ignored if the delay was greater than the speed *including* pattern delays.

XM::Loading and Saving
- [Imp] <js> When loading an XM file made with an older version of OpenMPT, gxx / 3xx combinations in the same pattern cell are now tried to be upgraded to fit the new behaviour of OpenMPT 1.20.02.00.
- [Fix] <js> Compatibility export broke X1x and X2x (extra-fine portamento) commands.

MOD
- [Fix] <js> Dxx effects that are to the left of a Bxx effect are now ignored (like in the XM format).
- [Fix] <js> Loading 15-sample MODs only worked under lucky circumstances (most likely since OpenMPT 1.20.01.00).

Other formats
- [Imp] <js> 669 Loader: Effects are now imported more accurately.
- [Imp] <js> DMF Loader: Improved effect import to fit more effects into a pattern cell.
- [Fix] <js> AMF (DSMI) Loader: Fixed pattern effects (normal volume slides were always loaded as volume slide + vibrato) and some other bugs; More AMF format revisions (8-14) are supported now.
- [Fix] <js> AMF (ASYLUM) Loader: Transposed samples will now play correctly, default speed / tempo are not ignored anymore.

Audio I/O
- [Mod] <js> Since the DirectSound driver seems to be buggy (see various reports on the issue tracker), OpenMPT defaults to Wave Out now if there's no ASIO driver present.

Misc
- [New] <js> Wave Export: Added option to loop a song a given number of times during export (http://bugs.openmpt.org/view.php?id=221).
- [Imp] <js> Keyboard Settings: Searching for shortcuts does now also work with MIDI CCs.
- [Fix] <ks> Save All / Save None buttons in the Unsaved Files dialog didn't work if there was only one unsaved file (http://bugs.openmpt.org/view.php?id=206).
- [Fix] <js> A known file extension shouldn't suggest a wrong file extension in the WAV / MP3 export dialog anymore (http://bugs.openmpt.org/view.php?id=298).


v1.20.02.00 (7 July 2012, revision 1318)
----------------------------------------
Pattern tab
- [New] <js> Middle-clicking or Ctrl+right-clicking a channel header shows the Quick Channel Settings dialog, where channel name, volume and panning settings can be quickly set up.
- [Imp] <js> After selecting a column through a double click, it is possible to extend this selection to other channels by keeping the mouse button down after the second click (http://bugs.openmpt.org/view.php?id=245).
- [Mod] <js> Order list display is now "blanked" after maximum supported length instead of internal size.
- [Mod] <js> Interpolation and transpose context menu items have been moved to sub menus.
- [Fix] <js> Shift-Click behaviour was inconsistent if a selection has already been made (http://bugs.openmpt.org/view.php?id=249).
- [Fix] <js> An order list beginning with a separator and a stop pattern won't hang the tracker anymore (http://bugs.openmpt.org/view.php?id=255).
- [Fix] <js> Moving channels through Drag & Drop didn't update the channel names properly.
- [Fix] <ks> Pressing and releasing superfluous modifier keys made some pattern selection shortcuts get stuck.
- [Reg] <js> Removed the "Rename Channel" context menu entry in favour of the new Quick Channel Settings.

Sample tab
- [Imp] <js> Improved AIFF support (added support for loop points, up to 32-Bit sample resolution, AIFF-C files and little-endian sample data).
- [Imp] <js> Added support for arbitrary bit resolutions between 1 and 32 bits in WAV files (e.g. 20-Bit sample data).
- [Imp] <js> If zooming the current selection is impossible, the zoom context menu item is greyed out.
- [Fix] <js> Shouldn't crash anymore when cleaning up Undo memory (http://bugs.openmpt.org/view.php?id=232).

Instrument tab
- [Mod] <js> When right-clicking an envelope point, "Insert Point" will now insert the new point a tick to the right instead of inserting no point at all.

Mod Conversion
- [Mod] <js> When converting to XM, pattern breaks for fixing the FT2 E6x bug are now only inserted when necessary.

VST / DMO Plugins
- [Imp] <js> Plugin selection dialog makes use of plugin categories (as reported by the plugins) now.
- [Imp] <js> The current playback position is now also reported correctly to plugins when jumping around in the order list (Previously, it was always reset to the song start).

VST::Specific Plugin Fixes
- [Fix] <js> The Korg Wavestation GUI did not work until song was played for the first time since OpenMPT 1.20. This also fixes the GUI of older versions of the Korg M1 plugin.

Playback
- [Fix] <js> Fixed frequency slide inaccuracies (tx BeRo).
- [Fix] <js> Removed portamento speed A01 "fix". At speed 1, use fine pitch slides instead of normal ones (they behave identically to what OpenMPT did previously at speed 1).

IT
- [Mod] <js> Random filter variation settings are not supported anymore when editing IT files. Please use the MPTM format instead. Importing old files with random filter settings does still work.

IT::Compatible Playback Mode
- [Fix] <js> Combinations of Qxy (retrigger) with a pattern delay at Speed y should now work as intended.
- [Fix] <js> Combinations of SDx with x greater than the current speed combined with tick delay commands didn't work.

IT::Loading
- [Fix] <js> Loading IT files made with older versions of OpenMPT replaces SC0 with ^^ instead of v00 now.

XM
- [Fix] <js> Set Finetune (E5x) should now work as in Fasttracker 2.
- [Fix] <js> Volume column command gxx did not have memory (tx coda). Combinations of gxx and Gxx in the same pattern cell work correctly now.

XM::Compatible Playback Mode
- [Fix] <js> Tremor (Txy) behaves more like in Fasttracker 2 now.
- [Fix] <js> Volume column command l00 sets the panning to full left on every tick but the first.

S3M::Loading
- [Fix] <js> Empty patterns were not loaded correctly.

MOD
- [Fix] <js> Set Finetune (E5x) should now behave more like in ProTracker.

Other formats
- [New] <js> AMS (Velvet Studio) support is finally back (not crashing the tracker this time :). AMS (Extreme's Tracker) support has been improved as well.
- [Imp] <js> WAV Loader also imports loop points when reading a WAV file as a module.
- [Imp] <js> STM Loader imports some effects more correctly now.
- [Imp] <js> UMX Loader checks for a few more contained module formats that are also supported by Galaxy Sound System (STM, 669, FAR).
- [Fix] <js> MDL Loader was severely broken in OpenMPT 1.20.01.00.
- [Fix] <js> MED Loader: Sample transpose should work as intended (at least for MMD1 modules), MMD2 order list works again as well, Tempo vs Speed precedence for value 32 should be correct now.

Misc
- [New] <js> Keyboard Settings: Shortcuts can now also be found by pressing the sought-after key combination. Click search field to reset filter.
- [Fix] <js> F1 was accidentally hard-coded to opening the help file (tx Diamond).
- [Fix] <js> Song Length Estimation also takes per-pattern time signatures into account now.

Bundled plugins
- [Fix] <js> When using more than one instance of the MIDI Input / Output plugin at a time, killing one plugin instance killed all other instances as well.
- [Fix] <ks> The MIDI Input / Output plugin could sometimes send garbage data.


v1.20.01.00 (5 May 2012, revision 1263)
---------------------------------------
General tab
- [Imp] <js> Like the plugin preset box, the plugin parameter selection box is now only populated when it is focussed, to avoid delays with plugins that have tons of parameters.
- [Imp] <js> Default global volume display is now limited to 0...64 (instead of 0...128) for S3M (http://forum.openmpt.org/index.php?topic=4658.0).
- [Mod] <js> Default global volume is not available anymore in the XM format, since it is not supported by the original format.
- [Fix] <js> Switching between plugin presets didn't update the plugin parameter display.
- [Fix] <js> When enabling surround for a channel, panning was not reset properly for playing tracks.

Pattern tab
- [New] <js> Added an option to select a whole channel when double-clicking a pattern cell (tx ko0x).
- [New] <js> Added an option to display the default volume setting of a sample in the volume column if it is empty (obviously inspired by Impulse Tracker).
- [New] <js> It is now possible to record incoming MIDI aftertouch messages to patterns using volume commands or MIDI Macros (http://bugs.openmpt.org/view.php?id=195).
- [New] <js> New shortcuts: Increase / Decrease Row Spacing (http://bugs.openmpt.org/view.php?id=181).
- [Imp] <js> Adding / removing channels through the pattern editor now creates an undo point instead of clearing the undo log completely.
- [Imp] <js> Parameter Control Events have an edit memory now and adhere to the row spacing setting (tx cce, http://bugs.openmpt.org/view.php?id=190).
- [Imp] <js> Added an order list context menu item to add a separator (+++) index.
- [Imp] <js> When recording note-offs in sample mode, Note Cuts are inserted instead of Note Offs.
- [Imp] <js> Song position retrieval also works for sub tunes now, so song properties are restored properly when starting playback from a sub tune (http://forum.openmpt.org/index.php?topic=4578.0).
- [Imp] <js> When trying to paste but no pattern data was found in the system clipboard, previously copied pattern data is now regained from an internal clipboard.
- [Mod] <js> Renamed X Param to Parameter Extension.
- [Mod] <js> Split keyboard settings now affect record groups: If there are channels assigned to both record groups, the lower part of the split keyboard is recorded into record group 2, the higher part is recorded into group 1 (http://forum.openmpt.org/index.php?topic=4568.0).
- [Mod] <js> Shift-Selecting now uses the select key (which is Shift by default) instead of the hard-coded shift key.
- [Mod] <js> Changed maximum width of pattern display to allow for wider displays than 4096 pixels (http://bugs.openmpt.org/view.php?id=215).
- [Mod] <js> Changed maximum undo steps to 100,000.
- [Fix] <js> When changing a note's octave, the triggered note was not stopped on key-up since the early OpenMPT 1.17 days (http://forum.openmpt.org/index.php?topic=4718.0).
- [Fix] <js> Keyboard Split instrument setting was broken in OpenMPT 1.19.
- [Fix] <js> Moving channels and then undoing the move doesn't screw up channel settings anymore (http://bugs.openmpt.org/view.php?id=156).
- [Fix] <js> When undoing an edit switches to another pattern, OpenMPT tries to find a linked order for this pattern, so that continuous scroll keeps working (http://bugs.openmpt.org/view.php?id=189). Might not work reliably if the same pattern is used twice.
- [Fix] <js> When duplicating a pattern sequence that starts with a non-existing pattern (e.g. +++), the pattern view didn't update properly so editing was still taking place in the previously selected pattern (confusing!)
- [Fix] <js> Instruments are now faded out properly when editing XM modules.
- [Fix] <js> Using Keyboard Split, it was possible to input unsupported notes (e.g. C-0 in MOD files).
- [Fix] <js> It was possible to interpolate between a note and e.g. note cut, but it was not possible to interpolate between a note and no note.
- [Fix] <js> Resizing a pattern didn't create an undo point.
- [Fix] <js> Pattern names were not duplicated (http://bugs.openmpt.org/view.php?id=208).
- [Fix] <js> Entering chords didn't do anything if only the note at the cursor position differed from previously entered pattern data.
- [Fix] <js> The Reset Channel shortcut and the shortcut for setting Row Spacing to 9 never worked.

Pattern tab::Note Properties
- [Imp] <js> Better explanation of the MOD E5x effect parameter.
- [Fix] <js> When showing the properties of a #xx (Parameter Extension) effect, negative values could have been shown.
- [Fix] <js> Plugin indices for Parameter Control Events were off by one.

Pattern tab::Find/Replace
- [Imp] <js> Swapped channel numbers in the channel search feature are now treated correctly - if you enter e.g. 15 as the first channel and 3 as the second channel, channels 3 through 15 will be searched.
- [Imp] <js> Volume column parameters are limited better now. It's still possible to do something like "Search for volume command d, replace by volume parameter 24", though... (don't do it!)
- [Imp] <js> Follow Song isn't turned off anymore when using Find/Replace and the song isn't actually playing (http://bugs.openmpt.org/view.php?id=229).
- [Imp] <js> Find/Replace also updates the order list with the correct order now - this doesn't work across multiple sequences yet, though (http://bugs.openmpt.org/view.php?id=152).
- [Fix] <js> Replace instrument -1 didn't work as expected on instrument number 1.
- [Fix] <js> Volume command parameters are now sanitized on replace (previously, it was possible to e.g. replace "v24" with "d", which would have generated the invalid command d24).
- [Fix] <js> Replacing "no note" with note + 1 or note + 12 will not create C-0 / B-0 notes in the pattern anymore.

Sample tab
- [New] <js> Experimental feature: A Sample Tuner which tunes the sample to a specified note.
- [Imp] <js> When changing XM autovibrato settings, they are now automatically propagated to other samples referred by the same instrument.
- [Mod] <js> Loops are now automatically enabled when setting loop points in the sample editor
- [Mod] <js> Changed maximum undo steps to 100,000.
- [Fix] <js> Pasting samples didn't copy over some sample settings (vibrato, etc.) if sample loops were enabled.
- [Fix] <js> WAV Loading / Saving didn't consider RIFF padding bytes since... forever. Old broken samples (only 8-Bit Mono samples with an odd length are affected) should still load correctly.
- [Fix] <js> Saving samples as WAV didn't save sample settings properly.
- [Fix] <js> Deleting sample data adjusted loop points, but not sustain points.
- [Fix] <js> Samples created using the "add silence / resize to" button didn't show up in the pattern editor's instrument list instantly.
- [Fix] <js> Crossfade keyboard shortcut was broken.
- [Fix] <js> Sometimes, the correct sample was not displayed after switching from another tab.
- [Fix] <js> When converting between IT / MPTM and XM, the auto vibrato and sample pan limits were not updated instantly.
- [Fix] <js> Saving and loading loop points in WAV samples is now done according to the RIFF standard (in OpenMPT, the loop end is exclusive, in the RIFF standard it is inclusive). Looped samples saved with older versions of OpenMPT are still imported correctly.
- [Fix] <js> When loading multiple samples at once, existing samples are not overwritten anymore.
- [Fix] <js> When cleaning up samples, the sample spin button is now updated instantly.

Instrument tab
- [Imp] <js> Better default values for loop points are chosen when enabling envelope (sustain) loops.
- [Imp] <js> The sample mapping dialog accepts mouse dragging now.
- [Imp] <js> Zxx value for the selected cutoff value is now shown next to the cutoff frequency (http://bugs.openmpt.org/view.php?id=36).
- [Imp] <js> Filter settings and random variation sliders now have tooltips displaying the actual settings / swing variation.
- [Imp] <js> When replacing an existing instrument, the replacement / deletion of the previously assigned samples can now be undone.
- [Mod] <js> Two envelope points cannot share the same tick anymore in normal mode as well - since there is no interpolation happening between ticks anyway, this is no limitation at all.
- [Mod] <js> Loading an instrument will not put samples into slots referenced by other instruments, even if those slots are empty (http://bugs.openmpt.org/view.php?id=213).
- [Mod] <js> When assigning an instrument plugin, any sample associations are removed if they point to empty samples or if the user confirms the action.
- [Mod] <js> Allow MIDI banks up to 16384
- [Mod] <al> A newly added instrument is no longer assigned to an already existing but unreferenced sample.
- [Fix] <js> Instruments are now faded out properly when editing an XM module. This means that sustain points can now also be tested properly.
- [Fix] <js> Filter frequency display is now updated instantly when toggling the cutoff checkbox.
- [Fix] <js> Loading instruments from other modules is no longer limited to 32 samples.
- [Fix] <js> Fixed possible stack corruption when loading instruments into XM files.

Tree view
- [Imp] <js> The limit of 32 displayed song items has been removed.
- [Imp] <js> If available, drum keys use key names provided by the soundfont instead of pre-defined drum key names.
- [Imp] <js> All supported module files are now shown in the directory browser by default, even if "Show All Files" is disabled.
- [Fix] <js> Fixed mnemonic shortcuts in some context menus.

Mod Conversion
- [Imp] <js> When converting XM to S3M / IT and there is pxx and Cxx in the same event, the commands are swapped (instead of simply deleting the Cxx command).
